' Masakari.bas, written (6,675 lines) in QB64 by Kaze (sanmayce@sanmayce.com), 2024-Dec-26
' Masakari.bas, written (6,666 lines) in QB64 by Kaze (sanmayce@sanmayce.com), 2022-Feb-09
' Revised 2023-Apr-23, fixed missing "./" before the header names - due to QB v2.0.2 complains when MASAKARI is in its own folder; added to compile line "-O3 -ffast-math -msse4.2"
' Revised 2021-Jul-28, fixed double-clicks, fixes in combo handling; fixed report line length bug when (ExpandTabs was not dealing with the full size).
' Many thanks go to Galleon, also thanks go to the www.qb64.org/forum members for sharing useful excerpts/etudes

' For F10 is needed: Schizandrafield_Corpus_revision_D_(45-corpora_-unique-words).sorted.ind
' For F11 is needed: Dictionary_Specification_Language_(ABBYY_Software_House)_Oxford_English_Dictionary_2nd_Edition_Version_4_(En-En)_ANSI.dsl
' For F12 is needed: dict2txt_Online_Etymology_Dictionary1.1.txt

' Note #1: For wrapping set the flag 'WrapFlag = 1' or 'WrapFlag = 0' for vanilla.
' 'MASAKARI_General-Purpose_Grade_English_Wordlist.wrd' is the unigram i.e. wordlist to be used here.

Const RSHIFTkey& = 100303
Const LSHIFTkey& = 100304
Const RCTRLkey& = 100305
Const LCTRLkey& = 100306
Const RALTkey& = 100307
Const LALTkey& = 100308

Const BACKSPCkey& = 8
Const TABkey& = 9
Const SPACEkey& = 32
Const ESCkey& = 27
Const ENTERkey& = 13

Const HOMEkey& = 18176
Const ENDkey& = 20224

Const INSkey& = 20992
Const DELkey& = 21248

Const PGUPkey& = 18688
Const PGDNkey& = 20736

Const LEFTkey& = 19200
Const RIGHTkey& = 19712
Const UPkey& = 18432
Const DOWNkey& = 20480

Dim Shared ToLoadOrNotFlag As Integer ' Global flag, if 1 then load the entire file - use it to speed up parsing. Set to 0 if you want to load bigger files, slow it is.
Dim Shared WrapFlag As Integer

Dim Shared CursorS As Integer
Dim Shared CursorE As Integer

Dim Shared Schizandra$(1 To 45)
Schizandra$(1) = "AHD, American_Heritage_Dictionary_4_(En-En)_WHOLEWORDS.dsl                                                          "
Schizandra$(2) = "BNC, Machine-Learning_British-National-Corpus_XML-edition.tar                                                       "
Schizandra$(3) = "BRE, Britannica_Encyclopedia_2010_1.563_miled_(En-En)_ANSI.dsl                                                      "
Schizandra$(4) = "CAL, Cambridge_Advanced_Learner's_Dictionary_4th_Ed_(En-En).dsl                                                     "
Schizandra$(5) = "CCA, Collins_COBUILD_Advanced_Learner's_English_Dictionary_(5th_ed)_(En-En)_WHOLEWORDS.dsl                          "
Schizandra$(6) = "DMC, DeepMind_Q_and_A_Dataset_cnn_downloads_(92579_files).tar                                                       "
Schizandra$(7) = "DMD, DeepMind_Q_and_A_Dataset_dailymail_downloads_(219506_files).tar                                                "
Schizandra$(8) = "EDR, encyclopediadramaticase-20150628-current.tar                                                                   "
Schizandra$(9) = "EJD, Encyclopaedia_Judaica_(in_22_volumes)_TXT.tar                                                                  "
Schizandra$(10) = "EJN, ENAMDICT_Japanese_names                                                                                        "
Schizandra$(11) = "FDU, For_Dummies_978-ebooks_Collection.tar                                                                          "
Schizandra$(12) = "GGB, Google_Books_corpus_version_20130501_English_All_Nodes.txt                                                     "
Schizandra$(13) = "GNS, Genesis_Library_English / Genesis_Library_English_fiction (2,290,923 .TXT files)                               "
Schizandra$(14) = "HCN, Hacker_News_2006_to_2017-jul.json                                                                              "
Schizandra$(15) = "IST, INTERNET_SACRED_TEXT_ARCHIVE_DVD-ROM_9_(English_140479_htm_files).tar                                          "
Schizandra$(16) = "LDC, Longman_Dictionary_of_Contemporary_English_5th_Ed_(En-En)_WHOLEWORDS.dsl                                       "
Schizandra$(17) = "MCD, Macmillan_English_Dictionary_(En-En)_.dsl                                                                      "
Schizandra$(18) = "MCT, Macmillan_English_Thesaurus_(En-En).dsl                                                                        "
Schizandra$(19) = "NSO, New_Shorter_Oxford_English_Dictionary_fifth_edition.tar                                                        "
Schizandra$(20) = "OED, Oxford_English_Dictionary_2nd_Edition_Version_4_(En-En)_WHOLEWORDS.dsl.txt                                     "
Schizandra$(21) = "OSH, OSHO.TXT                                                                                                       "
Schizandra$(22) = "PGT, Project_Gutenberg_DVD-2010_(29180_files).tar                                                                   "
Schizandra$(23) = "RDD, Reddit_Comments_(JSON_objects)_from_(2005-12_to_2018-01).json                                                  "
Schizandra$(24) = "RHW, Random_House_Webster's_Unabridged_Dictionary_(En-En)_.dsl                                                      "
Schizandra$(25) = "SNT, Machine-Learning_WestburyLab.NonRedundant.UsenetCorpus_(47860_English_language_non-binary-file_news_groups).tar"
Schizandra$(26) = "STX, archive.org_stackexchange_(346_corpora_2017-Oct-12).tar                                                        "
Schizandra$(27) = "TAL, the-anarchist-library-2016-01-18-en_html.tar                                                                   "
Schizandra$(28) = "TXF, TEXTFILES.COM_(58096_files).tar                                                                                "
Schizandra$(29) = "URB, Machine-Learning_Urban_Dictionary_Definitions_Corpus_(1999_-_May-2016).words.json                              "
Schizandra$(30) = "WKD, dumps.wikimedia.org_Germany_dewiki-20180220-pages-articles.xml                                                 "
Schizandra$(31) = "WKE, dumps.wikimedia.org_English_enwiki-20180220-pages-articles.xml                                                 "
Schizandra$(32) = "WKF, dumps.wikimedia.org_France_frwiki-20180220-pages-articles.xml                                                  "
Schizandra$(33) = "WKI, dumps.wikimedia.org_Italy_itwiki-20180220-pages-articles.xml                                                   "
Schizandra$(34) = "WKN, dumps.wikimedia.org_Netherlands_nlwiki-20180220-pages-articles.xml                                             "
Schizandra$(35) = "WKP, dumps.wikimedia.org_Portugal_ptwiki-20180220-pages-articles.xml                                                "
Schizandra$(36) = "WKS, dumps.wikimedia.org_Spain_eswiki-20180220-pages-articles.xml                                                   "
Schizandra$(37) = "WMB, dumps.wikimedia.org_English_enwikibooks-20180220-pages-articles.xml                                            "
Schizandra$(38) = "WMN, dumps.wikimedia.org_English_enwikinews-20180220-pages-articles.xml                                             "
Schizandra$(39) = "WMP, dumps.wikimedia.org_English_specieswiki-20180220-pages-articles.xml                                            "
Schizandra$(40) = "WMQ, dumps.wikimedia.org_English_enwikiquote-20180220-pages-articles.xml                                            "
Schizandra$(41) = "WMS, dumps.wikimedia.org_English_enwikisource-20180220-pages-articles.xml                                           "
Schizandra$(42) = "WMU, dumps.wikimedia.org_English_enwikiversity-20180220-pages-articles.xml                                          "
Schizandra$(43) = "WMV, dumps.wikimedia.org_English_enwikivoyage-20180220-pages-articles.xml                                           "
Schizandra$(44) = "WMW, dumps.wikimedia.org_English_enwiktionary-20180220-pages-articles.xml                                           "
Schizandra$(45) = "WUD, Webster's_Unabridged_3_(En-En)_WHOLEWORDS_ANSI.dsl                                                             "

Dim Shared DCTNS$(1 To 23)
DCTNS$(1) = "   42,257,313 American_Heritage_Dictionary_4_(En-En)_UTF-8.dsl"
DCTNS$(2) = "  299,225,953 Britannica_Encyclopedia_2010_1.563_miled_(En-En)_ANSI.dsl"
DCTNS$(3) = "   75,122,799 Cambridge_Advanced_Learner's_Dictionary_4th_Ed_(En-En).dsl"
DCTNS$(4) = "   23,413,283 Collins_COBUILD_Advanced_Learner's_English_Dictionary_(5th_ed)_(En-En).dsl"
DCTNS$(5) = "   37,870,978 Longman_Activator_2nd_Ed_(En-En).dsl"
DCTNS$(6) = "   52,743,002 Longman_Dictionary_of_Contemporary_English_5th_Ed_(En-En).dsl"
DCTNS$(7) = "   83,412,925 Macmillan_English_Dictionary_(En-En)_UTF-8.dsl"
DCTNS$(8) = "   29,772,872 Macmillan_English_Thesaurus_(En-En)_UTF-8.dsl"
DCTNS$(9) = "  101,528,058 Merriam-Webster's_Collegiate_Dictionary_11th_Edition_(En-En).dsl"
DCTNS$(10) = "   57,854,694 Oxford_Advanced_Learner's_Dictionary_8th_Edition_(En-En).dsl"
DCTNS$(11) = "   44,362,425 Oxford_American_Dictionary_2nd_Edition.dsl"
DCTNS$(12) = "   11,747,238 Oxford_American_Thesaurus_(En-En).dsl"
DCTNS$(13) = "  559,408,265 Oxford_English_Dictionary_2nd_Edition_Version_4_(En-En)_ANSI.dsl"
DCTNS$(14) = "   53,483,030 Random_House_Webster's_Unabridged_Dictionary_(En-En)_UTF-8.dsl"
DCTNS$(15) = "   12,202,934 The_Collins_Cobuild_School_Dictionary_of_American_English_(En-En).dsl"
DCTNS$(16) = "  137,754,899 Webster's_Unabridged_3_(En-En)_UTF-8.dsl"
DCTNS$(17) = "    5,340,386 dict2txt_Online_Etymology_Dictionary1.1.txt"
DCTNS$(18) = "7,015,793,795 enwiktionary-20210920-pages-articles.xml"
DCTNS$(19) = "1,917,822,288 Machine-Learning_Urban_Dictionary_Definitions_Corpus_(1999_-_May-2016).words.json"
DCTNS$(20) = "  148,865,399 [French_-_French]_Emile_Littr_UTF-8.mdx.txt"
DCTNS$(21) = "  176,073,762 [French_-_French]_GrandRobert_UTF-8.mdx.txt"
DCTNS$(22) = "   97,807,080 [French_-_French]_Larousse_Multidico_UTF-8.mdx.txt"
DCTNS$(23) = "  282,443,452 [French_-_French]_PetitRobert2007_UTF-8.mdx.txt"

_Define A-Z As _INTEGER64

Mrev$ = "8.2+"

'Set compile-time codepaths:
'Vanilla (WRAPPERV = 0) or Wrapper (WRAPPERV = 1):
$Let WRAPPERV = 0
'Toshiba 8x16 (BIGORSMALL = 1) or NEC 6x12 (BIGORSMALL = 0):
$Let BIGORSMALL = 0

$If WRAPPERV = 0 Then
    WrapFlag = 0 ' 1 means wrapping; 0 means vanilla
$ElseIf WRAPPERV = 1 Then
        WrapFlag = 1 ' 1 means wrapping; 0 means vanilla
$Else
$End If

FONT4x = 0 '32px in 98x30
ToLoadOrNotFlag = 0 ' Should be 0; OLD: 1 means fast load but memory greedy; 0 means slow load but memory efficient

ShutDownDuration# = 4 ' 4 seconds
DclickTime# = 0.33 ' 1/3 of a second, usually it is 0.27s, so 0.33 suits even the slow clickers
Dim Button1LOG_firstDetection#(4)
Dim Button1LOG_ForHowLongHolded#(4)
Dim Button2LOG_firstDetection#(4)
Dim Button2LOG_ForHowLongHolded#(4)
PrevClick1# = 0
PrevClick2# = 0

Dim KeyTap_Button1LOG_firstDetection#(4)
Dim KeyTap_Button1LOG_ForHowLongHolded#(4)
Dim KeyTap_Button2LOG_firstDetection#(4)
Dim KeyTap_Button2LOG_ForHowLongHolded#(4)
Dim KeyTap_Button3LOG_firstDetection#(4)
Dim KeyTap_Button3LOG_ForHowLongHolded#(4)
Dim KeyTap_Button4LOG_firstDetection#(4)
Dim KeyTap_Button4LOG_ForHowLongHolded#(4)
Dim KeyTap_Button5LOG_firstDetection#(4)
Dim KeyTap_Button5LOG_ForHowLongHolded#(4)
Dim KeyTap_Button6LOG_firstDetection#(4)
Dim KeyTap_Button6LOG_ForHowLongHolded#(4)

KeyTap_PrevClick1# = 0
KeyTap_PrevClick2# = 0
KeyTap_PrevClick3# = 0
KeyTap_PrevClick4# = 0
KeyTap_PrevClick5# = 0
KeyTap_PrevClick6# = 0

_ControlChr Off 'without it couldn't _MAPUNICODE these 7, 9..13, 28..31

If InStr(LCase$(Command$), "/help") Or InStr(LCase$(Command$), "-h") Then
    $ScreenHide
    $Console
    _Console On
    _ConsoleTitle "Masakari console window"
    _Dest _Console

    ShowASCIIart

    ' _____
    '|  _  |
    '| |/' |
    '|  /| |
    '\ |_/ /
    ' \___/
    '  __
    ' /  |
    '/_/ |
    '  | |
    '__| |__
    '\_____/
    ' _____
    '/ __  \
    '`' / /'
    '  / /
    './ /___
    '\_____/
    ' _____
    '|____ |
    '    / /
    '    \ \
    '.___/ /
    '\____/
    '   ___
    '  /   |
    ' / /| |
    '/ /_| |
    '\___  |
    '    |_/
    ' _____
    '|  ___|
    '|___ \
    '    \ \
    '/\__/ /
    '\____/
    '  ____
    ' / ___|
    '/ /___
    '| ___ \
    '| \_/ |
    '\_____/
    ' ______
    '|___  /
    '   / /
    '  / /
    './ /
    '\_/
    ' _____
    '|  _  |
    ' \ V /
    ' / _ \
    '| |_| |
    '\_____/
    ' _____
    '|  _  |
    '| |_| |
    '\____ |
    '.___/ /
    '\____/

    '   _
    '  (_)

    '   _
    '  (_)
    '                     _             _                  __
    '   _                | |           | |                / /
    ' _| |_  ______      | |__   _   _ | |_  ___  ___    / /___
    '|_   _||______|     | '_ \ | | | || __|/ _ \/ __|  / // __|
    '  |_|            _  | |_) || |_| || |_|  __/\__ \ / / \__ \
    '                ( ) |_.__/  \__, | \__|\___||___//_/  |___/
    '                |/           __/ |
    '                            |___/

    ' _   _              _____
    '| \ | | _   _   ___|_   _|___  _ __    __ _  _   _
    '|  \| || | | | / _ \ | | / _ \| '_ \  / _` || | | |
    '| |\  || |_| || (_) || ||  __/| | | || (_| || |_| |
    '|_| \_| \__, | \___/ |_| \___||_| |_| \__, | \__,_|
    '        |___/                         |___/

    ' _                 _______ _________ _______  _        _______
    '( (    /||\     /|(  ___  )\__   __/(  ____ \( (    /|(  ____ \|\     /|
    '|  \  ( |( \   / )| (   ) |   ) (   | (    \/|  \  ( || (    \/| )   ( |
    '|   \ | | \ (_) / | |   | |   | |   | (__    |   \ | || |      | |   | |
    '| (\ \) |  \   /  | |   | |   | |   |  __)   | (\ \) || | ____ | |   | |
    '| | \   |   ) (   | |   | |   | |   | (      | | \   || | \_  )| |   | |
    '| )  \  |   | |   | (___) |   | |   | (____/\| )  \  || (___) || (___) |
    '|/    )_)   \_/   (_______)   )_(   (_______/|/    )_)(_______)(_______)

    ShowF1
    System
Else
    _ScreenShow ' Why so?!
    $Console
    _Console Off
    _Title "MASAKARI, revision " + Mrev$
    $If WRAPPERV = 0 Then
        $If BIGORSMALL = 1 Then
                $ExeIcon:'./ColumnChart.ico'
        $Else
            $ExeIcon:'./ColumnChart_NEC.ico'
        $End If
    $ElseIf WRAPPERV = 1 Then
            $EXEICON:'./ColumnChart_wrap.ico'
    $End If
    _Icon
End If

'_DEFINE A-Z AS _INTEGER64 'commented and moved up since the above defined 'FONT4x = 1' was seen as 0 below?!

$If WINDOWS Then
        Declare Library "mem"
        Function MemInUsePercent~&&
        Function TotalPhysicalMem~&&
        Function FreePhysicalMem~&&
        Function TotalPagingFile~&&
        Function FreePagingFile~&&
        Function TotalVirtualMem~&&
        Function FreeVirtualMem~&&
        Function FreeExtendedMem~&&
        Function GetCPULoad#
        End Declare
$End If

Rem https://www.qb64.org/forum/index.php?topic=4307.msg137147#msg137147
'Dim Shared memstat As MEMORYSTATUSEX
'Dim Shared Result As _Integer64
'Type MEMORYSTATUSEX
'    dwLength As Long
'    dwMemoryLoad As Long
'    ullTotalPhys As _Unsigned _Integer64
'    ullAvailPhys As _Unsigned _Integer64
'    ullTotalPageFile As _Unsigned _Integer64
'    ullAvailPageFile As _Unsigned _Integer64
'    ullTotalVirtual As _Unsigned _Integer64
'    ullAvailVirtual As _Unsigned _Integer64
'    ullAvailExtendedVirtual As _Unsigned _Integer64
'End Type
'Declare CustomType Library 'Memory Information using KERNEL32
'    Function GlobalMemoryStatusEx& (Mstat As MEMORYSTATUSEX)
'End Declare
'GoSub Free_MEM:
'End
'Free_MEM:
'memstat.dwLength = Len(memstat): Result = GlobalMemoryStatusEx&(memstat)
'Free_MEM& = memstat.ullAvailPhys: Print "freeMEM= ";: Print Using "###,###,###,###"; memstat.ullAvailPhys;: Print " bytes";
'Return

Declare CustomType Library "./qsm" ' Notice that 'CustomType' makes things work, using 'STATIC' gives errors during compilation
    Sub Quicksort_QB64_v7 (ByVal QWORDS As _Offset, Byval Left As _Integer64, Byval Right As _Integer64)
End Declare

Declare CustomType Library "./qsm_linesize" ' Notice that 'CustomType' makes things work, using 'STATIC' gives errors during compilation
    Sub Quicksort_QB64_v7_linesize (ByVal QWORDSoff As _Offset, Byval QWORDSlen As _Offset, Byval Left As _Integer64, Byval Right As _Integer64)
End Declare
'Quicksort_QB64_v7_linesize MhandleOFF.OFFSET, MhandleLEN.OFFSET, 0, ElementsMinusOne

'Declare CustomType Library
'    Sub memcpy (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
'    Function memcmp% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
'End Declare
'a$ = "1234567890"
'b$ = "ABCDEFGHIJ"
'memcpy _Offset(a$) + 5, _Offset(b$) + 5, 5
'Print: Print a$: Print b$
'SignedInt% = memcmp%(_Offset(a$), _Offset(b$), 5) ' 1 vs A returns -1
'Print Mid$(a$, 1, 1); " vs "; Mid$(b$, 1, 1); " returns "; SignedInt%
'SignedInt% = memcmp%(_Offset(b$), _Offset(a$), 5) ' A vs 1 returns 1
'Print Mid$(b$, 1, 1); " vs "; Mid$(a$, 1, 1); " returns "; SignedInt%
'SignedInt% = memcmp%(_Offset(a$) + 5, _Offset(b$) + 5, 5) ' F vs F returns 0
'Print Mid$(a$, 1 + 5, 1); " vs "; Mid$(b$, 1 + 5, 1); " returns "; SignedInt%

'On Linux, the compile line should be expanded from:
'qb64\internal\c\makeline_lnx.txt:
'g++ -no-pie -w qbx.cpp parts/core/os/lnx/src.a -lGL -lGLU -lX11 -lpthread -ldl -lrt -D FREEGLUT_STATIC -o
'to:
'g++ -O3 -mavx2 -maes -no-pie -w qbx.cpp parts/core/os/lnx/src.a -lGL -lGLU -lX11 -lpthread -ldl -lrt -D FREEGLUT_STATIC -o

'// manatarka.h:
'// In order to compile properly, edit the next line from E:\qb64\internal\temp\recompile_win.bat:
'// c_compiler\bin\g++ -s -Wfatal-errors ...
'// Insert "-O3 -msse4.1 -maes", or even better "-O3 -mavx2 -maes" for YMM variants, so:
'// c_compiler\bin\g++ -O3 -mavx2 -maes -s -Wfatal-errors ...

'Declare CustomType Library
'    Sub memcpy (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
'    Function memcmp% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
'End Declare
'a$ = "1234567890"
'b$ = "ABCDEFGHIJ"
'memcpy _Offset(a$) + 5, _Offset(b$) + 5, 5
'Print: Print a$: Print b$
'SignedInt% = memcmp%(_Offset(a$), _Offset(b$), 5) ' 1 vs A returns -1
'Print Mid$(a$, 1, 1); " vs "; Mid$(b$, 1, 1); " returns "; SignedInt%
'SignedInt% = memcmp%(_Offset(b$), _Offset(a$), 5) ' A vs 1 returns 1
'Print Mid$(b$, 1, 1); " vs "; Mid$(a$, 1, 1); " returns "; SignedInt%
'SignedInt% = memcmp%(_Offset(a$) + 5, _Offset(b$) + 5, 5) ' F vs F returns 0
'Print Mid$(a$, 1 + 5, 1); " vs "; Mid$(b$, 1 + 5, 1); " returns "; SignedInt%

'Declare CustomType Library "manatarka"
'    Sub UCASE_XMM (ByVal QWORDSsrc As _Offset, Byval QWORDSdst As _Offset, Byval bytesto As _Integer64)
'    Sub UCASE_XMM_inplace (ByVal QWORDSsrc As _Offset, Byval bytesto As _Integer64)
'    Function Railgun_Doublet%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of LONG
'    Function Railgun_Trolldom_64%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of _Integer64
'    Function Railgun_Nyotengu_XMM_YMM_ZMM%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of _Integer64
'    'char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
'    'char * Railgun_Trolldom_64 (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern)
'    'char * Railgun_Nyotengu_XMM_YMM_ZMM (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern) // Last change: 2020-Nov-30
'    Sub DoubleDeuceAES_Gumbotron (ByVal buffer As _Offset, Byval bytesto As _Integer64, Byval LoPart As _Offset, Byval HiPart As _Offset) 'Note: This hasher uses AES extension, the CPU has to support it!
'    Sub DoubleDeuceAES_Gumbotron_YMM (ByVal buffer As _Offset, Byval bytesto As _Integer64, Byval LoPart As _Offset, Byval HiPart As _Offset) 'Note: This hasher uses AES extension, the CPU has to support it!
'    'void DoubleDeuceAES_Gumbotron (const uint8_t *buffer, size_t length, uint64_t *LoPart, uint64_t *HiPart) {
'End Declare

Declare CustomType Library "./memKAZE"
    Sub memcpyKAZE (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
    Function memcmpKAZE% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
End Declare

' CAUTION: With next 4 lines, all is OK ... under Windows only, for some reason on Linux it works sometime, sometime not?!
'Declare CustomType Library
'    Sub memcpy (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
'    Function memcmp% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
'End Declare


' Examples [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
'DoubleDeuceAES_Gumbotron_YMM _Offset(TestKey$), Len(TestKey$), _Offset(LoPart), _Offset(HiPart)

'MhandleXMM = _MemNew(LinesTestLookups + 8&& * (LinesTestLookups * 2)) ' BYTE+QWORD+QWORD=17
'ts# = Timer(.001)
'LinesTestLookupsUploading = 0
'For i = 1 To LinesTestLookups
'    DoubleDeuceAES_Gumbotron_YMM _Offset(NoNeedOfArrayButForBench$(i)), Len(NoNeedOfArrayButForBench$(i)), _Offset(LoPart), _Offset(HiPart)
'    KeyLen = Len(NoNeedOfArrayButForBench$(i))
'    If KeyLen >= 256 Then KeyLen = 0
'    memcpy MhandleXMM.OFFSET + (LinesTestLookupsUploading + 8&& * (LinesTestLookupsUploading * 2)) + 0, _Offset(KeyLen), 1
'    _MemPut MhandleXMM, MhandleXMM.OFFSET + (LinesTestLookupsUploading + 8&& * (LinesTestLookupsUploading * 2)) + 1, LoPart
'    _MemPut MhandleXMM, MhandleXMM.OFFSET + (LinesTestLookupsUploading + 8&& * (LinesTestLookupsUploading * 2)) + 1 + 8, HiPart
'    LinesTestLookupsUploading = LinesTestLookupsUploading + 1
'Next
'te# = Timer(.001)

'For i = 1 To LinesTestLookups
'    memcpy _Offset(KeyLen), MhandleXMM.OFFSET + ((i - 1) + 8&& * ((i - 1) * 2)) + 0, 1
'    _MemGet MhandleXMM, MhandleXMM.OFFSET + ((i - 1) + 8&& * ((i - 1) * 2)) + 1, LoPart
'    _MemGet MhandleXMM, MhandleXMM.OFFSET + ((i - 1) + 8&& * ((i - 1) * 2)) + 1 + 8, HiPart
'Next

'Hits = 0
'FoundAt = 1
'Do
'    FoundAt = InStr(FoundAt, Haystack$, Needle$)
'    If FoundAt = 0 Then Exit Do Else FoundAt = FoundAt + 1: Hits = Hits + 1
'Loop

'Hits = 0
'HaystackLEN%& = Len(Haystack$) 'The workaround of lacking casting
'NeedleLEN = Len(Needle$)
'PointerHQB64%& = _Offset(Haystack$) 'Dim PointerHQB64 As _Offset
'PointerNQB64%& = _Offset(Needle$) 'Dim PointerNQB64 As _Offset
'FoundAt%& = PointerHQB64%&
'Do
'    FoundAtNew%& = Railgun_Trolldom_64%&(FoundAt%&, PointerNQB64%&, HaystackLEN%& - (FoundAt%& - PointerHQB64%&), NeedleLEN)
'    If FoundAtNew%& = 0 Then Exit Do
'    FoundAt%& = FoundAtNew%& + 1: Hits = Hits + 1
'Loop

'Hits = 0
'HaystackLEN%& = Len(Haystack$) 'The workaround of lacking casting
'NeedleLEN = Len(Needle$)
'PointerHQB64%& = _Offset(Haystack$) 'Dim PointerHQB64 As _Offset
'PointerNQB64%& = _Offset(Needle$) 'Dim PointerNQB64 As _Offset
'FoundAt%& = PointerHQB64%&
'Do
'    FoundAtNew%& = Railgun_Nyotengu_XMM_YMM_ZMM%&(FoundAt%&, PointerNQB64%&, HaystackLEN%& - (FoundAt%& - PointerHQB64%&), NeedleLEN)
'    If FoundAtNew%& = 0 Then Exit Do
'    FoundAt%& = FoundAtNew%& + 1: Hits = Hits + 1
'Loop

'FuleBufPadded$ = FuleBuf$ + Space$(FileLen Mod 16)
'GalfoniadaVECTOR$ = FuleBuf$ + Space$(FileLen Mod 16)
'UCASE_XMM _Offset(FuleBufPadded$), _Offset(GalfoniadaVECTOR$), Len(FuleBufPadded$) 'make in-lpace version - overwriting the source
'UCASE_XMM_inplace _Offset(FuleBufPadded$), Len(FuleBufPadded$)
' Examples ]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

Dim Shared Mwholefile As _MEM
Dim Shared MhandleOFF As _MEM
Dim Shared MhandleLEN As _MEM 'paired with above one, added for speed, no need to search for the length at offset 'MhandleOFF'

Dim QWORD As _Unsigned _Integer64
'DIM SHARED Byte AS STRING * 1 'not used since r.7
Dim PrevByte As String * 1
Dim LastByte As String * 1

FULLscr_Flag = 0
_AllowFullScreen _Stretch , _Smooth 'allow Alt+Enter, notice it has to be here before the screen/font stuff below, otherwise it enters all 4 modes back to back.

_ScreenMove 102, 3
XdimCOL = 128
YdimROW = 40 ' ensure old laptops with 768pixels vertical will hold the whole window
wide& = _DesktopWidth
high& = _DesktopHeight
If high& > 1000 Then YdimROW = 60
If wide& >= 1920 Then XdimCOL = 213 '192
YdimROW = 40 'debug, test the Search Panel; also strive for the crisp FullScreen

'Take heed, in order to have undistorted font shapes, adhere to the ratio of the hardware video mode i.e. _DesktopWidth\_DesktopHeight; the counterpart in question is XdimCOL\YdimROW
'"In order to have clean/undistorted font shape, _DesktopWidth\_DesktopHeight = " + LTrim$(Str$(_DesktopWidth)) + "/" + LTrim$(Str$(_DesktopHeight)) + " = " + Left$(LTrim$(Str$(_DesktopWidth / _DesktopHeight)), 4)
'"should be as near as possible (or multiple of) to XdimCOL\YdimROW = " + LTrim$(Str$(XdimCOL)) + "/" + LTrim$(Str$(YdimROW)) + " = " + Left$(LTrim$(Str$(XdimCOL / YdimROW)), 4)
'Examples:
'128x40 is superb for 1680/1050=1.6 since 128/40=2x(40x1.6) i.e. multiple of 1.6 i.e. 3.2
'192x60 is superb for 1920/1200=1.6 since 192/60=2x(60x1.6) i.e. multiple of 1.6 i.e. 3.2
'213x60 is MEH for 1920/1080=~1.77 since 213/60~=2x(60x~1.77) i.e. multiple of ~1.77 i.e. ~3.55

If XdimCOL = 128 And YdimROW = 40 Then _Title "MASAKARI, revision " + Mrev$ + " 128x40, The 'Holy Axe' English Text Sidekick"
If XdimCOL = 128 And YdimROW = 60 Then _Title "MASAKARI, revision " + Mrev$ + " 128x60, The 'Holy Axe' English Text Sidekick"
If XdimCOL = 213 And YdimROW = 60 Then _Title "MASAKARI, revision " + Mrev$ + " 213x60, The 'Holy Axe' English Text Sidekick"

Mode4K = 0 'Make it 1 or 0, if 1 then 16 becomes 32 i.e. the font is 4x bigger: 8x16 becomes 16x32
If wide& >= 1920 * 2 Then Mode4K = 1

If FONT4x = 1 Then
    XdimCOL = 112
    YdimROW = 30 ' ensure old laptops with 768pixels vertical will hold the whole window
    If XdimCOL = 112 And YdimROW = 30 Then _Title "MASAKARI, revision " + Mrev$ + " 112x30, The 'Holy Axe' English Text Sidekick"
End If

'Mode4K = 1: YdimROW = YdimROW \ 2: XdimCOL = 96 'debug; Enforcing 32px on 1680 or FHD is good, however status line should be shrunk, also Search Panel need 40lines not 30!

ASCIIFrame = 0
ASCIIFramePEN = 0

'EpochStepping.bas
FramesPerSecond = 500
LastHit~&& = EpochTime~&& 'assume the start point is at 100%
Stepping = 10 '0..10 where 10 is 100%, 9 is 90%

$If WIN Then
        Const Slash = "\"
$Else
    Const Slash = "/"
$End If

$If WINDOWS Then
        PSPlike$ = _CWD$ + "\"
$Else
    PSPlike$ = _CWD$ + "/"
$End If

'Note1: If the Toshiba (MxPlus_ToshibaTxL2_8x16.ttf) font is not in the starting folder then JPN 6x12 (Px437_DOS-V_re_JPN12.ttf) is loaded instead (if not 4K). On old laptops e.g. 1366x768 it can show the "standard 128x60".
'Note2: Trying to enforce the maximum, if (4K is 0) and (Toshiba is missing):
$If BIGORSMALL = 1 Then
        If _FileExists(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf") = 0 Then
        If Mode4K = 0 Then
        If wide& >= 1920 Then
        XdimCOL = 300 ' 300x6< (FHDx=1920)
        YdimROW = 80 ' 80x12< (FHDy=1080)
        _Title "MASAKARI, revision " + Mrev$ + " 300x80, The 'Holy Axe' English Text Sidekick"
        End If
        End If
        End If
$Else
    'IF _FILEEXISTS(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf") = 0 THEN
    If Mode4K = 0 Then
        If wide& >= 1920 Then
            XdimCOL = 300 ' 300x6< (FHDx=1920)
            YdimROW = 80 ' 80x12< (FHDy=1080)
            _Title "MASAKARI, revision " + Mrev$ + " 300x80, The 'Holy Axe' English Text Sidekick"
        End If
    End If
    'END IF
$End If

'' SOUND PLAYER [
''s& = _SNDOPEN(PSPlike$+"music_zapsplat_rapid_turnaround.mp3")
's& = _SNDOPEN(PSPlike$+"music_pioxonaq_agressive_lightning.mp3")
'IF s& <> 0 THEN
'    _SNDPLAY s& 'check for valid handle before using!
'    'The _SNDLOOP statement is like _SNDPLAY but the sound is looped. Uses a handle from the _SNDOPEN function.
'    'Example 1: Playing a previously opened sound at half volume.
'    '_SNDPLAYCOPY applause&, 0.5
'    volumeINT% = 9 '10 means 100% means 1.0, down to 0 i.e. 0..10 or 0,0.1,...1.0
'    StopFlag = 0
'    DO
'        k$ = INKEY$
'        SELECT CASE k$
'            CASE "n"
'                IF volumeINT% >= 1 THEN volumeINT% = volumeINT% - 1
'                _SNDVOL s&, volumeINT% / 10
'            CASE "m"
'                IF volumeINT% <= 8 THEN volumeINT% = volumeINT% + 1 ' don't go 100% but up to 90%
'                _SNDVOL s&, volumeINT% / 10
'            CASE "p"
'                _SNDPAUSE s&
'            CASE " "
'                _SNDPLAY s&
'            CASE CHR$(27)
'                _SNDSTOP s&
'                _SNDCLOSE s&
'                StopFlag = 1
'        END SELECT
'        LOCATE 1, 1
'        IF StopFlag = 0 THEN PRINT "Volume:"; volumeINT%; "; Position:"; INT(_SNDGETPOS(s&)); "second, up to"; INT(_SNDLEN(s&))
'    LOOP UNTIL StopFlag
'END IF
'' SOUND PLAYER ]

'spell [
Dim lfixed As String * 32
TotalWrd& = 0
Open PSPlike$ + "masakari.ind" For Binary As #2
If LOF(2) Then
    TotalWrd& = LOF(2) / 32
    Close #2
Else
    Close #2
    Kill PSPlike$ + "masakari.ind"
    Open PSPlike$ + "masakari.wrd" For Binary As #2
    If LOF(2) Then
        Close #2
        Open PSPlike$ + "masakari.wrd" For Input As #1
        Open PSPlike$ + "masakari.ind" For Random Access Write As #2 Len = 32
        Do While Not EOF(1)
            Line Input #1, l$
            lfixed$ = l$
            Put #2, , lfixed$: TotalWrd& = TotalWrd& + 1
            FL2wrd& = 1
        Loop
        Close #1, #2
    Else
        Close #2
        Kill PSPlike$ + "masakari.wrd"
    End If
End If
'spell ]

If InStr(LCase$(Command$), "/ascii") Or InStr(LCase$(Command$), "-ascii") Then
Else
    GoTo SkipFontReviews
End If
'SCREEN 0 'It is better to define your own mode, as:
handle& = _NewImage(98, 30, 0)
Screen handle&
_Dest handle&

'_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 32, "MONOSPACE")
'_FONT _LOADFONT("C:\windows\fonts\lucon.ttf", 32, "MONOSPACE")
'_FONT _LOADFONT("C:\windows\fonts\MxPlus_Cordata_PPC-400.ttf", 32, "MONOSPACE")
'_FONT _LOADFONT("C:\windows\fonts\MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE")
_Font _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE")

'RESTORE Microsoft_pc_cp437 'United States MS DOS
'RESTORE Microsoft_windows_cp1250 'WINDOWS in Central European and Eastern European languages that use Latin script, such as Polish, Czech, Slovak, Hungarian, Slovene, Bosnian, Croatian, Serbian (Latin script), Romanian and Albanian. It may also be used with the German language.
'RESTORE Microsoft_windows_cp1251 'Cyrillic alphabet such as Russian, Bulgarian, Serbian Cyrillic and other languages. It is the most widely used for encoding the Bulgarian, Serbian and Macedonian languages.
'RESTORE Microsoft_pc_cpMIK 'Cyrillic Bulgarian Pravetz 16 for MS-DOS
Color 4
If InStr(LCase$(Command$), "/ascii_gesch") Or InStr(LCase$(Command$), "-ascii_gesch") Then
    Restore Microsoft_pc_cpGESCH 'My codepage a.k.a. Gesch
    Print "Showing GRAPHEMES of Gesch (a.k.a. Schpitz) codepage,": Print "it allows browsing German/Italian/French/Spanish/Bulgarian (and its dialect Russian :P):"
Else
    Restore Microsoft_windows_cp1252
    Print "Showing GRAPHEMES of cp1252 codepage - Windows Western languages with Latin alphabet,":
    Print "it allows browsing... ugh, it sucks:"
End If

If InStr(LCase$(Command$), "/ascii_gesch") Or InStr(LCase$(Command$), "-ascii_gesch") Then
    For ASCIIcode = 0 To 6 'German A:a:O:o:U:u: ss
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 7 To 7 'Integral high
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 8 To 8 'Integral low
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 14 To 15 'French C,c,
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 16 To 27 'French/Italian E'e' A`a`E`e`I`i`O`o`U`u`
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    'why 28..31 are not available?!
    For ASCIIcode = 128 To 255
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 220 To 223 ' the unnecessary 4 bold drawing chars are replaced with French AE ae I: i:
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 127 To 127 'almost equal to
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 181 To 190 'Cyrillic short vowels
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 198 To 207 'Cyrillic short vowels
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 208 To 216 'misc, Spanish
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 28 To 31 'draw animated block
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 11 To 12 'draw animated block
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
End If

toggleCyanPurpleWhite = 3
Color toggleCyanPurpleWhite
If cnt Mod 16 = 0 Then Print: Print String$(3 - Len(LTrim$(Str$(cnt))), "0") + LTrim$(Str$(cnt)); " ";
For i = 0 To 255
    'IF i <> 11 AND i <> 12 AND i <> 9 AND i <> 7 AND i <> 13 AND i <> 10 THEN
    Print Chr$(i) + " ";
    'ELSE
    'PRINT "  ";
    'END IF
    cnt = cnt + 1
    If (cnt <= 255) And (cnt Mod 16 = 0) Then
        If toggleCyanPurpleWhite = 3 Then
            toggleCyanPurpleWhite = 7
        ElseIf toggleCyanPurpleWhite = 7 Then
            toggleCyanPurpleWhite = 9
        Else
            toggleCyanPurpleWhite = 3
        End If
        Color toggleCyanPurpleWhite
        Print: Print String$(3 - Len(LTrim$(Str$(cnt))), "0") + LTrim$(Str$(cnt)); " ";
    End If
Next
Color 4
If InStr(LCase$(Command$), "/ascii_gesch") Or InStr(LCase$(Command$), "-ascii_gesch") Then
    Print: Print: Print "Example (forming a long integral from 209 179 210): ": Print Chr$(209); " Useful for": Print Chr$(179); " making paragraphs": Print Chr$(210); " of your own."
Else
    Print: Print: Print "Example (forming a long integral from 244 179 245): ": Print Chr$(244); " Useful for": Print Chr$(179); " making paragraphs": Print Chr$(245); " of your own."
End If
Color 7
End

Microsoft_pc_cp737: 'Greek MS DOS displays Greek alphabet for algebraic formulas.
Data 913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928
Data 929,931,932,933,934,935,936,937,945,946,947,948,949,950,951,952
Data 953,954,955,956,957,958,959,960,961,963,962,964,965,966,967,968
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 969,940,941,942,970,943,972,973,971,974,902,904,905,906,908,910
Data 911,177,8805,8804,938,939,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp775: 'Estonian, Lithuanian and Latvian languages.
Data 262,252,233,257,228,291,229,263,322,275,342,343,299,377,196,197
Data 201,230,198,333,246,290,162,346,347,214,220,248,163,216,215,164
Data 256,298,243,379,380,378,8221,166,169,174,172,189,188,321,171,187
Data 9617,9618,9619,9474,9508,260,268,280,278,9571,9553,9559,9565,302,352,9488
Data 9492,9524,9516,9500,9472,9532,370,362,9562,9556,9577,9574,9568,9552,9580,381
Data 261,269,281,279,303,353,371,363,382,9496,9484,9608,9604,9612,9616,9600
Data 211,223,332,323,245,213,181,324,310,311,315,316,326,274,325,8217
Data 173,177,8220,190,182,167,247,8222,176,8729,183,185,179,178,9632,160

Microsoft_pc_cp850: 'Western Europe, Spain, England
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197
Data 201,230,198,244,246,242,251,249,255,214,220,248,163,216,215,402
Data 225,237,243,250,241,209,170,186,191,174,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,193,194,192,169,9571,9553,9559,9565,162,165,9488
Data 9492,9524,9516,9500,9472,9532,227,195,9562,9556,9577,9574,9568,9552,9580,164
Data 240,208,202,203,200,305,205,206,207,9496,9484,9608,9604,166,204,9600
Data 211,223,212,210,245,213,181,254,222,218,219,217,253,221,175,180
Data 173,177,8215,190,182,167,247,184,176,168,183,185,179,178,9632,160

Microsoft_pc_cp852: 'Central European languages that use Latin script such as Bosnian, Croatian, Czech, Hungarian, Polish, Romanian, Serbian or Slovak.
Data 199,252,233,226,228,367,263,231,322,235,336,337,238,377,196,262
Data 201,313,314,244,246,317,318,346,347,214,220,356,357,321,215,269
Data 225,237,243,250,260,261,381,382,280,281,172,378,268,351,171,187
Data 9617,9618,9619,9474,9508,193,194,282,350,9571,9553,9559,9565,379,380,9488
Data 9492,9524,9516,9500,9472,9532,258,259,9562,9556,9577,9574,9568,9552,9580,164
Data 273,272,270,203,271,327,205,206,283,9496,9484,9608,9604,354,366,9600
Data 211,223,212,323,324,328,352,353,340,218,341,368,253,221,355,180
Data 173,733,731,711,728,167,247,184,176,168,729,369,344,345,9632,160

Microsoft_pc_cp855: 'Cyrillic code page to be used under MS-DOS
Data 1106,1026,1107,1027,1105,1025,1108,1028,1109,1029,1110,1030,1111,1031,1112,1032
Data 1113,1033,1114,1034,1115,1035,1116,1036,1118,1038,1119,1039,1102,1070,1098,1066
Data 1072,1040,1073,1041,1094,1062,1076,1044,1077,1045,1092,1060,1075,1043,171,187
Data 9617,9618,9619,9474,9508,1093,1061,1080,1048,9571,9553,9559,9565,1081,1049,9488
Data 9492,9524,9516,9500,9472,9532,1082,1050,9562,9556,9577,9574,9568,9552,9580,164
Data 1083,1051,1084,1052,1085,1053,1086,1054,1087,9496,9484,9608,9604,1055,1103,9600
Data 1071,1088,1056,1089,1057,1090,1058,1091,1059,1078,1046,1074,1042,1100,1068,8470
Data 173,1099,1067,1079,1047,1096,1064,1101,1069,1097,1065,1095,1063,167,9632,160

Microsoft_pc_cp857: 'Turkish MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,305,196,197
Data 201,230,198,244,246,242,251,249,304,214,220,248,163,216,350,351
Data 225,237,243,250,241,209,286,287,191,174,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,193,194,192,169,9571,9553,9559,9565,162,165,9488
Data 9492,9524,9516,9500,9472,9532,227,195,9562,9556,9577,9574,9568,9552,9580,164
Data 186,170,202,203,200,0,205,206,207,9496,9484,9608,9604,166,204,9600
Data 211,223,212,210,245,213,181,0,215,218,219,217,236,255,175,180
Data 173,177,0,190,182,167,247,184,176,168,183,185,179,178,9632,160

Microsoft_pc_cp860: 'Portuguese language. MS DOS
Data 199,252,233,226,227,224,193,231,234,202,232,205,212,236,195,194
Data 201,192,200,244,245,242,218,249,204,213,220,162,163,217,8359,211
Data 225,237,243,250,241,209,170,186,191,210,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp861: 'Icelandic language (as well as other Nordic languages). MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,208,240,222,196,197
Data 201,230,198,244,246,254,251,221,253,214,220,248,163,216,8359,402
Data 225,237,243,250,193,205,211,218,191,8976,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp862: 'Hebrew letters in positions 809A hex, but otherwise it is identical to CP437. Now obsolete, see CP1255
Data 1488,1489,1490,1491,1492,1493,1494,1495,1496,1497,1498,1499,1500,1501,1502,1503
Data 1504,1505,1506,1507,1508,1509,1510,1511,1512,1513,1514,162,163,165,8359,402
Data 225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp863: 'French language (mainly in Canada). MS DOS
Data 199,252,233,226,194,224,182,231,234,235,232,239,238,8215,192,167
Data 201,200,202,244,203,207,251,249,164,212,220,162,163,217,219,402
Data 166,180,243,250,168,184,179,175,206,8976,172,189,188,190,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp864: 'Arabic MS DOS
Data 176,183,8729,8730,9618,9472,9474,9532,9508,9516,9500,9524,9488,9484,9492,9496
Data 946,8734,966,177,189,188,8776,171,187,65271,65272,0,0,65275,65276,0
Data 160,173,65154,163,164,65156,0,0,65166,65167,65173,65177,1548,65181,65185,65189
Data 1632,1633,1634,1635,1636,1637,1638,1639,1640,1641,65233,1563,65201,65205,65209,1567
Data 162,65152,65153,65155,65157,65226,65163,65165,65169,65171,65175,65179,65183,65187,65191,65193
Data 65195,65197,65199,65203,65207,65211,65215,65217,65221,65227,65231,166,172,247,215,65225
Data 1600,65235,65239,65243,65247,65251,65255,65259,65261,65263,65267,65213,65228,65230,65229,65249
Data 65149,1617,65253,65257,65260,65264,65266,65232,65237,65269,65270,65245,65241,65265,9632,0

Microsoft_pc_cp865: 'Nordic languages (except Icelandic, for which CP861 is used). MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197
Data 201,230,198,244,246,242,251,249,255,214,220,248,163,216,8359,402
Data 225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171,164
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp866: 'Cyrillic alphabetical order code page to be used with MS-DOS
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103
Data 1025,1105,1028,1108,1031,1111,1038,1118,176,8729,183,8730,8470,164,9632,160

Microsoft_pc_cp869: 'Greek MS DOS. Less popular than Code page 737
Data 0,0,0,0,0,0,902,0,183,172,166,8216,8217,904,8213,905
Data 906,938,908,0,0,910,939,169,911,178,179,940,163,941,942,943
Data 970,912,972,973,913,914,915,916,917,918,919,189,920,921,171,187
Data 9617,9618,9619,9474,9508,922,923,924,925,9571,9553,9559,9565,926,927,9488
Data 9492,9524,9516,9500,9472,9532,928,929,9562,9556,9577,9574,9568,9552,9580,931
Data 932,933,934,935,936,937,945,946,947,9496,9484,9608,9604,948,949,9600
Data 950,951,952,953,954,955,956,957,958,959,960,961,963,962,964,900
Data 173,177,965,966,967,167,968,901,176,168,969,971,944,974,9632,160

Microsoft_pc_cp874: 'Thai MS DOS and Windows
Data 8364,0,0,0,0,8230,0,0,0,0,0,0,0,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,0,0,0,0,0,0,0,0
Data 160,3585,3586,3587,3588,3589,3590,3591,3592,3593,3594,3595,3596,3597,3598,3599
Data 3600,3601,3602,3603,3604,3605,3606,3607,3608,3609,3610,3611,3612,3613,3614,3615
Data 3616,3617,3618,3619,3620,3621,3622,3623,3624,3625,3626,3627,3628,3629,3630,3631
Data 3632,3633,3634,3635,3636,3637,3638,3639,3640,3641,3642,0,0,0,0,3647
Data 3648,3649,3650,3651,3652,3653,3654,3655,3656,3657,3658,3659,3660,3661,3662,3663
Data 3664,3665,3666,3667,3668,3669,3670,3671,3672,3673,3674,3675,0,0,0,0

Microsoft_windows_cp1250: 'WINDOWS in Central European and Eastern European languages that use Latin script, such as Polish, Czech, Slovak, Hungarian, Slovene, Bosnian, Croatian, Serbian (Latin script), Romanian and Albanian. It may also be used with the German language.
Data 8364,0,8218,0,8222,8230,8224,8225,0,8240,352,8249,346,356,381,377
Data 0,8216,8217,8220,8221,8226,8211,8212,0,8482,353,8250,347,357,382,378
Data 160,711,728,321,164,260,166,167,168,169,350,171,172,173,174,379
Data 176,177,731,322,180,181,182,183,184,261,351,187,317,733,318,380
Data 340,193,194,258,196,313,262,199,268,201,280,203,282,205,206,270
Data 272,323,327,211,212,336,214,215,344,366,218,368,220,221,354,223
Data 341,225,226,259,228,314,263,231,269,233,281,235,283,237,238,271
Data 273,324,328,243,244,337,246,247,345,367,250,369,252,253,355,729

Microsoft_windows_cp1252: 'Windows Western languages with Latin alphabet, used by default in the legacy components of Microsoft Windows in English.
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,352,8249,338,0,381,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,353,8250,339,0,382,376
Data 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
Data 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
Data 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
Data 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
Data 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

Microsoft_windows_cp1253: 'Greek (but not polytonic Greek) Not fully compatible with ISO 8859-7 (? is located differently).
Data 8364,0,8218,402,8222,8230,8224,8225,0,8240,0,8249,0,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,0,8482,0,8250,0,0,0,0
Data 160,901,902,163,164,165,166,167,168,169,0,171,172,173,174,8213
Data 176,177,178,179,900,181,182,183,904,905,906,187,908,189,910,911
Data 912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927
Data 928,929,0,931,932,933,934,935,936,937,938,939,940,941,942,943
Data 944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959
Data 960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,0

Microsoft_windows_cp1254: 'Turkish
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,352,8249,338,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,353,8250,339,0,0,376
Data 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
Data 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
Data 286,209,210,211,212,213,214,215,216,217,218,219,220,304,350,223
Data 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
Data 287,241,242,243,244,245,246,247,248,249,250,251,252,305,351,255

Microsoft_windows_cp1255: 'Hebrew Windows. Modern applications prefer [https://en.wikipedia.org/wiki/UTF-8 UTF-8] or UTF-16 http://www.fileformat.info/info/charset/UTF-16/list.htm to Windows 1255.
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,0,8249,0,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,0,8250,0,0,0,0
Data 160,161,162,163,8362,165,166,167,168,169,215,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,247,187,188,189,190,191
Data 1456,1457,1458,1459,1460,1461,1462,1463,1464,1465,0,1467,1468,1469,1470,1471
Data 1472,1473,1474,1475,1520,1521,1522,1523,1524,0,0,0,0,0,0,0
Data 1488,1489,1490,1491,1492,1493,1494,1495,1496,1497,1498,1499,1500,1501,1502,1503
Data 1504,1505,1506,1507,1508,1509,1510,1511,1512,1513,1514,0,0,8206,8207,0

Microsoft_windows_cp1256: 'Arabic Latin Windows
Data 8364,1662,8218,402,8222,8230,8224,8225,710,8240,1657,8249,338,1670,1688,1672
Data 1711,8216,8217,8220,8221,8226,8211,8212,1705,8482,1681,8250,339,8204,8205,1722
Data 160,1548,162,163,164,165,166,167,168,169,1726,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,1563,187,188,189,190,1567
Data 1729,1569,1570,1571,1572,1573,1574,1575,1576,1577,1578,1579,1580,1581,1582,1583
Data 1584,1585,1586,1587,1588,1589,1590,215,1591,1592,1593,1594,1600,1601,1602,1603
Data 224,1604,226,1605,1606,1607,1608,231,232,233,234,235,1609,1610,238,239
Data 1611,1612,1613,1614,244,1615,1616,247,1617,249,1618,251,252,8206,8207,1746

Microsoft_windows_cp1257: 'Estonian (although that can also be written with Windows-1252), Latvian and Lithuanian languages under Microsoft Windows. It is also possible to write Polish and German.
Data 8364,0,8218,0,8222,8230,8224,8225,0,8240,0,8249,0,168,711,184
Data 0,8216,8217,8220,8221,8226,8211,8212,0,8482,0,8250,0,175,731,0
Data 160,0,162,163,164,0,166,167,216,169,342,171,172,173,174,198
Data 176,177,178,179,180,181,182,183,248,185,343,187,188,189,190,230
Data 260,302,256,262,196,197,280,274,268,201,377,278,290,310,298,315
Data 352,323,325,211,332,213,214,215,370,321,346,362,220,379,381,223
Data 261,303,257,263,228,229,281,275,269,233,378,279,291,311,299,316
Data 353,324,326,243,333,245,246,247,371,322,347,363,252,380,382,729

Microsoft_windows_cp1258: 'Vietnamese. [https://en.wikipedia.org/wiki/UTF-8 UTF-8] is the preferred encoding for Vietnamese in modern applications.
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,0,8249,338,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,0,8250,339,0,0,376
Data 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
Data 192,193,194,258,196,197,198,199,200,201,202,203,768,205,206,207
Data 272,209,777,211,212,416,214,215,216,217,218,219,220,431,771,223
Data 224,225,226,259,228,229,230,231,232,233,234,235,769,237,238,239
Data 273,241,803,243,244,417,246,247,248,249,250,251,252,432,8363,255

Microsoft_pc_cp437: 'United States MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197
Data 201,230,198,244,246,242,251,249,255,214,220,162,163,165,8359,402
Data 225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_windows_cp1251: 'Cyrillic alphabet such as Russian, Bulgarian, Serbian Cyrillic and other languages. It is the most widely used for encoding the Bulgarian, Serbian and Macedonian languages.
Data 1026,1027,8218,1107,8222,8230,8224,8225,8364,8240,1033,8249,1034,1036,1035,1039
Data 1106,8216,8217,8220,8221,8226,8211,8212,0,8482,1113,8250,1114,1116,1115,1119
Data 160,1038,1118,1032,164,1168,166,167,1025,169,1028,171,172,173,174,1031
Data 176,177,1030,1110,1169,181,182,183,1105,8470,1108,187,1112,1029,1109,1111
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103

Microsoft_pc_cpMIK: 'Cyrillic Bulgarian Pravetz 16 for MS-DOS
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103
Data 9492,9524,9516,9500,9472,9532,9571,9553,9562,9566,9577,9574,9568,9552,9580,9488
Data 9617,9618,9619,9474,9508,8470,167,9559,9565,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cpGESCH: 'Schpitz/Gesch (a.k.a. Georgievica a.k.a. Geschovica) is Sanmayce's layout, combining the MIK and 437, in this way: (NOT RECODING only 009,010,013):
' shpitz

' DEFINITIONS
' top or extreme part
' the ultimate, the best of, "cool"
' typical, classic, a perfect example of; definitively

' LANGUAGES OF ORIGIN
' Yiddish

' ETYMOLOGY
' ????? shpits 'tip, peak'

' ALTERNATIVE SPELLINGS
' schpitz, shpits, shpitzy, shpitsy

'NOTES
'Steinmetz, "Yiddish and English" has an entry for shpits, but the meaning is simply 'tip.'

' ASCII 000..031 have to accomodate German and French  '&H203e = 8254 is upperscore '&H00DC=220
Data 196,228,214,246,&H00DC,&H00FC,223,&H00c1,&H00e1,&h00C7,&H00E7
'A:a:O:o:U:u:ss A' a' C'c'
Data &H0c9,&H00e9,&H0c0,&H00e0,&H00c8,&H00e8,&H00cc,&H00ec,&H00d2,&H00f2,&H00d9,&H00f9
' E'e' A`a`E`e`I`i`O`o`U`u`

'DATA &H00cb,&H00eb,&H00cf,&H00ef
' E:e: I:i: ' E:e: are present in Russian, so remove them

'First half of big Cyrillic letters:
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
'Second half of big Cyrillic letters:
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
'First half of small Cyrillic letters:
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
'1st third of CP437 drawing symbols:
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
'2nd third of CP437 drawing symbols:
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
'3rd third of CP437 drawing symbols:
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
'Second half of small Cyrillic letters:
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103
'Last 16 of CP437 symbols:
'                                                 u-kr E:   e:   <<  >>  Up_ ...
'DATA 8216,8217,8218,8219,8220,8221,8222,8223,176,1118,1025,1105,171,187,175,8230
'                                                MICRO  E:   e:   <<  >>  Up_ ...
Data 8216,8217,8218,8219,8220,8221,8222,8223,176,&h00b5,1025,1105,171,187,175,8230

Data &H00c6,&H00E6,&H0152,&H0153
' AE ae OEoe

Data &h2248
'almost equal to
'DATA &H221a
'square root

Data &H0102,&H0103,&H0114,&H0115,&H014e,&H014f,&H040e,&H045e,&H00cf,&H00ef
'Cyrillic short vowels: AaEeOoYy I:i:
Data &H00c2,&H00e2,&H00ca,&H00ea,&H00ce,&H00ee,&H00d4,&H00f4,&H00db,&H00fb
' A^a^ E^e^ I^i^ O^o^ U^u^

Data &h2017,&H2320,&H2321,&h00a1,&h00bf,&h00d1,&h00f1,&h00dd,&h00fd
'doubleunderline IntegralH IntegralL, Spanish: r! r? N~ n~ Y` y`

Data &h00cd,&h00ed,&h00da,&h00fa
' I'i'U'u'

Data &h00D3,&h00F3
' O' o'

' Portuguese makes use of five diacritics: the cedilla (c,), acute accent (a' e' i' o' u'), circumflex accent (a^, e^, o^), tilde (a~, o~), and grave accent (a`, and rarely e`, i`, o`, and u`).

SkipFontReviews:
handle& = _NewImage(XdimCOL + IndigoField, YdimROW + 1, 0)
Screen handle&
_Dest handle&

' _DEST 0 refers to the present program SCREEN. You can use 0 to refer to the present program
'  SCREEN.

'_FONT 16 'wish we could use the old 8x16 bitmap/raster fonts from DOS times...

'Let's think for people using 4K, then 32px is to be used. Now, 128col x 8 = 1024 (fits well in 1680x) or 198col x 8 = 1584 (fits well in FHD)
'IF _FILEEXISTS("C:\windows\fonts\MxPlus_ToshibaTxL2_8x16.ttf") = 0 THEN
$If BIGORSMALL = 0 Then
    If Mode4K = 0 Then
        '_FONT _LOADFONT(PSPlike$ +"cour.ttf", 14, "MONOSPACE") ' 8x14 is not bad at all!
        '_FONT _LOADFONT(PSPlike$ +"cour.ttf", 16, "MONOSPACE")
        '_FONT _LOADFONT(PSPlike$ +"lucon.ttf", 14, "MONOSPACE") ' 8x14 is not bad at all!
        '_FONT _LOADFONT(PSPlike$ +"lucon.ttf", 16, "MONOSPACE")
        'If not a single line is uncommented, above, then the EMULATED (Trident?) font is in use.
        _Font _LoadFont(PSPlike$ + "Px437_DOS-V_re_JPN12.ttf", 12, "MONOSPACE") '2021-Apr-23, use it on old laptops with 1680- by x, it is 6x12
        '_FONT _LOADFONT(PSPlike$ + "lucon.ttf", 12, "MONOSPACE") '2021-Apr-23, use it on old laptops with 1680- by x, it is 6x12
    Else
        '_FONT _LOADFONT(PSPlike$ +"cour.ttf", 32, "MONOSPACE")
        _Font _LoadFont(PSPlike$ + "lucon.ttf", 32, "MONOSPACE")
        'If not a single line is uncommented, above, then the EMULATED (Trident?) font is in use.
    End If
$Else
        If _FileExists(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf") = 0 Then
        If Mode4K = 0 Then
        '_FONT _LOADFONT(PSPlike$ +"cour.ttf", 14, "MONOSPACE") ' 8x14 is not bad at all!
        '_FONT _LOADFONT(PSPlike$ +"cour.ttf", 16, "MONOSPACE")
        '_FONT _LOADFONT(PSPlike$ +"lucon.ttf", 14, "MONOSPACE") ' 8x14 is not bad at all!
        '_FONT _LOADFONT(PSPlike$ +"lucon.ttf", 16, "MONOSPACE")
        'If not a single line is uncommented, above, then the EMULATED (Trident?) font is in use.
        _Font _LoadFont(PSPlike$ + "Px437_DOS-V_re_JPN12.ttf", 12, "MONOSPACE") '2021-Apr-23, use it on old laptops with 1680- by x, it is 6x12
        '_FONT _LOADFONT(PSPlike$ + "lucon.ttf", 12, "MONOSPACE") '2021-Apr-23, use it on old laptops with 1680- by x, it is 6x12
        Else
        '_FONT _LOADFONT(PSPlike$ +"cour.ttf", 32, "MONOSPACE")
        _Font _LoadFont(PSPlike$ + "lucon.ttf", 32, "MONOSPACE")
        'If not a single line is uncommented, above, then the EMULATED (Trident?) font is in use.
        End If
        Else
        If Mode4K = 0 Then
        If FONT4x = 1 Then
        _Font _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE") 'Toshiba rules...
        Else
        _Font _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 16, "MONOSPACE") 'Toshiba rules...
        End If
        '_FONT _LOADFONT(PSPlike$ +"MxPlus_Cordata_PPC-400.ttf", 16, "MONOSPACE") 'Beautiful, yet the '2' has a missing dot - up-right
        Else
        _Font _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE")
        '_FONT _LOADFONT(PSPlike$ +"MxPlus_Cordata_PPC-400.ttf", 32, "MONOSPACE")
        End If
        End If
$End If

If _FileExists(PSPlike$ + "Masakari.RGB") = 0 Then
    GoSub SetColorScheme
Else
    f00 = FreeFile
    Open "Masakari.RGB" For Binary As #f00
    RGB3x16$ = Space$(3 * 16)
    Get #f00, , RGB3x16$
    Close #f00
    For ii = 0 To 15
        _PaletteColor ii, _RGB32(Asc(Mid$(RGB3x16$, 3 * ii + 1, 1)) * 4, Asc(Mid$(RGB3x16$, 3 * ii + 2, 1)) * 4, Asc(Mid$(RGB3x16$, 3 * ii + 3, 1)) * 4)
    Next
End If

'RESTORE Microsoft_windows_cp1252
Restore Microsoft_pc_cpGESCH 'My codepage a.k.a. Gesch
'RESTORE Microsoft_windows_cp1251

For ASCIIcode = 0 To 6 'German A:a:O:o:U:u: ss
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 7 To 7 'Integral high
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 8 To 8 'Integral low
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 14 To 15 'French C,c,
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 16 To 27 'French/Italian E'e' A`a`E`e`I`i`O`o`U`u`
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
'why 28..31 are not available?!
For ASCIIcode = 128 To 255
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 220 To 223 ' the unnecessary 4 bold drawing chars are replaced with French AE ae I: i:
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 127 To 127 'almost equal to
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 181 To 190 'Cyrillic short vowels
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 198 To 207 'Cyrillic short vowels
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 208 To 216 'misc, Spanish
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 28 To 31 'draw animated block
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next
For ASCIIcode = 11 To 12 'draw animated block
    Read unicode
    _MapUnicode unicode To ASCIIcode
Next

' Either one must be uncommented:
_Display
'_AUTODISPLAY 'no need of refreshing

PurpleFlag = 0

NormalFRGr = 3
If PurpleFlag Then NormalFRGr = 9
NormalBCKGr = 0
If PurpleFlag Then NormalBCKGr = 0

InverseFRGr = 0
If PurpleFlag Then InverseFRGr = 8
InverseBCKGr = 3
If PurpleFlag Then InverseBCKGr = 0

Color NormalFRGr, NormalBCKGr

ShowASCIIart

$If WINDOWS Then
        i = 0
        Do
        i = i + 1
        setting$ = Environ$(i) ' get a setting from the list
        If InStr(setting$, "NUMBER_OF_PROCESSORS") Then NUMBER_OF_PROCESSORS$ = setting$
        Loop Until setting$ = ""
        Print NUMBER_OF_PROCESSORS$

        ' For some reason the Drag-and-Drop stops working when running as Administrator?! [
        'C$ = ENVIRON$("ALLUSERSPROFILE") 'try desktop for all users
        'SHORTCUT$ = C$ + "\Desktop\" + "Masakari.log.txt" 'create filename for the desktop
        ' For some reason the Drag-and-Drop stops working when running as Administrator?! ]
        SHORTCUT$ = _StartDir$ + "\" + "Masakari.log.txt"
        Open SHORTCUT$ For Append As #13
        Print #13,
        Print #13, "[Written on DATE: " + Date$ + ", TIME: " + Time$ + "]:"
        Print #13,
        'CLOSE #13
        Print "The log/output file, opened in APPEND mode: "; Chr$(34); SHORTCUT$; Chr$(34)
$End If

'f = FREEFILE
'SHELL _HIDE "cd > PRGMDIR.INF" 'get the current program path
'OPEN "PRGMDIR.INF" FOR INPUT AS #f
'LINE INPUT #f, current_program_path$
'CLOSE #f
'KILL "PRGMDIR.INF"
'PRINT "Current working directory path (obtained via SHELL _HIDE): "; CHR$(34); current_program_path$; CHR$(34)

'Ugh, they are reversed?!
'PRINT "Current working directory path: "; CHR$(34); _CWD$; CHR$(34)
'PRINT "User's program calling path: "; CHR$(34); _STARTDIR$; CHR$(34)
Print "Current working directory path: "; Chr$(34); _StartDir$; Chr$(34)
Print "User's program calling path: "; Chr$(34); _CWD$; Chr$(34)
'PRINT "Command line parameters sent when a program is started: "; CHR$(34); COMMAND$; CHR$(34)
'PRINT "_OS$="; _OS$

'Lazy me, in order to avoid editing the existing r.3+ code FileArray$() became function, array no more!
Dim FileArrayWINDOW$(YdimROW)

$If WINDOWS Then
        _AcceptFileDrop 'enables drag/drop functionality
        If Command$ = "" Then Print: Print "Drag files from a folder and drop them in this window... May press Alt+X or Alt+Q to eXit/Quit..."
        If Command$ = "" Then Print "May press Alt+Enter to toggle Fullscreen/Windowed modes. "
        If Command$ = "" Then Print "In order to have clean/undistorted font shape, _DesktopWidth\_DesktopHeight = " + LTrim$(Str$(_DesktopWidth)) + "/" + LTrim$(Str$(_DesktopHeight)) + " = " + Left$(LTrim$(Str$(_DesktopWidth / _DesktopHeight)), 4)
        If Command$ = "" Then Print "should be as near as possible (or multiple of) to XdimCOL\YdimROW = " + LTrim$(Str$(XdimCOL)) + "/" + LTrim$(Str$(YdimROW)) + " = " + Left$(LTrim$(Str$(XdimCOL / YdimROW)), 4)
$End If

_Display

a$ = ""
PostfixedToHeader = CsrLin
Do

    Locate PostfixedToHeader, 1

    'FOR d = 1 TO _DEVICES 'number of input devices found
    '    dev$ = _DEVICE$(d)
    '    IF INSTR(dev$, "[MOUSE]") THEN buttons = _LASTBUTTON(d): wheels = _LASTWHEEL(d): EXIT FOR
    'NEXT
    'PRINT
    'PRINT "Mouse Buttons:"; buttons
    'PRINT "Mouse Wheels:"; wheels
    ''d = _DEVICES '  always read number of devices to enable device input
    ''DO WHILE _DEVICEINPUT(2) 'loop only runs during a device 2 mouse event
    ''LOOP

    $If WINDOWS Then
            ' MEMUSAGE by Steve [
            ' GetCPULoad = 0 is idle, 1 is fully used.
            '  Multiply by 100 for a percentage
            Print
            Print "CPU used:              "; LTrim$(Str$(Int((GetCPULoad * 10000) / 100))); "%"; Space$(18)
            Print "Memory used:           "; LTrim$(Str$(MemInUsePercent)); "%"; Space$(18)
            Print "Total Physical Memory: ";: Print AddCommas$(TotalPhysicalMem); " bytes"; Space$(18)
            Print "Free Physical Memory:  ";: Print AddCommas$(FreePhysicalMem); " bytes"; Space$(18)
            Print "Total Paging File:     ";: Print AddCommas$(TotalPagingFile); " bytes"; Space$(18)
            Print "Free Paging File:      ";: Print AddCommas$(FreePagingFile); " bytes"; Space$(18)
            '        PRINT "Total Virtual Memory:  ";: PRINT AddCommas$(TotalVirtualMem); " bytes"; SPACE$(18)
            '        PRINT "Free Virtual Memory:   ";: PRINT AddCommas$(FreeVirtualMem); " bytes"; SPACE$(18)
            ' MEMUSAGE by Steve ]
    $End If

    'IF COMMAND$ = "" THEN PRINT: PRINT "May press Alt+X or Alt+Q to eXit/Quit..."
    ReturnCOMBO

    If YdimROW = 60 Then
        cryFrame = CsrLin
        NextFrame cryFrame + 1
        Locate cryFrame, 1
    End If

    _Display

    $If WINDOWS Then
            If _TotalDroppedFiles Then
            'FOR i = 1 TO _TOTALDROPPEDFILES
            'a$ = _DROPPEDFILE(i)
            a$ = _DroppedFile(1)
            'NEXT'
            _FinishDrop 'If _FINISHDROP isn't called here then _TOTALDROPPEDFILES never gets reset.
            'ELSE
            'a$ = "Scroller.$$$"
            'SHELL _HIDE "DIR /B *.* > Scroller.$$$"
            End If
    $End If
    $If WINDOWS Then
            If Command$ <> "" Then a$ = _StartDir$ + "\" + Command$
    $Else
        'If Command$ <> "" Then a$ = _StartDir$ + "/" + Command$
        ' above line was in r.8.1+++, now:
        If Command$ <> "" Then a$ = Command$
    $End If

    'Print a$: End

    'WrapFlag = 0
    'Wwidth% = XdimCOL
    'ul& = 0
    'LongestLine = 0
    'DO WHILE NOT EOF(1)
    '    LINE INPUT #1, l$: ul& = ul& + 1
    '    ExpandTabs l$
    '    IF LEN(l$) > LongestLine THEN LongestLine = LEN(l$)
    '    IF WrapFlag THEN
    '        lX$ = l$
    '        DO WHILE LEN(lX$) > Wwidth%
    '            Glupak% = Wwidth%
    '            DO UNTIL MID$(lX$, Glupak% + 1, 1) = " " AND MID$(lX$, Glupak%, 1) <> " "
    '                Glupak% = Glupak% - 1
    '                IF Glupak% = 0 THEN
    '                    PRINT "Rejecting line(#"; LTRIM$(STR$(ul&)); ", "; LTRIM$(STR$(LEN(l$))); "chars) that cannot be wrapped!"
    '                    _DISPLAY: SYSTEM
    '                    GOTO B4Txpanar
    '                END IF
    '            LOOP
    '            PRINT #3, LEFT$(lX$, Glupak%)
    '            lX$ = STRING$(1, " ") + LTRIM$(MID$(lX$, Glupak% + 1, LEN(lX$) - (Glupak%)))
    '        LOOP
    '        PRINT #3, lX$
    '        B4Txpanar:
    '    END IF
    'LOOP

    SecondTime = 1
    GettingStarted:

    If WrapFlag = 1 Then
        'Creating the wrapped temporary file [
        If _FileExists(a$ + ".wrapped") = 0 Then
            If _FileExists(a$) Then
                If SecondTime <> 2 Then Print: Print "Writing wrapped variant..."
                PostfixedToHeader = CsrLin

                StatuLine$ = Space$(XdimCOL)
                Mid$(StatuLine$, 1, 1) = "["
                Mid$(StatuLine$, XdimCOL, 1) = "]"

                _Display
                Open a$ For Binary As #1
                Open a$ + ".wrapped" For Output As #3
                Open a$ + ".unwrappable" For Output As #2
                LongestLine = 0
                UnwrappableLines = 0
                FileSize = LOF(1)
                If FileSize Then
                    ChunkBeingOneUnit = FileSize \ (XdimCOL - 1 - 1) + 1: LastPercentage = 0
                    NumberOfLFs = 0
                    Wwidth% = XdimCOL
                    ul& = 0
                    ReadBytes = 0
                    Do While Not EOF(1)
                        Line Input #1, l$: ul& = ul& + 1: ReadBytes = ReadBytes + Len(l$)
                        ExpandTabsFULL l$
                        If Len(l$) > LongestLine Then LongestLine = Len(l$)
                        If WrapFlag Then
                            ' Firstly do the wrapping virtually (in order to avoid writing some wrapped chunks and encounter unwrappable chunk) - we need either a wrapped line (in its entirety) or none:
                            AssumeLineIsWrappable = 1
                            lX$ = l$
                            Do While Len(lX$) > Wwidth%
                                Glupak% = Wwidth%
                                Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                                    InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                                    If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                                    'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                                    Glupak% = Glupak% - 1
                                    If Glupak% = 0 Then
                                        AssumeLineIsWrappable = 0
                                        GoTo B4TxpanarVIRTUAL
                                    End If
                                Loop
                                lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                            Loop
                            B4TxpanarVIRTUAL:
                            If AssumeLineIsWrappable = 1 Then
                                lX$ = l$
                                Do While Len(lX$) > Wwidth%
                                    Glupak% = Wwidth%
                                    Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                                        InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                                        If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                                        'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                                        Glupak% = Glupak% - 1
                                        If Glupak% = 0 Then
                                            Print "Rejecting line(#"; LTrim$(Str$(ul&)); ", "; LTrim$(Str$(Len(l$))); "chars) that cannot be wrapped!"
                                            Close #1, #3: Kill a$ + ".wrapped"
                                            _Display: End
                                            GoTo B4Txpanar
                                        End If
                                    Loop
                                    Print #3, Left$(lX$, Glupak%)
                                    'lX$ = STRING$(1, " ") + LTRIM$(MID$(lX$, Glupak% + 1, LEN(lX$) - (Glupak%)))
                                    lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                                Loop
                                Print #3, lX$
                                B4Txpanar:
                            Else
                                Print #2, l$: UnwrappableLines = UnwrappableLines + 1
                            End If
                        End If
                        If (ReadBytes \ ChunkBeingOneUnit) > LastPercentage Then
                            LastPercentage = LastPercentage + 1 ' in range 1..(XdimCOL-1)
                            Mid$(StatuLine$, 2, LastPercentage) = String$(LastPercentage, Chr$(176))
                            Locate YdimROW + 1, 1: Color 9, 0: Print StatuLine$;
                            _Display
                        End If
                    Loop
                Else
                    Close #1 'when filesize is 0
                    System
                End If 'IF FileSize THEN
                Close #1, #3
                a$ = a$ + ".wrapped"
                Locate PostfixedToHeader, 1
                Color NormalFRGr, NormalBCKGr
            End If
        Else
            a$ = a$ + ".wrapped"
        End If
        'Creating the wrapped temporary file ]
    End If

    TimeA = Timer

    ' Below fragment is r.4+ with 64bit pointers... to external/internal RAM!
    ' On i5-7200u, SSD Kingston 256GB it loads OED in ????/??? seconds, respectively.

    'Print a$
    'Print _FileExists(Command$): End

    If _FileExists(a$) Then
        If SecondTime <> 2 Then Print: Print "Loading...": Print

        PostfixedToHeader = CsrLin

        StatuLine$ = Space$(XdimCOL)
        Mid$(StatuLine$, 1, 1) = "["
        Mid$(StatuLine$, XdimCOL, 1) = "]"

        _Display
        Open a$ For Binary As #1
        LongestLine = 0
        FileSize = LOF(1)
        If FileSize Then
            ChunkBeingOneUnit = FileSize \ (XdimCOL - 1 - 1) + 1: LastPercentage = 0
            NumberOfLFs = 0
            If ToLoadOrNotFlag Then
                Mwholefile = _MemNew(FileSize + 1)
                'TheWholeFile$ = SPACE$(FileSize + 1) ' Grmbl, this comes with limitation probably 2GB, which prompts for buffered e.g. 128KB approach as my old LineWordReporter.c tool.
                'GET #1, , TheWholeFile$
                ReadBytes = 0 ' Have to load the 2+GB "malloc" in chunks...
                chunk128KB$ = Space$(128 * 1024 * 1024)
                Do While ReadBytes + (128 * 1024 * 1024) < FileSize
                    Get #1, , chunk128KB$
                    i = 1
                    Do While i <= (128 * 1024 * 1024)
                        i = InStr(i, chunk128KB$, Chr$(10))
                        If i = 0 Then Exit Do
                        NumberOfLFs = NumberOfLFs + 1
                        i = i + 1
                    Loop
                    'FOR i = 1 TO LEN(chunk128KB$)
                    '    IF MID$(chunk128KB$, i, 1) = CHR$(10) THEN NumberOfLFs = NumberOfLFs + 1 ' Boost it with INSTR...
                    'NEXT i
                    _MemPut Mwholefile, Mwholefile.OFFSET + ReadBytes, chunk128KB$
                    ReadBytes = ReadBytes + (128 * 1024 * 1024)
                Loop
                If (FileSize - ReadBytes) Then
                    RemainingChunk$ = Space$(FileSize - ReadBytes)
                    Get #1, , RemainingChunk$
                    i = 1
                    Do While i <= Len(RemainingChunk$)
                        i = InStr(i, RemainingChunk$, Chr$(10))
                        If i = 0 Then Exit Do
                        NumberOfLFs = NumberOfLFs + 1
                        i = i + 1
                    Loop
                    'FOR i = 1 TO LEN(RemainingChunk$)
                    '    IF MID$(RemainingChunk$, i, 1) = CHR$(10) THEN NumberOfLFs = NumberOfLFs + 1 ' Boost it with INSTR...
                    'NEXT i
                    _MemPut Mwholefile, Mwholefile.OFFSET + ReadBytes, RemainingChunk$
                End If
            End If
            'Bugfix from 2021-Jan-29, inhere problem exists, in efficient mode we don't know 'NumberOfLFs' therefore should read-it-without-loading-it:
            If ToLoadOrNotFlag = 0 Then
                ReadBytes = 0 ' Have to load the 2+GB "malloc" in chunks...
                chunk128KB$ = Space$(128 * 1024 * 1024)
                Do While ReadBytes + (128 * 1024 * 1024) < FileSize
                    Get #1, , chunk128KB$
                    i = 1
                    Do While i <= (128 * 1024 * 1024)
                        i = InStr(i, chunk128KB$, Chr$(10))
                        If i = 0 Then Exit Do
                        NumberOfLFs = NumberOfLFs + 1
                        i = i + 1
                    Loop
                    ReadBytes = ReadBytes + (128 * 1024 * 1024)
                Loop
                If (FileSize - ReadBytes) Then
                    RemainingChunk$ = Space$(FileSize - ReadBytes)
                    Get #1, , RemainingChunk$
                    i = 1
                    Do While i <= Len(RemainingChunk$)
                        i = InStr(i, RemainingChunk$, Chr$(10))
                        If i = 0 Then Exit Do
                        NumberOfLFs = NumberOfLFs + 1
                        i = i + 1
                    Loop
                End If
            End If
            Seek #1, 1
            'IF ASC(Byte) < 32 AND Byte <> CHR$(10) AND Byte <> CHR$(13) AND Byte <> CHR$(9) THEN Byte = CHR$(32)
            filecount = 0
            'Ugh, buggy, in r.5 below two "malloc" lines should be using 'NumberOfLFs' not 'FileSize'...
            MhandleOFF = _MemNew(8&& * (NumberOfLFs + 1)) 'create new memory block of 8*NumberOfLFs bytes - each line has its own 64bit Offset
            MhandleLEN = _MemNew(8&& * (NumberOfLFs + 1)) 'create new memory block of 8*NumberOfLFs bytes - each line has its own 64bit Length, kinda overkill, could be 32bit

            ' Parser for r.6 [[[
            '            LineLen13 = 0
            '            Byte = ""
            '            'Caution: Many files DON'T end with CRLF, or LF or CR - kinda the last line is not always postixed correctly!
            '            'This means if after the last CRLF, or LF or CR there is at least one byte then the number of total lines should be +1
            '            FOR j = 1 TO FileSize + 1
            '
            '                IF (j \ ChunkBeingOneUnit) > LastPercentage THEN
            '                    LastPercentage = LastPercentage + 1 ' in range 1..(XdimCOL-1)
            '                    MID$(StatuLine$, 2, LastPercentage) = STRING$(LastPercentage, CHR$(176))
            '                    LOCATE YdimROW + 1, 1: COLOR 9, 0: PRINT StatuLine$;
            '                    _DISPLAY
            '                END IF
            '
            '                PrevByte = Byte
            '                IF j <= FileSize THEN
            '                    IF ToLoadOrNotFlag THEN
            '                        'Byte = MID$(TheWholeFile$, j, 1)
            '                        _MEMGET Mwholefile, Mwholefile.OFFSET + (j - 1), Byte
            '                    ELSE
            '                        GET #1, , Byte
            '                    END IF
            '                ELSE
            '                    Byte = ""
            '                    IF PrevByte <> CHR$(10) THEN Byte = CHR$(10) ' enforce last line to be postfixed ONLY if last char was not LF
            '                END IF
            '                QWORD = j
            '                IF Byte = CHR$(10) THEN 'For now, won't work for MacOS...
            '                    QWORD = QWORD - LineLen13 'have to write the current offset minus the length of the line
            '                    _MEMPUT MhandleOFF, MhandleOFF.OFFSET + 8&& * filecount, QWORD
            '                    IF PrevByte = CHR$(13) THEN LineLen13 = LineLen13 - 1
            '                    _MEMPUT MhandleLEN, MhandleLEN.OFFSET + 8&& * filecount, LineLen13
            '                    IF LineLen13 > LongestLine THEN LongestLine = LineLen13
            '                    LineLen13 = 0
            '                    filecount = filecount + 1
            '                ELSE
            '                    LineLen13 = LineLen13 + 1
            '                END IF
            '            NEXT j
            ' Parser for r.6 ]]]

            ' Parser for r.7 [[[[[[
            If ToLoadOrNotFlag = 0 Then
                ReadBytes = 0 ' Have to load the 2+GB "malloc" in chunks...
                ChunkLen = 128 * 1024
                chunk128KB$ = Space$(ChunkLen) '+1 for sentinel
                j = 1 ' is the current offset where new GET reads
                QWORDlast = 1
                PrevByte = ""
                Do While ReadBytes + (ChunkLen) < FileSize ' this '<' is important, on purpose not using '<=' since there should be a remnant chunk (where LF postfixing is enforced, eventually)

                    If (j \ ChunkBeingOneUnit) > LastPercentage Then

                        If SecondTime <> 2 Then
                            $If WINDOWS Then
                                    Locate PostfixedToHeader, 1
                                    ' MEMUSAGE by Steve [
                                    ' GetCPULoad = 0 is idle, 1 is fully used.
                                    '  Multiply by 100 for a percentage
                                    Print "CPU used:              "; LTrim$(Str$(Int((GetCPULoad * 10000) / 100))); "%"; Space$(18)
                                    Print "Memory used:           "; LTrim$(Str$(MemInUsePercent)); "%"; Space$(18)
                                    Print "Total Physical Memory: ";: Print AddCommas$(TotalPhysicalMem); " bytes"; Space$(18)
                                    Print "Free Physical Memory:  ";: Print AddCommas$(FreePhysicalMem); " bytes"; Space$(18)
                                    Print "Total Paging File:     ";: Print AddCommas$(TotalPagingFile); " bytes"; Space$(18)
                                    Print "Free Paging File:      ";: Print AddCommas$(FreePagingFile); " bytes"; Space$(18)
                                    Print "Total Virtual Memory:  ";: Print AddCommas$(TotalVirtualMem); " bytes"; Space$(18)
                                    Print "Free Virtual Memory:   ";: Print AddCommas$(FreeVirtualMem); " bytes"; Space$(18)
                                    ' MEMUSAGE by Steve ]
                            $End If
                        End If

                        LastPercentage = LastPercentage + 1 ' in range 1..(XdimCOL-1)
                        Mid$(StatuLine$, 2, LastPercentage) = String$(LastPercentage, Chr$(176))
                        Locate YdimROW + 1, 1: Color 9, 0: Print StatuLine$;

                        If YdimROW = 60 Then
                            cryFrame = CsrLin
                            NextFramePEN 1
                            Locate cryFrame, 1
                        End If

                        _Display
                    End If

                    LastByte = Right$(chunk128KB$, 1) 'to handle eventual CR, left behind i.e. in previous chunk
                    Get #1, j, chunk128KB$
                    i = 1
                    FoundAt = InStr(i, chunk128KB$, Chr$(10))
                    If FoundAt Then
                        Do While FoundAt
                            If FoundAt = 1 Then PrevByte = LastByte Else PrevByte = Mid$(chunk128KB$, FoundAt - 1, 1)
                            QWORD = (j - 1) + FoundAt
                            LineLen13 = QWORD - QWORDlast
                            _MemPut MhandleOFF, MhandleOFF.OFFSET + 8&& * filecount, QWORDlast
                            QWORDlast = QWORD + 1
                            If PrevByte = Chr$(13) Then LineLen13 = LineLen13 - 1
                            _MemPut MhandleLEN, MhandleLEN.OFFSET + 8&& * filecount, LineLen13
                            If LineLen13 > LongestLine Then LongestLine = LineLen13
                            filecount = filecount + 1
                            i = FoundAt + 1
                            If i > (ChunkLen) Then Exit Do 'could use sentinel (buffer+1), in order this line to drop out
                            FoundAt = InStr(i, chunk128KB$, Chr$(10))
                        Loop
                    End If
                    j = j + (ChunkLen)
                    ReadBytes = ReadBytes + (ChunkLen)
                Loop
                If (FileSize - ReadBytes) Then
                    RemainingChunk$ = Space$(FileSize - ReadBytes) '+1 for sentinel
                    LastByte = Right$(chunk128KB$, 1) 'to handle eventual CR, left behind i.e. in previous chunk
                    Get #1, , RemainingChunk$
                    If Right$(RemainingChunk$, 1) <> Chr$(10) Then RemainingChunk$ = RemainingChunk$ + Chr$(10) ' dirty, enforcing not missing the last line (if it is not postfixed with LF)
                    'Beware, yes be aware that above line should have been applied for above/first fragment because the filesize could be multiple of the chunk length i.e. no remaining chunk, however it was feinted by '<'
                    i = 1
                    FoundAt = InStr(i, RemainingChunk$, Chr$(10))
                    If FoundAt Then
                        Do While FoundAt
                            If FoundAt = 1 Then PrevByte = LastByte Else PrevByte = Mid$(RemainingChunk$, FoundAt - 1, 1)
                            QWORD = (j - 1) + FoundAt
                            LineLen13 = QWORD - QWORDlast
                            _MemPut MhandleOFF, MhandleOFF.OFFSET + 8&& * filecount, QWORDlast
                            QWORDlast = QWORD + 1
                            If PrevByte = Chr$(13) Then LineLen13 = LineLen13 - 1
                            _MemPut MhandleLEN, MhandleLEN.OFFSET + 8&& * filecount, LineLen13
                            If LineLen13 > LongestLine Then LongestLine = LineLen13
                            filecount = filecount + 1
                            i = FoundAt + 1
                            If i > (FileSize - ReadBytes) Then Exit Do 'could use sentinel (buffer+1), in order this line to drop out
                            FoundAt = InStr(i, RemainingChunk$, Chr$(10))
                        Loop
                    End If
                End If
            End If
            Seek #1, 1
            ' Parser for r.7 ]]]]]]

        Else
            Close #1 'when filesize is 0
            System
        End If 'IF FileSize THEN
    End If

    ' Below fragment is r.4 with 64bit pointers... to external RAM!
    ' On i5-7200u, SSD Kingston 256GB it loads OED in 3,339 seconds, naturally the second attempt is to read byte-by-byte from RAM, however the whole file has to be loaded.
    'IF _FILEEXISTS(a$) THEN
    '    PRINT: PRINT "Loading..."
    '    _DISPLAY
    '    OPEN a$ FOR BINARY AS #1
    '    FileSize = LOF(1)
    '    filecount = 0
    '    MhandleOFF = _MEMNEW(8&& * FileSize) 'create new memory block of 8*filesize bytes - each line has its own 64bit Offset
    '    MhandleLEN = _MEMNEW(8&& * FileSize) 'create new memory block of 8*filesize bytes - each line has its own 64bit Length, kinda overkill, could be 32bit
    '    LineLen13 = 0
    '    Byte = ""
    '    'Caution: Many files DON'T end with CRLF, or LF or CR - kinda the last line is not always postixed correctly!
    '    'This means if after the last CRLF, or LF or CR there is at least one byte then the number of total lines should be +1
    '    FOR j = 1 TO FileSize + 1
    '        PrevByte = Byte
    '        IF j <= FileSize THEN
    '            GET #1, , Byte
    '        ELSE
    '            Byte = ""
    '            IF PrevByte <> CHR$(10) THEN Byte = CHR$(10) ' enforce last line to be postfixed ONLY if last char was not LF
    '        END IF
    '        QWORD = j
    '        IF Byte = CHR$(10) THEN 'For now, won't work for MacOS...
    '            QWORD = QWORD - LineLen13 'have to write the current offset minus the length of the line
    '            _MEMPUT MhandleOFF, MhandleOFF.OFFSET + 8&& * filecount, QWORD
    '            IF PrevByte = CHR$(13) THEN LineLen13 = LineLen13 - 1
    '            _MEMPUT MhandleLEN, MhandleLEN.OFFSET + 8&& * filecount, LineLen13
    '            IF LineLen13 > LongestLine THEN LongestLine = LineLen13
    '            LineLen13 = 0
    '            filecount = filecount + 1
    '        ELSE
    '            LineLen13 = LineLen13 + 1
    '        END IF
    '    NEXT j
    'END IF

    ''PRINT "filecount= "; filecount
    ''PRINT "LongestLine= "; LongestLine
    ''exercise in reproducing the indexed file:
    ''Debugo = CHR$(13) + CHR$(10)
    'Debugo = CHR$(10)
    'OPEN a$ + ".dump" FOR BINARY AS #2
    'FOR i = 1 TO filecount
    '    _MEMGET MhandleOFF, MhandleOFF.OFFSET + 8&& * (i - 1), QWORD
    '    _MEMGET MhandleLEN, MhandleLEN.OFFSET + 8&& * (i - 1), LineLen13
    '    PRINT QWORD, LineLen13:
    '    SEEK #1, QWORD
    '    BufferForLine$ = ""
    '    FOR j = 1 TO LineLen13
    '        GET #1, , Byte 'grmbl, how to load in one call?! As fread() is capable.
    '        PUT #2, , Byte
    '        BufferForLine$ = BufferForLine$ + Byte
    '    NEXT j
    '    PUT #2, , Debugo
    '    PRINT BufferForLine$
    'NEXT i
    '_DISPLAY
    'END

    ' Commented fragment is r.3+ with slow strings
    'LongestLine = 0
    'IF _FILEEXISTS(a$) THEN
    '    PRINT: PRINT "Loading..."
    '    _DISPLAY
    '    filecount = 0
    '    '        OPEN a$ FOR INPUT AS #1
    '    OPEN a$ FOR BINARY AS #1 ' As suggested by SMcNeill and Pete in https://www.qb64.org/forum/index.php?topic=3518.msg128631#msg128631
    '    DO UNTIL EOF(1)
    '        LINE INPUT #1, l$
    '        filecount = filecount + 1
    '    LOOP
    '    CLOSE #1
    '    REDIM FileArray$(1 TO filecount)
    '    filecount = 0
    '    '        OPEN a$ FOR INPUT AS #1
    '    OPEN a$ FOR BINARY AS #1 ' As suggested by SMcNeill and Pete in https://www.qb64.org/forum/index.php?topic=3518.msg128631#msg128631
    '    FileSize = LOF(1)
    '    DO UNTIL EOF(1)
    '        LINE INPUT #1, l$
    '        ExpandTabs l$
    '        FOR j = 1 TO LEN(l$)
    '            IF MID$(l$, j, 1) < CHR$(32) THEN MID$(l$, j, 1) = CHR$(32)
    '        NEXT j
    '        IF LEN(l$) > LongestLine THEN LongestLine = LEN(l$)
    '        filecount = filecount + 1
    '        FileArray$(filecount) = l$
    '    LOOP
    '    CLOSE #1
    'END IF

    _Limit 5
    If (_KeyDown(LALTkey&) Or _KeyDown(RALTkey&)) And (_KeyDown(81) Or _KeyDown(113)) Then System
    If (_KeyDown(LALTkey&) Or _KeyDown(RALTkey&)) And (_KeyDown(88) Or _KeyDown(120)) Then System

    '                            QB64 _KEYHIT and _KEYDOWN Values
    '
    'Esc  F1    F2    F3    F4    F5    F6    F7    F8    F9    F10   F11   F12   Sys  ScL Pause
    ' 27 15104 15360 15616 15872 16128 16384 16640 16896 17152 17408 34048 34304 +316 +302 +019
    '`~  1!  2@  3#  4$  5%  6^  7&  8*  9(  0) -_ =+ BkSp   Ins   Hme   PUp   NumL   /     *    -
    '126 33  64  35  36  37  94  38  42  40  41 95 43   8   20992 18176 18688 +300   47    42   45
    ' 96 49  50  51  52  53  54  55  56  57  48 45 61
    'Tab Q   W   E   R   T   Y   U   I   O   P  [{  ]}  \|   Del   End   PDn   7Hme  8/?   9PU   +
    ' 9  81  87  69  82  84  89  85  73  79  80 123 125 124 21248 20224 20736 18176 18432 18688 43
    '   113 119 101 114 116 121 117 105 111 112  91  93  92                    55    56    57
    'CapL   A   S   D   F   G   H   J   K   L   ;:  '" Enter                   4/?-   5    6/-?
    '+301   65  83  68  70  71  72  74  75  76  58  34  13                    19200 19456 19712  E
    '       97 115 100 102 103 104 106 107 108  59  39                         52    53    54    n
    'Shift   Z   X   C   V   B   N   M   ,<  .>  /?    Shift       ?           1End  2/?   3PD   t
    '+304   90  88  67  86  66  78  77  60  62  63    +303       18432        20224 20480 20736  e
    '      122 120  99 118  98 110 109  44  46  47                             49    50    51    r
    'Ctrl   Win  Alt     Spacebar      Alt  Win  Menu  Ctrl   ?-   ?   -?      0Ins        .Del
    '+306  +311 +308       32         +307 +312 +319  +305 19200 20480 19712  20992       21248 13
    '                                                                          48          46
    '         Lower value = LCase/NumLock On __________________ + = add 100000

Loop While a$ = ""

If XdimCOL = 128 And YdimROW = 40 Then _Title "MASAKARI, revision " + Mrev$ + " 128x40, The 'Holy Axe' English Text Sidekick" + ": " + a$
If XdimCOL = 128 And YdimROW = 60 Then _Title "MASAKARI, revision " + Mrev$ + " 128x60, The 'Holy Axe' English Text Sidekick" + ": " + a$
If XdimCOL = 213 And YdimROW = 60 Then _Title "MASAKARI, revision " + Mrev$ + " 213x60, The 'Holy Axe' English Text Sidekick" + ": " + a$
If XdimCOL = 300 And YdimROW = 80 Then _Title "MASAKARI, revision " + Mrev$ + " 300x80, The 'Holy Axe' English Text Sidekick" + ": " + a$
If XdimCOL = 112 And YdimROW = 30 Then _Title "MASAKARI, revision " + Mrev$ + " 112x30, The 'Holy Axe' English Text Sidekick" + ": " + a$
LoadedFile$ = a$

TimeB = Timer: SecondTime = 2
'PLAY "L8V2a-c-" 'removed in order to get rid of audio dependency
CurrentLine = 1
File_Frame_x = 1
File_Frame_y = 1
Color NormalFRGr, NormalBCKGr
UpdateWindowFrame NormalFRGr, NormalBCKGr

' Here is the layout:
' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
'                     .         .      |                    .
'                     .         .      |                    .
'                     cry       60     |                    filecount
'              FileArrayWINDOW$(60)    |          FileArray(filecount)
' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

UpdateCLine 1, 1, InverseFRGr, InverseBCKGr, 1
StatuLine$ = Space$(XdimCOL)
Mid$(StatuLine$, 1, 1) = "["
Mid$(StatuLine$, XdimCOL, 1) = "]"

FieldLineNum = Len(AddCommas$(filecount))
FieldLineLen = Len(AddCommas$(LongestLine))

'Dumbo$ = "File Size: " + AddCommas$(FileSize) + "; Longest Line: " + AddCommas$(LongestLine)
Dumbo$ = "Filesize: " + AddCommas$(FileSize) + "; Longest: " + AddCommas$(LongestLine)
Mid$(StatuLine$, 2, Len(Dumbo$)) = Dumbo$
Locate YdimROW + 1, 1
Color 9, 0: Print StatuLine$;
UpdateCLL CurrentLine, Len(Dumbo$) + 1 + 1 ' +1 due to [
'MostRightField = LEN(Dumbo$) + 1 + 1 + LEN("; Line Number: ") + LEN("; Line Length: ") + FieldLineNum + FieldLineLen
MostRightField = Len(Dumbo$) + 1 + 1 + Len("; Line: ") + Len("; Linesize: ") + FieldLineNum + FieldLineLen
UpdateNextToCCL_DONE MostRightField

If WrapFlag = 1 Then
    UpdateNextToCCL_UNWRAPPABLEcount MostRightField
End If

CursorS = 30
CursorE = 31

_Display
Locate 1, 1, 1, CursorS, CursorE
crx = Pos(0)
cry = CsrLin
crxOLD = crx
cryOLD = cry
PageScrollBenchmark = 0
LineScrollBenchmark = 0

tCurrentT1# = Timer(.001)
tLASTrelease1# = tCurrentT1#
tLASTpress1# = tCurrentT1#
tCurrentT2# = Timer(.001)
tLASTrelease2# = tCurrentT2#
tLASTpress2# = tCurrentT2#

SimulateTabRel = 0
Do 'mainloop [
    ReturnCOMBO
    IsF12released_Flag = 0
    IsF2released_Flag = 0
    IsF3released_Flag = 0
    IsENTERreleased_Flag = 0
    IsF10released_Flag = 0
    IsF11released_Flag = 0

    MustBeLONGssigned& = _KeyHit
    If SimulateTabRel = 1 Then SimulateTabRel = 0: MustBeLONGssigned& = -9
    If MustBeLONGssigned& Then
        Select Case MustBeLONGssigned&
            Case -33: 'LShift+1=! released, there were STICKY problem when _KeyDown(33) was used?!
                If SortedByLEN = 0 Then
                    ReportSortingLength (MostRightField): _Display
                    'UpdateNextToCCL_BUSY (MostRightField): _Display
                    Quicksort_QB64_v7_linesize MhandleOFF.OFFSET, MhandleLEN.OFFSET, 0, filecount - 1
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    UpdateNextToCCL_DONE (MostRightField)
                    _Display
                    _KeyClear
                    SortedByLEN = 1 ' don't sort again if sorted by LEN
                    SortedByOFF = 0 ' don't sort again if sorted by OFF
                End If
            Case -64: 'LShift+2=@ released, there were STICKY problem when _KeyDown(64) was used?!
                If SortedByOFF = 0 Then
                    ReportSortingOffset (MostRightField): _Display
                    'UpdateNextToCCL_BUSY (MostRightField): _Display
                    Quicksort_QB64_v7_linesize MhandleLEN.OFFSET, MhandleOFF.OFFSET, 0, filecount - 1
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    UpdateNextToCCL_DONE (MostRightField)
                    _Display
                    _KeyClear
                    SortedByOFF = 1 ' don't sort again if sorted by OFF
                    SortedByLEN = 0 ' don't sort again if sorted by LEN
                End If
            Case -20992: 'Ins released
                LastHit~&& = EpochTime~&&: Stepping = 10
                If CursorS = 0 Then
                    $If WINDOWS Then
                            Play "v15l48ba"
                    $End If
                    CursorS = 30
                    CursorE = 31
                Else
                    $If WINDOWS Then
                            Play "v15l48eef"
                    $End If
                    CursorS = 0
                    CursorE = 31
                End If
                _Display
            Case -9: 'Tab released while LShift is held
                'If _KeyDown(LSHIFTkey&) Then

                LastHit~&& = EpochTime~&&: Stepping = 10
                UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
                Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
                Color 9, 0

                ' Scrolling into 3D djamtche [
                'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
                dictTAB$ = "Masakari's dictionaries"
                If Len(dictTAB$) > 70 Then Reduced$ = "..." + Right$(dictTAB$, 70) Else Reduced$ = dictTAB$
                Call DrawBoxShadowOED(3 + 3, 3, 35, 125, Reduced$, 1)
                BckGRcolor = 1 '6
                PhysicalLine& = 1
                dictTAB_TotalWrd& = 23
                $If WINDOWS Then
                        Play "v15l48ga"
                $End If

                s$ = LTrim$(Str$(PhysicalLine&))
                If Len(s$) > 3 Then
                    If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
                    s$ = ""
                    For i = 1 To Len(x$) Step 3
                        s$ = s$ + Mid$(x$, i, 3) + ","
                    Next
                    s$ = Left$(s$, Len(s$) - 1)
                End If
                s$ = LTrim$(s$)
                Padded$ = "0,000,000,000"
                Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
                Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
                Locate , , 0

                DjamPoolLength = 125 - 3 + 1 - 4
                DjamPoolHeight = 35 - (3 + 3) + 1 - 4
                CurrentPos& = PhysicalLine& ' Notice that CurrentPos& = 1..(dictTAB_TotalWrd& - DjamPoolHeight + 1)
                ' inhere it could be between 1.. due to BINARY search
                If dictTAB_TotalWrd& < DjamPoolHeight Then CurrentPos2max& = 1 Else CurrentPos2max& = (dictTAB_TotalWrd& - DjamPoolHeight + 1)
                If CurrentPos& > CurrentPos2max& Then CurrentPos& = CurrentPos2max&
                PoolLinePos = 1
                Do
                    key$ = InKey$
                    'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
                    If key$ <> "" Then
                        code% = Asc(key$):
                        If code% Then ' ASC returns any value greater than 0
                            Select Case Asc(key$)
                                Case 13:
                                    If CurrentPos& + (PoolLinePos - 1) = 13 Then
                                        Call dict02sub
                                        GoTo DirtyGo
                                    End If
                                Case 32:
                                Case 65 To 97: 'PRINT key$;
                                Case Asc("a") To Asc("z"): 'PRINT key$;
                                    'CASE 27: COLOR 7, 0: SYSTEM 'END
                            End Select
                        Else
                            Select Case Asc(key$, 2)
                                Case 72:
                                    If PoolLinePos > 1 Then
                                        PoolLinePos = PoolLinePos - 1
                                    Else
                                        If CurrentPos& > 1 Then CurrentPos& = CurrentPos& - 1
                                    End If
                                Case 80:
                                    If PoolLinePos < MIN&(DjamPoolHeight, dictTAB_TotalWrd&) Then
                                        PoolLinePos = PoolLinePos + 1
                                    Else
                                        If CurrentPos& < CurrentPos2max& Then CurrentPos& = CurrentPos& + 1
                                    End If
                                Case 75: 'Left
                                Case 77: 'Right
                                Case 71: 'Home
                                    PoolLinePos = 1
                                    CurrentPos& = 1
                                Case 79: 'End
                                    PoolLinePos = MIN&(DjamPoolHeight, dictTAB_TotalWrd&)
                                    CurrentPos& = CurrentPos2max&
                                Case 73: 'PgUp
                                    If CurrentPos& - DjamPoolHeight >= 1 Then CurrentPos& = CurrentPos& - DjamPoolHeight
                                Case 81: 'PgDn
                                    If CurrentPos& + DjamPoolHeight <= CurrentPos2max& Then CurrentPos& = CurrentPos& + DjamPoolHeight
                                Case 61: 'F3
                                Case 13: 'Enter

                            End Select
                        End If
                    End If

                    For i = 1 To MIN&(DjamPoolHeight, dictTAB_TotalWrd&) ' with dictionaries all are bigger than ~40 lines
                        PADDED_EntryAll$ = DCTNS$(CurrentPos& + (i - 1)) + String$(DjamPoolLength - Len(DCTNS$(CurrentPos& + (i - 1))), " ")
                        Locate 3 + 3 + 2 + (i - 1), 3 + 2
                        If i = PoolLinePos Then Color BckGRcolor, 0 Else Color 0, BckGRcolor
                        Print PADDED_EntryAll$;
                    Next
                    s$ = LTrim$(Str$(CurrentPos& + PoolLinePos - 1))
                    If Len(s$) > 3 Then
                        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
                        s$ = ""
                        For i = 1 To Len(x$) Step 3
                            s$ = s$ + Mid$(x$, i, 3) + ","
                        Next
                        s$ = Left$(s$, Len(s$) - 1)
                    End If
                    s$ = LTrim$(s$)
                    Padded$ = "0,000,000,000"
                    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
                    Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
                    _Display 'in order to not having frozen screen
                    _Limit 60
                Loop Until _KeyDown(27)
                ' Scrolling into 3D djamtche ]
                DirtyGo:
                _KeyClear 2
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                'End If
            Case Else
        End Select
        If MustBeLONGssigned& < 0 Then 'negative value means key released
            MustBeLONGssigned& = -MustBeLONGssigned&
            If MustBeLONGssigned& \ 256 = 60 Then
                IsF2released_Flag = 1
            Else
            End If
            If MustBeLONGssigned& \ 256 = 61 Then
                IsF3released_Flag = 1
            Else
            End If
            If MustBeLONGssigned& \ 256 = 134 Then
                IsF12released_Flag = 1
            Else
            End If
            If MustBeLONGssigned& \ 256 = 133 Then
                IsF11released_Flag = 1
            Else
            End If
            If MustBeLONGssigned& \ 256 = 68 Then '17408=F10
                IsF10released_Flag = 1
            Else
            End If
            If MustBeLONGssigned& = 13 Then
                IsENTERreleased_Flag = 1
            Else
            End If
        End If
    End If

    If LALT_RALT Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        'PLAY "L4V2f" 'removed in order to get rid of audio dependency
        _KeyClear
        ReportTimeToLoad MostRightField
        _Display
    End If
    If (_KeyDown(LALTkey&) Or _KeyDown(RALTkey&)) And (_KeyDown(81) Or _KeyDown(113)) Then System
    If (_KeyDown(LALTkey&) Or _KeyDown(RALTkey&)) And (_KeyDown(88) Or _KeyDown(120)) Then System

    ''IF _KEYDOWN(LCTRLkey&) AND (_KEYDOWN(83) OR _KEYDOWN(115)) THEN 'Ctrl+S
    'If (_KeyDown(RSHIFTkey&) And _KeyDown(LSHIFTkey&) = 0) Or (_KeyDown(RCTRLkey&) And _KeyDown(LCTRLkey&) = 0) And PageScrollBenchmark = 0 And LineScrollBenchmark <> 0 Then
    'Shift was removed since it triggers Windows STICKY keys
    If (_KeyDown(RCTRLkey&) And _KeyDown(LCTRLkey&) = 0) And (PageScrollBenchmark <> 0 Or LineScrollBenchmark <> 0) Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        InverseL = CsrLin

        '[[[[[[[[[[[[[[[[[[[[[[[[

        FiCbig$ = UCase$(Chr$(97))
        SeCbig$ = UCase$(Chr$(122))

        For i = 1 To MIN&(YdimROW, filecount)
            'IF LEN(FileArray$(i + (File_Frame_y - 1))) >= XdimCOL THEN
            '    FileArrayWINDOW$(i) = MID$(FileArray$(i + (File_Frame_y - 1)), 1, XdimCOL)
            'ELSE
            '    FileArrayWINDOW$(i) = FileArray$(i + (File_Frame_y - 1)) + SPACE$(XdimCOL - LEN(FileArray$(i + (File_Frame_y - 1))))
            'END IF

            'LOCATE I, 1: PRINT FileArrayWINDOW$(I);
            Moron$ = FileArrayWINDOW$(i)
            BigMoron$ = Space$(Len(Moron$))

            SuperSlow$ = UCase$(Moron$)
            Matrox% = Len(SuperSlow$)
            j% = 0
            wrd$ = ""
            Do
                Again2:
                j% = j% + 1
                IamStupid$ = Mid$(SuperSlow$, j%, 1)
                If IamStupid$ >= FiCbig$ And IamStupid$ <= SeCbig$ Then
                    wrd$ = wrd$ + IamStupid$
                End If
                If wrd$ = "" And j% < Matrox% Then GoTo Again2
                If wrd$ = "" And j% = Matrox% Then GoTo Nothing2
                If wrd$ <> "" And j% < Matrox% Then
                    IamStupid2$ = Mid$(SuperSlow$, j% + 1, 1)
                    If IamStupid2$ >= FiCbig$ And IamStupid2$ <= SeCbig$ Then GoTo Again2
                End If

                WRDpresent% = 0
                Open "masakari.wrd" For Binary As #6
                If LOF(6) Then
                    Close #6
                    Open "masakari.ind" For Random Access Read As #6 Len = 32
                    LeftPoint& = 1
                    RightPoint& = TotalWrd&
                    Do
                        If RightPoint& - LeftPoint& <= 1 Then 'Sxsedtcheta
                            Get #6, LeftPoint&, lfixed$
                            If wrd$ = UCase$(RTrim$(lfixed$)) Then WRDpresent% = 1
                            Get #6, RightPoint&, lfixed$
                            If wrd$ = UCase$(RTrim$(lfixed$)) Then WRDpresent% = 1
                            Exit Do
                        End If
                        SplitPoint& = (LeftPoint& + RightPoint&) \ 2
                        Get #6, SplitPoint&, lfixed$
                        If wrd$ < UCase$(RTrim$(lfixed$)) Then
                            RightPoint& = SplitPoint&
                        ElseIf wrd$ > UCase$(RTrim$(lfixed$)) Then
                            LeftPoint& = SplitPoint&
                        Else
                            WRDpresent% = 1: Exit Do
                        End If
                    Loop
                    Close #6
                Else
                    Close #6
                    Kill "masakari.wrd"
                    WRDpresent% = 2
                End If
                If WRDpresent% = 0 Then
                    For Underdog% = j% - Len(wrd$) + 1 To j%
                        Mid$(BigMoron$, Underdog%, 1) = "#"
                    Next
                End If

                wrd$ = ""
                Nothing2:
            Loop While j% < Matrox%

            For j% = 1 To XdimCOL
                If Mid$(BigMoron$, j%, 1) <> " " Then
                    If i = InverseL Then ' inverse line
                        Locate i, j%: Color 15, InverseBCKGr: Print Mid$(Moron$, j%, 1);
                    Else
                        Locate i, j%: Color 15, 0: Print Mid$(Moron$, j%, 1);
                    End If
                End If
            Next
            'CALL MovePage(VideoBuffer%, 0, 8)
        Next

        ']]]]]]]]]]]]]]]]]]]]]]]]
        $If WINDOWS Then
                Play "v20l20g"
        $End If
        Do Until _KeyDown(RCTRLkey&) = 0 And _KeyDown(RSHIFTkey&) = 0
            _Display 'Caramba, when this line is commented the loop is not working as it should?!
        Loop
    End If

    ' keyboard mumbo-jumbo - handling of double-hits [
    KeyTap_buttondown1 = _KeyDown(LSHIFTkey&)
    KeyTap_buttondown2 = _KeyDown(LCTRLkey&)
    KeyTap_buttondown3 = _KeyDown(LALTkey&)
    KeyTap_buttondown4 = _KeyDown(RALTkey&)

    KeyTap_buttondown5 = _KeyDown(RSHIFTkey&)
    KeyTap_buttondown6 = _KeyDown(RCTRLkey&)

    If (KeyTap_buttondown1 And KeyTap_PrevClick1# = 0) Then 'first detection of the click
        KeyTap_PrevClick1# = Timer(0.001)
    End If
    If (KeyTap_buttondown2 And KeyTap_PrevClick2# = 0) Then 'first detection of the click
        KeyTap_PrevClick2# = Timer(0.001)
    End If
    If (KeyTap_buttondown3 And KeyTap_PrevClick3# = 0) Then 'first detection of the click
        KeyTap_PrevClick3# = Timer(0.001)
    End If
    If (KeyTap_buttondown4 And KeyTap_PrevClick4# = 0) Then 'first detection of the click
        KeyTap_PrevClick4# = Timer(0.001)
    End If

    If (KeyTap_buttondown5 And KeyTap_PrevClick5# = 0) Then 'first detection of the click
        KeyTap_PrevClick5# = Timer(0.001)
    End If
    If (KeyTap_buttondown6 And KeyTap_PrevClick6# = 0) Then 'first detection of the click
        KeyTap_PrevClick6# = Timer(0.001)
    End If


    If (KeyTap_buttondown1 And KeyTap_PrevClick1# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed1# = Timer(0.001) - KeyTap_PrevClick1#
    End If
    If (KeyTap_buttondown2 And KeyTap_PrevClick2# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed2# = Timer(0.001) - KeyTap_PrevClick2#
    End If
    If (KeyTap_buttondown3 And KeyTap_PrevClick3# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed3# = Timer(0.001) - KeyTap_PrevClick3#
    End If
    If (KeyTap_buttondown4 And KeyTap_PrevClick4# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed4# = Timer(0.001) - KeyTap_PrevClick4#
    End If

    If (KeyTap_buttondown5 And KeyTap_PrevClick5# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed5# = Timer(0.001) - KeyTap_PrevClick5#
    End If
    If (KeyTap_buttondown6 And KeyTap_PrevClick6# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed6# = Timer(0.001) - KeyTap_PrevClick6#
    End If

    If KeyTap_buttondown1 = 0 And KeyTap_PrevClick1# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button1LOG_firstDetection#(MumboJumbo) = KeyTap_Button1LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button1LOG_firstDetection#(4) = KeyTap_PrevClick1#
        KeyTap_Button1LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed1#
        KeyTap_PrevClick1# = 0
    End If

    If KeyTap_buttondown2 = 0 And KeyTap_PrevClick2# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button2LOG_firstDetection#(MumboJumbo) = KeyTap_Button2LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button2LOG_firstDetection#(4) = KeyTap_PrevClick2#
        KeyTap_Button2LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed2#
        KeyTap_PrevClick2# = 0
    End If

    If KeyTap_buttondown3 = 0 And KeyTap_PrevClick3# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button3LOG_firstDetection#(MumboJumbo) = KeyTap_Button3LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button3LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button3LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button3LOG_firstDetection#(4) = KeyTap_PrevClick3#
        KeyTap_Button3LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed3#
        KeyTap_PrevClick3# = 0
    End If

    If KeyTap_buttondown4 = 0 And KeyTap_PrevClick4# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button4LOG_firstDetection#(MumboJumbo) = KeyTap_Button4LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button4LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button4LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button4LOG_firstDetection#(4) = KeyTap_PrevClick4#
        KeyTap_Button4LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed4#
        KeyTap_PrevClick4# = 0
    End If

    If KeyTap_buttondown5 = 0 And KeyTap_PrevClick5# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button5LOG_firstDetection#(MumboJumbo) = KeyTap_Button5LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button5LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button5LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button5LOG_firstDetection#(4) = KeyTap_PrevClick5#
        KeyTap_Button5LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed5#
        KeyTap_PrevClick5# = 0
    End If

    If KeyTap_buttondown6 = 0 And KeyTap_PrevClick6# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button6LOG_firstDetection#(MumboJumbo) = KeyTap_Button6LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button6LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button6LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button6LOG_firstDetection#(4) = KeyTap_PrevClick6#
        KeyTap_Button6LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed6#
        KeyTap_PrevClick6# = 0
    End If

    If KeyTap_Button1LOG_firstDetection#(3) And (KeyTap_Button1LOG_firstDetection#(4) - KeyTap_Button1LOG_firstDetection#(3) < DclickTime#) Then Double_LSHIFTkey = 1 Else Double_LSHIFTkey = 0
    If KeyTap_Button2LOG_firstDetection#(3) And (KeyTap_Button2LOG_firstDetection#(4) - KeyTap_Button2LOG_firstDetection#(3) < DclickTime#) Then Double_LCTRLkey = 1 Else Double_LCTRLkey = 0
    If KeyTap_Button3LOG_firstDetection#(3) And (KeyTap_Button3LOG_firstDetection#(4) - KeyTap_Button3LOG_firstDetection#(3) < DclickTime#) Then Double_LALTkey = 1 Else Double_LALTkey = 0
    If KeyTap_Button4LOG_firstDetection#(3) And (KeyTap_Button4LOG_firstDetection#(4) - KeyTap_Button4LOG_firstDetection#(3) < DclickTime#) Then Double_RALTkey = 1 Else Double_RALTkey = 0

    If KeyTap_Button5LOG_firstDetection#(3) And (KeyTap_Button5LOG_firstDetection#(4) - KeyTap_Button5LOG_firstDetection#(3) < DclickTime#) Then Double_RSHIFTkey = 1 Else Double_RSHIFTkey = 0
    If KeyTap_Button6LOG_firstDetection#(3) And (KeyTap_Button6LOG_firstDetection#(4) - KeyTap_Button6LOG_firstDetection#(3) < DclickTime#) Then Double_RCTRLkey = 1 Else Double_RCTRLkey = 0
    ' keyboard mumbo-jumbo - handling of double-hits ]

    If Double_LSHIFTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_LSHIFTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button1LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print Space$((XdimCOL - MostRightField) - 0);
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print "; Pressed 'Double_LSHIFTkey', but unassigned.";
        Locate cryInfo, crxInfo, 1, CursorS, CursorE
    End If
    If Double_LCTRLkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_LCTRLkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button2LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print Space$((XdimCOL - MostRightField) - 0);
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print "; Pressed 'Double_LCTRLkey', but unassigned.";
        Locate cryInfo, crxInfo, 1, CursorS, CursorE
    End If
    If Double_LALTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_LALTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button3LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button3LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print Space$((XdimCOL - MostRightField) - 0);
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print "; Pressed 'Double_LALTkey', highlighting the unfamiliar words.";
        Locate cryInfo, crxInfo, 1, CursorS, CursorE

        'If FULLscr_Flag = 0 Then
        '    FULLscr_Flag = 1
        '    _FullScreen _Stretch , _Smooth
        '    $If WINDOWS Then
        '        Play "v20l32f"
        '    $End If
        'Else
        '    FULLscr_Flag = 0
        '    _FullScreen _Off
        '    $If WINDOWS Then
        '        Play "v20l32f"
        '    $End If
        'End If

        If PageScrollBenchmark = 0 Then
            LastHit~&& = EpochTime~&&: Stepping = 10
            InverseL = CsrLin

            '[[[[[[[[[[[[[[[[[[[[[[[[

            FiCbig$ = UCase$(Chr$(97))
            SeCbig$ = UCase$(Chr$(122))

            For i = 1 To MIN&(YdimROW, filecount)
                'IF LEN(FileArray$(i + (File_Frame_y - 1))) >= XdimCOL THEN
                '    FileArrayWINDOW$(i) = MID$(FileArray$(i + (File_Frame_y - 1)), 1, XdimCOL)
                'ELSE
                '    FileArrayWINDOW$(i) = FileArray$(i + (File_Frame_y - 1)) + SPACE$(XdimCOL - LEN(FileArray$(i + (File_Frame_y - 1))))
                'END IF

                'LOCATE I, 1: PRINT FileArrayWINDOW$(I);
                Moron$ = FileArrayWINDOW$(i)
                BigMoron$ = Space$(Len(Moron$))

                SuperSlow$ = UCase$(Moron$)
                Matrox% = Len(SuperSlow$)
                j% = 0
                wrd$ = ""
                Do
                    Again2alt:
                    j% = j% + 1
                    IamStupid$ = Mid$(SuperSlow$, j%, 1)
                    If IamStupid$ >= FiCbig$ And IamStupid$ <= SeCbig$ Then
                        wrd$ = wrd$ + IamStupid$
                    End If
                    If wrd$ = "" And j% < Matrox% Then GoTo Again2alt
                    If wrd$ = "" And j% = Matrox% Then GoTo Nothing2alt
                    If wrd$ <> "" And j% < Matrox% Then
                        IamStupid2$ = Mid$(SuperSlow$, j% + 1, 1)
                        If IamStupid2$ >= FiCbig$ And IamStupid2$ <= SeCbig$ Then GoTo Again2alt
                    End If

                    WRDpresent% = 0
                    Open "masakari.wrd" For Binary As #6
                    If LOF(6) Then
                        Close #6
                        Open "masakari.ind" For Random Access Read As #6 Len = 32
                        LeftPoint& = 1
                        RightPoint& = TotalWrd&
                        Do
                            If RightPoint& - LeftPoint& <= 1 Then 'Sxsedtcheta
                                Get #6, LeftPoint&, lfixed$
                                If wrd$ = UCase$(RTrim$(lfixed$)) Then WRDpresent% = 1
                                Get #6, RightPoint&, lfixed$
                                If wrd$ = UCase$(RTrim$(lfixed$)) Then WRDpresent% = 1
                                Exit Do
                            End If
                            SplitPoint& = (LeftPoint& + RightPoint&) \ 2
                            Get #6, SplitPoint&, lfixed$
                            If wrd$ < UCase$(RTrim$(lfixed$)) Then
                                RightPoint& = SplitPoint&
                            ElseIf wrd$ > UCase$(RTrim$(lfixed$)) Then
                                LeftPoint& = SplitPoint&
                            Else
                                WRDpresent% = 1: Exit Do
                            End If
                        Loop
                        Close #6
                    Else
                        Close #6
                        Kill "masakari.wrd"
                        WRDpresent% = 2
                    End If
                    If WRDpresent% = 0 Then
                        For Underdog% = j% - Len(wrd$) + 1 To j%
                            Mid$(BigMoron$, Underdog%, 1) = "#"
                        Next
                    End If

                    wrd$ = ""
                    Nothing2alt:
                Loop While j% < Matrox%

                For j% = 1 To XdimCOL
                    If Mid$(BigMoron$, j%, 1) <> " " Then
                        If i = InverseL Then ' inverse line
                            Locate i, j%: Color 15, InverseBCKGr: Print Mid$(Moron$, j%, 1);
                        Else
                            Locate i, j%: Color 15, 0: Print Mid$(Moron$, j%, 1);
                        End If
                    End If
                Next
                'CALL MovePage(VideoBuffer%, 0, 8)
            Next

            ']]]]]]]]]]]]]]]]]]]]]]]]
            $If WINDOWS Then
                    Play "v20l20g"
            $End If
        End If

    End If
    If Double_RALTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_RALTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button4LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button4LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print Space$((XdimCOL - MostRightField) - 0);
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print "; Pressed 'Double_RALTkey', but unassigned.";
        Locate cryInfo, crxInfo, 1, CursorS, CursorE
    End If

    If Double_RSHIFTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_RSHIFTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button5LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button5LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print Space$((XdimCOL - MostRightField) - 0);
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print "; Pressed 'Double_RSHIFTkey', but unassigned.";
        Locate cryInfo, crxInfo, 1, CursorS, CursorE
    End If
    If Double_RCTRLkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_RCTRLkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button6LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button6LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print Space$((XdimCOL - MostRightField) - 0);
        Locate YdimROW + 1, MostRightField: Color 4, 0: Print "; Pressed 'Double_RCTRLkey', but unassigned.";
        Locate cryInfo, crxInfo, 1, CursorS, CursorE
    End If

    If _KeyDown(LSHIFTkey&) = 0 And _KeyDown(15616) And _KeyDown(LCTRLkey&) Then 'LCtrl+F3
        LastHit~&& = EpochTime~&&: Stepping = 10
        'CALL DrawBox(3, 3, 7, 44, 8, 7)
        'CALL DrawBoxShadow(3, 3, 7, 44)
        'In case of YdimROW = 40 then shrunk panel
        If YdimROW = 40 Then shrunkP = 14 Else shrunkP = 0
        Call DrawBoxShadow3(3, 3, 48 - shrunkP, 107, "LCtrl+F3: Search Panel")
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        _Display
        IsF3released_Flag = 0
        _KeyClear
    End If

    'IF _KEYDOWN(LSHIFTkey&) = 0 AND _KEYDOWN(15616) AND _KEYDOWN(LALTkey&) THEN 'LAlt+F3released
    If _KeyDown(LSHIFTkey&) = 0 And _KeyDown(15616) And _KeyDown(LALTkey&) = 0 Then 'F3released
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do While _KeyDown(15616): Locate , , 0: _Display: Loop
        'CALL DrawBox(3, 3, 7, 44, 8, 7)
        'CALL DrawBoxShadow(3, 3, 7, 44)
        'In case of YdimROW = 40 then shrunk panel
        shrunkP = 14
        'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
        F3pattern$ = DrawBoxShadow3exact$(3 + 13, 3, 35 - shrunkP, 107, "F3: Exact Case-Sensitive Search Panel")
        Do Until IsENTERreleased: Locate , , 0: _Display: Loop 'doesnt work on Linux Fedora 33
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        UpdateNextToCCL_F3 MostRightField
        _Display

        Do While CurrentLine < filecount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < filecount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            TheNewCL$ = FileArray$(CurrentLine)
            If InStr(TheNewCL$, F3pattern$) Then
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                Exit Do
            Else
                If CurrentLine = filecount Then
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    _Display
                    $If WINDOWS Then
                            Play "v20l32c"
                    $End If
                    Exit Do
                End If
            End If
        Loop

        ' Interactive search, from the line below the INVERSE one, forward ... ]
        UpdateNextToCCL_DONE MostRightField
        IsF3released_Flag = 0
        _KeyClear
    End If

    'IF _KEYDOWN(LSHIFTkey&) = 0 AND _KEYDOWN(34304) AND _KEYDOWN(LALTkey&) THEN 'LAlt+F12released
    If _KeyDown(LSHIFTkey&) = 0 And _KeyDown(15360) And _KeyDown(LALTkey&) = 0 Then 'F2released
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do While _KeyDown(15360): Locate , , 0: _Display: Loop
        'CALL DrawBox(3, 3, 7, 44, 8, 7)
        'CALL DrawBoxShadow(3, 3, 7, 44)
        'In case of YdimROW = 40 then shrunk panel
        shrunkP = 14
        'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
        F3pattern$ = DrawBoxShadow3exactRussian$(3 + 13, 3, 35 - shrunkP, 107, "F2: Exact Case-Sensitive Search Panel (Russian Phonetic)")
        Do Until IsENTERreleased: Locate , , 0: _Display: Loop 'doesnt work on Linux Fedora 33
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        UpdateNextToCCL_F3 MostRightField
        _Display

        Do While CurrentLine < filecount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < filecount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            TheNewCL$ = FileArray$(CurrentLine)
            If InStr(TheNewCL$, F3pattern$) Then
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                Exit Do
            Else
                If CurrentLine = filecount Then
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    _Display
                    $If WINDOWS Then
                            Play "v20l32c"
                    $End If
                    Exit Do
                End If
            End If
        Loop

        ' Interactive search, from the line below the INVERSE one, forward ... ]
        UpdateNextToCCL_DONE MostRightField
        IsF2released_Flag = 0
        _KeyClear
    End If

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) = 0 And _KeyDown(15616) Then 'LShift+(F3 released)
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do While _KeyDown(15616): Locate , , 0: _Display: Loop
        'DO UNTIL IsF3released: LOCATE , , 0: _DISPLAY: LOOP ' doesn't work on Linux Fedora 33
        UpdateNextToCCL_F3 MostRightField
        _Display
        If InStr(_Clipboard$, Chr$(10)) Then '_CLIPBOARD$ could be multi-line, so get the first
            a2$ = Left$(_Clipboard$, InStr(_Clipboard$, Chr$(10)) - 1)
            If Right$(a2$, 1) = Chr$(13) Then a2$ = Left$(a2$, Len(a2$) - 1)
            F3pattern$ = a2$
        Else
            F3pattern$ = _Clipboard$
        End If
        ' Interactive search, from the line below the INVERSE one, forward ... [
        Do While CurrentLine < filecount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < filecount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            TheNewCL$ = FileArray$(CurrentLine)
            If InStr(TheNewCL$, F3pattern$) Then
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                Exit Do
            Else
                If CurrentLine = filecount Then
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    _Display
                    $If WINDOWS Then
                            Play "v20l32c"
                    $End If
                    Exit Do
                End If
            End If
        Loop

        ' Interactive search, from the line below the INVERSE one, forward ... ]
        UpdateNextToCCL_DONE MostRightField
    End If

    If _KeyDown(LSHIFTkey&) = 0 And _KeyDown(LCTRLkey&) = 0 And _KeyDown(15616) And _KeyDown(LALTkey&) Then 'LAlt+F3released
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do While _KeyDown(15616): Locate , , 0: _Display: Loop
        'DO UNTIL IsF3released: LOCATE , , 0: _DISPLAY: LOOP ' doesn't work on Linux Fedora 33
        UpdateNextToCCL_F3 MostRightField
        _Display
        F3pattern$ = CurrentWord$

        ' Interactive search, from the line below the INVERSE one, forward ... [

        Do While CurrentLine < filecount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < filecount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            TheNewCL$ = FileArray$(CurrentLine)
            If InStr(TheNewCL$, F3pattern$) Then
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                Exit Do
            Else
                If CurrentLine = filecount Then
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    _Display
                    $If WINDOWS Then
                            Play "v20l32c"
                    $End If
                    Exit Do
                End If
            End If
        Loop

        ' Interactive search, from the line below the INVERSE one, forward ... ]
        UpdateNextToCCL_DONE MostRightField
    End If

    If LALT_Up = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        If _FileExists(PSPlike$ + "Masakari.RGB") = 0 Then
            GoSub SetColorScheme
            RGB3x16$ = Space$(3 * 16)
            For attribute = 0 To 15
                Out &H3C7, attribute 'set color attribute to read
                red = Inp(&H3C9) 'multiply by 4 to convert intensity to 0 to 255 RGB values
                grn = Inp(&H3C9)
                blu = Inp(&H3C9)
                Mid$(RGB3x16$, 3 * attribute + 1, 1) = Chr$(red)
                Mid$(RGB3x16$, 3 * attribute + 2, 1) = Chr$(grn)
                Mid$(RGB3x16$, 3 * attribute + 3, 1) = Chr$(blu)
            Next
        Else
            f00 = FreeFile
            Open "Masakari.RGB" For Binary As #f00
            RGB3x16$ = Space$(3 * 16)
            Get #f00, , RGB3x16$
            Close #f00
            For ii = 0 To 15
                _PaletteColor ii, _RGB32(Asc(Mid$(RGB3x16$, 3 * ii + 1, 1)) * 4, Asc(Mid$(RGB3x16$, 3 * ii + 2, 1)) * 4, Asc(Mid$(RGB3x16$, 3 * ii + 3, 1)) * 4)
            Next
            $If WINDOWS Then
                    Play "v20l32c"
            $End If
        End If

        SimulateBlinking& = 0
        Locate , , 0
        rChannel% = 0
        gChannel% = 0
        bChannel% = 0
        Brightness% = 0
        GoSub UpdateColors
        Do
            reentrance& = _KeyHit
            If reentrance& Then
                Select Case reentrance&
                    Case -114: '"r":
                        If rChannel% > -63 Then rChannel% = rChannel% - 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48d"
                        $End If
                    Case -82 '"R":
                        If rChannel% < 63 Then rChannel% = rChannel% + 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48d"
                        $End If
                    Case -103: '"g":
                        If gChannel% > -63 Then gChannel% = gChannel% - 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48e"
                        $End If
                    Case -71: '"G":
                        If gChannel% < 63 Then gChannel% = gChannel% + 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48e"
                        $End If
                    Case -98: '"b":
                        If bChannel% > -63 Then bChannel% = bChannel% - 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48f"
                        $End If
                    Case -66: '"B":
                        If bChannel% < 63 Then bChannel% = bChannel% + 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48f"
                        $End If
                    Case -105: '"i":
                        If Brightness% > -63 Then Brightness% = Brightness% - 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48a"
                        $End If
                    Case -73: '"I":
                        If Brightness% < 63 Then Brightness% = Brightness% + 1
                        GoSub UpdateColors
                        $If WINDOWS Then
                                Play "v5l48a"
                        $End If
                    Case Else
                End Select
            End If
            _Limit 20: _Display: '_Delay .9
        Loop Until reentrance& = -27
        Do While _KeyDown(LALTkey&) Or _KeyDown(UPkey&): _Limit 10: Loop ' to avoid flickering i.e. reentrance
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        _Display
    End If

    If LALT_Down = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        'GoSub UpdateColorSchemeFile
        ReDim red(0 To 15)
        ReDim grn(0 To 15)
        ReDim blu(0 To 15)
        For attribute = 0 To 15
            Out &H3C7, attribute 'set color attribute to read
            red = Inp(&H3C9) * 4 'multiply by 4 to convert intensity to 0 to 255 RGB values
            grn = Inp(&H3C9) * 4
            blu = Inp(&H3C9) * 4
            red(attribute) = red
            grn(attribute) = grn
            blu(attribute) = blu
        Next
        'Sepiascale
        'outputRed = (inputRed * .393) + (inputGreen * .769) + (inputBlue * .189)
        'outputGreen = (inputRed * .349) + (inputGreen * .686) + (inputBlue * .168)
        'outputBlue = (inputRed * .272) + (inputGreen * .534) + (inputBlue * .131)
        For i = 0 To 15
            'Sepiascale
            _PaletteColor i, _RGB32(Int(red(i) * .393) + Int(grn(i) * .769) + Int(blu(i) * .189), Int(red(i) * .349) + Int(grn(i) * .686) + Int(blu(i) * .168), Int(red(i) * .272) + Int(grn(i) * .534) + Int(blu(i) * .131))
            'Greyscale
            _PaletteColor i, _RGB32((red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3)
            'Amberscale
        Next
        For i = 1 To 6
            Dummy$ = DrawBoxShadowDUMMY$(i, 2 + (i - 1) * 6, 2, 6 + (i - 1) * 6, 116, "Dummy window with background color" + Str$(i))
        Next
        Locate , , 0
        Do While InKey$ = ""
            SimulateBlinking& = Not SimulateBlinking&
            If SimulateBlinking& = 0 Then
                Locate 38, 2: Color 0, 7: Print "Note1: File 'Masakari.RGB' has NOT been updated with current (before Greyscaling) color settings.";
                Locate 39, 2: Color 0, 7: Print "Note2: In order to have your own color scheme, you can manually change the values of 'Masakari.RGB' (3x16 bytes long).";
            Else
                'Locate 38, 2: Color 15, 7: Print "Note1: File 'Masakari.RGB' has been updated with current (before Greyscaling) color settings.";
                'Locate 39, 2: Color 15, 7: Print "Note2: In order to have your own color scheme, you can manually change the values of 'Masakari.RGB' (3x16 bytes long).";
            End If
            _Limit 20: _Display: '_Delay .9
        Loop
        Do While _KeyDown(LALTkey&) Or _KeyDown(DOWNkey&): _Limit 10: Loop ' to avoid flickering i.e. reentrance
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        _Display
    End If

    If _KeyDown(27) Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        LineScrollBenchmark = 0
        PageScrollBenchmark = 0
    End If

    If LSHIFT_RSHIFT Or LineScrollBenchmark = 1 Then 'same as scroll page-by-page benchmark, but line-by-line
        LastHit~&& = EpochTime~&&: Stepping = 10
        If LineScrollBenchmark = 0 Then TimeScrollA = Timer
        LineScrollBenchmark = 1
        'PgDn - just add the page height i.e. 'YdimROW' to 'File_Frame_y'
        ' Don't execute PgDn (advancing the 'CurrentLine') if 'File_Frame_y' is not "eligible":
        'IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'IF File_Frame_y + 1 <= filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'CAUTION [
        ' Next three line beep NOT
        'DEFLNG A-Z
        'aaa = 61
        'bbb = -48
        'IF aaa <= bbb THEN BEEP: END
        'Next three line beep
        'aaa~& = 61
        'bbb~& = -48
        'IF aaa~& <= bbb~& THEN BEEP: END
        'Next three line beep NOT
        'aaa& = 61
        'bbb& = -48
        'IF aaa& <= bbb& THEN BEEP: END
        'Next line works even when unsigned!
        'IF File_Frame_y + YdimROW - (filecount - (YdimROW - 1)) <= 0 THEN
        'CAUTION ]
        'Next line doesn't work when unsigned!
        If File_Frame_y + 1 <= filecount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + 1
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + 1 <= filecount Then CurrentLine = CurrentLine + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        Else
            If LineScrollBenchmark = 1 Then
                TimeScrollB = Timer
                _KeyClear
                ReportTimeToScroll MostRightField
                LineScrollBenchmark = 0
                _Display
            End If
        End If
    End If

    ' Esc  F1  F2  F3  F4  F5  F6  F7  F8  F9  F10  F11  F12  Sys ScL Pause
    '  27 +59 +60 +61 +62 +63 +64 +65 +66 +67 +68  +133 +134   -   -    -
    ' `~  1!  2@  3#  4$  5%  6^  7&  8*  9(  0) -_ =+ BkSp   Ins Hme PUp   NumL  /   *    -
    ' 126 33  64  35  36  37  94  38  42  40  41 95 43   8    +82 +71 +73    -    47  42   45
    '  96 49  50  51  52  53  54  55  56  57  48 45 61
    ' Tab Q   W   E   R   T   Y   U   I   O   P  [{  ]}  \|   Del End PDn   7Hme 8/  9PU  +
    '  9  81  87  69  82  84  89  85  73  79  80 123 125 124  +83 +79 +81   +71  +72  +73  43
    '    113 119 101 114 116 121 117 105 111 112  91  93  92                 55   56   57
    ' CapL  A   S   D   F   G   H   J   K   L   ;:  '" Enter                4/-  5   6/-
    '   -   65  83  68  70  71  72  74  75  76  58  34  13                  +75  +76  +77  E
    '       97 115 100 102 103 104 106 107 108  59  39                       52   53   54  n
    '
    ' Shift  Z   X   C   V   B   N   M   ,<  .>  /?    Shift               1End 2/  3PD  t
    '   *    90  88  67  86  66  78  77  60  62  63      *        +72       +79  +80  +81  e
    '       122 120  99 118  98 110 109  44  46  47                          49   50   51  r
    ' Ctrl Win Alt       Spacebar          Alt Win Menu Ctrl   -     -   0Ins     .Del
    '  *    -   *           32              *   -   -    *    +75 +80 +77   +82       +83  13
    '                                                                        48        46
    '
    '     Italics = LCase/NumLock On  ____________  + = 2 Byte: CHR$(0) + CHR$(code)
    'NOTE: The above commented table can be copied and pasted directly into the QB64 IDE

    key$ = InKey$
    'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
    If key$ <> "" Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        code% = Asc(key$):
        If code% Then ' ASC returns any value greater than 0
            Select Case Asc(key$)
                Case 32:
                    a$ = RTrim$(FileArray$(CurrentLine))
                    If _FileExists(a$) Then
                        Close #1
                        _MemFree MhandleOFF
                        _MemFree MhandleLEN
                        If ToLoadOrNotFlag Then
                            _MemFree Mwholefile
                        End If
                        GoTo GettingStarted 'Before going above lines must be executed, i.e. to initialize.
                    End If
                Case 65 To 97: 'PRINT key$;
                Case Asc("a") To Asc("z"): 'PRINT key$;
                    'CASE 27: COLOR 7, 0: SYSTEM 'END
            End Select
        Else
            Select Case Asc(key$, 2)
                Case 59:
                    Locate 1, 1, 0, CursorS, CursorE
                    For i = 1 To YdimROW
                        Locate i, 1: Print Space$(XdimCOL);
                    Next
                    Locate 1, 1
                    ShowF1
                    Print "Press ESC...";
                    _Display
                    $If WINDOWS Then
                            Play "v20l20g"
                    $End If
                    Do While InKey$ <> Chr$(27)
                        _Limit 10
                        _Display 'in order to not having frozen screen
                    Loop
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                Case 133: 'f11

                Case 134: 'f12

                Case 72:
                    If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
                    If cry > 1 Then
                        cry = cry - 1 'up
                    Else 'scrolling is needed
                        If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
                        UpdateWindowFrame NormalFRGr, NormalBCKGr
                    End If
                Case 80:
                    If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
                    If cry < YdimROW Then
                        If cry < filecount Then cry = cry + 1 'down
                    Else 'scrolling is needed
                        If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                        UpdateWindowFrame NormalFRGr, NormalBCKGr
                    End If
                Case 75: If crx > 1 Then crx = crx - 1 'left
                Case 77: If crx < XdimCOL Then crx = crx + 1 'right
                Case 73: 'PgUp
                    If File_Frame_y - YdimROW >= 1 Then
                        File_Frame_y = File_Frame_y - YdimROW
                        If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
                        UpdateWindowFrame NormalFRGr, NormalBCKGr
                    End If
                Case 81: 'PgDn
                    If File_Frame_y + YdimROW <= filecount - (YdimROW - 1) Then
                        File_Frame_y = File_Frame_y + YdimROW
                        'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
                        'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
                        If CurrentLine + YdimROW <= filecount Then CurrentLine = CurrentLine + YdimROW
                        UpdateWindowFrame NormalFRGr, NormalBCKGr
                    End If
            End Select
        End If
    End If
    If cryOLD <> cry Then
        UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
        cryOLD = cry
    Else 'it 'cry' could be changed by Mouse Wheel too, check it
        AsIfItIsINKEY% = _MouseInput '      Check the mouse status
        'WHILE _MOUSEINPUT: WEND '2021-Apr-23
        If AsIfItIsINKEY% Then
            buttondown1 = _MouseButton(1)
            buttondown2 = _MouseButton(2)
            buttondown3 = _MouseButton(3)
            mwheel = _MouseWheel
        End If

        If IsF10released_Flag Then
            LastHit~&& = EpochTime~&&: Stepping = 10
            UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
            Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
            Color 9, 0
            Call dict03sub
            _KeyClear 2
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If

        If IsF11released_Flag Then
            LastHit~&& = EpochTime~&&: Stepping = 10
            UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
            Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
            Color 9, 0
            Call dict02sub
            _KeyClear 2
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If

        If IsF12released_Flag Then
            LastHit~&& = EpochTime~&&: Stepping = 10
            UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
            Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
            Color 9, 0
            Call dict01sub
            _KeyClear 2
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If

        If _KeyDown(LSHIFTkey&) Or _KeyDown(LCTRLkey&) Or _KeyDown(LALTkey&) Then ShutDownIsNoLonger = 1: ShutDownIsNoLongerR = 1 ' do not forget there are key+button shortcuts

        If (buttondown1 And PrevClick1# = 0) Then 'first detection of the click
            PrevClick1# = Timer(0.001)
            SaveMouseX2 = _MouseX
            SaveMouseY2 = _MouseY
            ShutDownIsNoLonger = 0
        End If

        If (buttondown2 And PrevClick2# = 0) Then 'first detection of the click
            PrevClick2# = Timer(0.001)
            SaveMouseXR = _MouseX
            SaveMouseYR = _MouseY
            ShutDownIsNoLongerR = 0
        End If

        If (buttondown1 And PrevClick1# <> 0) Then 'already clicked
            ForHowLongWasPressed1# = Timer(0.001) - PrevClick1#
            If (SaveMouseX2 <> _MouseX) Or (SaveMouseY2 <> _MouseY) Then ShutDownIsNoLonger = 1
        End If

        If (buttondown2 And PrevClick2# <> 0) Then 'already clicked
            ForHowLongWasPressed2# = Timer(0.001) - PrevClick2#
            If (SaveMouseXR <> _MouseX) Or (SaveMouseYR <> _MouseY) Then ShutDownIsNoLongerR = 1
        End If

        If buttondown1 = 0 And PrevClick1# <> 0 Then 'write to the log
            For MumboJumbo = 1 To 3
                Button1LOG_firstDetection#(MumboJumbo) = Button1LOG_firstDetection#(MumboJumbo + 1)
                Button1LOG_ForHowLongHolded#(MumboJumbo) = Button1LOG_ForHowLongHolded#(MumboJumbo + 1)
            Next
            Button1LOG_firstDetection#(4) = PrevClick1#
            Button1LOG_ForHowLongHolded#(4) = ForHowLongWasPressed1#
            PrevClick1# = 0
        End If

        If buttondown2 = 0 And PrevClick2# <> 0 Then 'write to the log
            For MumboJumbo = 1 To 3
                Button2LOG_firstDetection#(MumboJumbo) = Button2LOG_firstDetection#(MumboJumbo + 1)
                Button2LOG_ForHowLongHolded#(MumboJumbo) = Button2LOG_ForHowLongHolded#(MumboJumbo + 1)
            Next
            Button2LOG_firstDetection#(4) = PrevClick2#
            Button2LOG_ForHowLongHolded#(4) = ForHowLongWasPressed2#
            PrevClick2# = 0
        End If

        If Button1LOG_firstDetection#(3) And (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3) < DclickTime#) Then Double_LeftClick = 1 Else Double_LeftClick = 0
        'IF Double_LeftClick = 1 THEN PRINT "Double_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

        If Button2LOG_firstDetection#(3) And (Button2LOG_firstDetection#(4) - Button2LOG_firstDetection#(3) < DclickTime#) Then Double_RightClick = 1 Else Double_RightClick = 0
        'IF Double_LeftClick = 1 THEN PRINT "Double_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

        If (ForHowLongWasPressed1# > ShutDownDuration#) And (ShutDownIsNoLonger = 0) Then 'the pointer should not be moved (in perfect case), inhere should be as the pointer during the initial click
            ShutDownIsNoLonger = 1
            System
        End If

        If (ForHowLongWasPressed2# > ShutDownDuration#) And (ShutDownIsNoLongerR = 0) Then 'the pointer should not be moved (in perfect case), inhere should be as the pointer during the initial click
            ShutDownIsNoLongerR = 1
            'SimulateTabRel = 1
            'add some common task here, mapped onto held Button2
        End If
    End If

    If _KeyDown(LSHIFTkey&) And buttondown1 Then 'Fast Up
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
        If cry > 1 Then
            cry = cry - 1 'up
        Else 'scrolling is needed
            If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If

    If _KeyDown(LSHIFTkey&) And buttondown2 Then 'Fast Down
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
        If cry < YdimROW Then
            If cry < filecount Then cry = cry + 1 'down
        Else 'scrolling is needed
            If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If

    If _KeyDown(LALTkey&) And buttondown1 Then 'LCTRL_HOME
        LastHit~&& = EpochTime~&&: Stepping = 10
        LCTRL_HOME = 1
    End If
    If _KeyDown(LALTkey&) And buttondown2 Then 'LCTRL_END
        LastHit~&& = EpochTime~&&: Stepping = 10
        LCTRL_END = 1
    End If

    If _KeyDown(LCTRLkey&) And buttondown1 Then 'Fast PgUp
        LastHit~&& = EpochTime~&&: Stepping = 10
        If File_Frame_y - YdimROW >= 1 Then
            File_Frame_y = File_Frame_y - YdimROW
            If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If

    If _KeyDown(LCTRLkey&) And buttondown2 Then 'Fast PgDn, grmbl, for some reason (LShift+button3) and (LShift+button1) are not spitting?!
        LastHit~&& = EpochTime~&&: Stepping = 10
        If File_Frame_y + YdimROW <= filecount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= filecount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If

    If mwheel = 1 Then ' as if Down
        If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
        If cry < YdimROW Then
            If cry < filecount Then cry = cry + 1 'down
        Else 'scrolling is needed
            If File_Frame_y < filecount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If
    If mwheel = -1 Then ' as if Up
        If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
        If cry > 1 Then
            cry = cry - 1 'up
        Else 'scrolling is needed
            If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If
    If (_KeyDown(LSHIFTkey&) = 0) And buttondown1 Then
        crxOLD = crx
        cryOLD = cry
        If _MouseY <= MIN&(YdimROW, filecount) Then
            cry = _MouseY
            crx = _MouseX
            UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
            Do While cryOLD > cry
                cryOLD = cryOLD - 1
                If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
            Loop
            Do While cryOLD < cry
                cryOLD = cryOLD + 1
                If CurrentLine < filecount Then CurrentLine = CurrentLine + 1
            Loop
        End If
    End If

    If (mwheel = -1) And buttondown2 Then ' same as LCTRL_HOME
        LCTRL_HOME = 1
    End If
    If (mwheel = 1) And buttondown2 Then ' same as LCTRL_END
        LCTRL_END = 1
    End If

    If buttondown2 Then ' 'drawing a line' gesture - 100 cells at least long, COMBO: Alt+X, Alt+Q
        ReadOnceY = _MouseY
        ReadOnceX = _MouseX
        If Button2Down = 0 Then Mouse2Press! = Timer: Button2Down = 1
        If WidenessINIT = 0 Then WidenessINIT = ReadOnceX
        If HighnessINIT = 0 Then HighnessINIT = ReadOnceY
        If ReadOnceY < YdimROW + 1 Then Locate ReadOnceY, ReadOnceX: Print Chr$(176); 'don't write trail in status line
    Else
        Button2Down = 0
        Mouse2Release! = Timer
        If WidenessINIT And (Mouse2Release! - Mouse2Press! > 0 And Mouse2Release! - Mouse2Press! < 2) Then
            If Abs(_MouseX - WidenessINIT) >= 100 Then System 'PLAY "v10l8g" 'bidirectional i.e. can be drawn from left to right and vice versa
            WidenessINIT = 0
        End If
        'simulate PgDn (from bottom to top, as the hand cursor in PhotoShop), but not repetitive i.e. not-buffered
        If HighnessINIT And (Mouse2Release! - Mouse2Press! > 0 And Mouse2Release! - Mouse2Press! < 2) Then
            If (HighnessINIT - _MouseY) >= 5 Then 'PLAY "v10l8g" 'bidirectional i.e. can be drawn from left to right and vice versa

                If File_Frame_y + YdimROW <= filecount - (YdimROW - 1) Then
                    File_Frame_y = File_Frame_y + YdimROW
                    'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
                    'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
                    If CurrentLine + YdimROW <= filecount Then CurrentLine = CurrentLine + YdimROW
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                End If
                ' Here is the layout:
                ' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
                '                     .         .      |                    .
                '                     .         .      |                    .
                '                     cry       60     |                    filecount
                '              FileArrayWINDOW$(60)    |          FileArray(filecount)
                ' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
                ' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

            End If
        End If
        'simulate PgUp (from top to bottom, as the hand cursor in PhotoShop), but not repetitive i.e. not-buffered
        If HighnessINIT And (Mouse2Release! - Mouse2Press! > 0 And Mouse2Release! - Mouse2Press! < 2) Then
            If (_MouseY - HighnessINIT) >= 5 Then 'PLAY "v10l8g" 'bidirectional i.e. can be drawn from left to right and vice versa

                If File_Frame_y - YdimROW >= 1 Then
                    File_Frame_y = File_Frame_y - YdimROW
                    If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                End If

            End If
        End If
        HighnessINIT = 0
    End If

    If LCTRL_RCTRL Then PageScrollBenchmark = 1: TimeScrollA = Timer
    If buttondown3 Or PageScrollBenchmark Then 'PgDn - just add the page height i.e. 'YdimROW' to 'File_Frame_y'
        LastHit~&& = EpochTime~&&: Stepping = 10
        ' Don't execute PgDn (advancing the 'CurrentLine') if 'File_Frame_y' is not "eligible":
        'IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'IF File_Frame_y + 1 <= filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'CAUTION [
        ' Next three line beep NOT
        'DEFLNG A-Z
        'aaa = 61
        'bbb = -48
        'IF aaa <= bbb THEN BEEP: END
        'Next three line beep
        'aaa~& = 61
        'bbb~& = -48
        'IF aaa~& <= bbb~& THEN BEEP: END
        'Next three line beep NOT
        'aaa& = 61
        'bbb& = -48
        'IF aaa& <= bbb& THEN BEEP: END
        'Next line works even when unsigned!
        'IF File_Frame_y + YdimROW - (filecount - (YdimROW - 1)) <= 0 THEN
        'CAUTION ]
        'Next line doesn't work when unsigned!
        If File_Frame_y + YdimROW <= filecount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= filecount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        Else
            If PageScrollBenchmark = 1 Then
                TimeScrollB = Timer
                _KeyClear
                ReportTimeToScroll MostRightField
                PageScrollBenchmark = 0
                _Display
            End If
        End If
    End If

    If cryOLD <> cry Then
        UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
        cryOLD = cry
    End If
    If LCTRL_HOME Or RCTRL_HOME Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Locate 1, 1, 1, CursorS, CursorE
        crx = Pos(0)
        cry = CsrLin
        crxOLD = crx
        cryOLD = cry
        File_Frame_x = 1
        File_Frame_y = 1
        CurrentLine = 1
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        'DO WHILE _MOUSEINPUT: LOOP
    End If
    If LCTRL_END Or RCTRL_END Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        If filecount >= YdimROW Then
            If filecount - (YdimROW - 1) Then
                Locate YdimROW, 1, 1, CursorS, CursorE
                crx = Pos(0)
                cry = CsrLin
                crxOLD = crx
                cryOLD = cry
                File_Frame_x = 1
                File_Frame_y = filecount - (YdimROW - 1)
                CurrentLine = filecount
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
        Else
            Locate filecount, 1, 1, CursorS, CursorE
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = filecount
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'DO WHILE _MOUSEINPUT: LOOP
    End If

    ' @QB64team shared this clear code:
    'DO
    '    WHILE _MOUSEINPUT: WEND
    '    IF _MOUSEBUTTON(1) THEN
    '        IF timeElapsedSince!(lastClick!) <= .3 THEN
    '            PRINT "... and make it double!"
    '        ELSE
    '            PRINT
    '            PRINT "Click!";
    '        END IF
    '        lastClick! = TIMER
    '        WHILE _MOUSEBUTTON(1): i = _MOUSEINPUT: WEND
    '    END IF
    '    _LIMIT 60
    'LOOP UNTIL _KEYHIT = 27

    'FUNCTION timeElapsedSince! (startTime!)
    '    IF startTime! > TIMER THEN startTime! = startTime! - 86400
    '    timeElapsedSince! = TIMER - startTime!
    'END FUNCTION

    'WHILE _MOUSEINPUT: WEND
    'IF _MOUSEBUTTON(1) THEN
    '    IF timeElapsedSince!(lastClick!) <= .3 THEN
    '        ' Double-click
    '        a$ = RTRIM$(FileArray$(CurrentLine))
    '        IF _FILEEXISTS(a$) THEN
    '            CLOSE #1
    '            _MEMFREE MhandleOFF
    '            _MEMFREE MhandleLEN
    '            IF ToLoadOrNotFlag THEN
    '                _MEMFREE Mwholefile
    '            END IF
    '            GOTO GettingStarted 'Before going above lines must be executed, i.e. to initialize.
    '        ELSE ' not responsive enough - it misses some double-clicks?!
    '            IF File_Frame_y - YdimROW >= 1 THEN
    '                File_Frame_y = File_Frame_y - YdimROW
    '                IF CurrentLine - YdimROW >= 1 THEN CurrentLine = CurrentLine - YdimROW
    '                UpdateWindowFrame NormalFRGr, NormalBCKGr
    '            END IF
    '        END IF
    '    ELSE
    '        ' Single-click
    '    END IF
    '    lastClick! = TIMER
    '    WHILE _MOUSEBUTTON(1): idummy = _MOUSEINPUT: WEND
    'END IF

    ' Grmbl, my doulbe-click sucks, therefore going to limbo... Yet, the above replacement nullifies/discards further events :( thus banning my other mouse functionality!
    ' No grmbls anymore, fixed:
    If Double_LeftClick Then
        a$ = RTrim$(FileArray$(CurrentLine))
        If _FileExists(a$) Then
            Close #1
            _MemFree MhandleOFF
            _MemFree MhandleLEN
            If ToLoadOrNotFlag Then
                _MemFree Mwholefile
            End If
            GoTo GettingStarted 'Before going above lines must be executed, i.e. to initialize.
        Else ' not responsive enough - it misses some double-clicks?!
            If File_Frame_y - YdimROW >= 1 Then
                File_Frame_y = File_Frame_y - YdimROW
                If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
        End If
        Double_LeftClick = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            Button1LOG_firstDetection#(MumboJumbo) = 0
            Button1LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
    End If

    'WHILE _MOUSEINPUT: WEND
    'IF _MOUSEBUTTON(2) THEN
    '    IF timeElapsedSince!(lastClick!) <= .3 THEN
    '        ' Double-click
    '        IF File_Frame_y + YdimROW <= filecount - (YdimROW - 1) THEN
    '            File_Frame_y = File_Frame_y + YdimROW
    '            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
    '            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
    '            IF CurrentLine + YdimROW <= filecount THEN CurrentLine = CurrentLine + YdimROW
    '            UpdateWindowFrame NormalFRGr, NormalBCKGr
    '        END IF
    '    ELSE
    '        ' Single-click
    '    END IF
    '    lastClick! = TIMER
    '    WHILE _MOUSEBUTTON(2): idummy = _MOUSEINPUT: WEND
    'END IF

    ' Grmbl, my doulbe-click sucks, therefore going to limbo... Yet, the above replacement nullifies/discards further events :( thus banning my other mouse functionality!
    ' No grmbls anymore, fixed:
    If Double_RightClick Then
        If File_Frame_y + YdimROW <= filecount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= filecount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        Double_RightClick = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            Button2LOG_firstDetection#(MumboJumbo) = 0
            Button2LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
    End If

    Locate cry, crx, 1, CursorS, CursorE
    UpdateCLine cry, 1, InverseFRGr, InverseBCKGr, cry
    UpdateCLL CurrentLine, Len(Dumbo$) + 1 + 1
    _Display

    If buttondown2 And buttondown1 Then 'pagoda, GRMBL, for now the file being handled SHOULD be in the invocation/home folder!
        buttondown2 = 0
        buttondown1 = 0 ' have to nullify because the cleaning of mouseinputs below prevents zeroing the variable in the main cycle where release is awaited but never registered.
        ShutDownIsNoLonger = 1
        UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
        UpdateCLL CurrentLine, Len(Dumbo$) + 1 + 1
        Locate cry, crx, 0, CursorS, CursorE 'hide the cursor
        _Display
        If Len(CurrentWord$) > 1 Then
            UpdateNextToCCL_BUSY (MostRightField): _Display
            p$ = LoadedFile$
            If InStr(p$, Slash) Then
                pTRIMMED = 0
                Do Until Mid$(p$, Len(p$) - pTRIMMED, 1) = Slash
                    pTRIMMED = pTRIMMED + 1
                Loop
                p$ = Right$(p$, pTRIMMED)
            End If
            $If WINDOWS Then
                $If 32BIT Then
                        Shell _Hide "call " + "XGRAM_PAGODA5_32bit.bat" + " " + LCase$(CurrentWord$) + " " + Chr$(34) + p$ + Chr$(34)
                $End If
                $If 64BIT Then
                        SHELL _HIDE "call " + "XGRAM_PAGODA5_64bit.bat" + " " + LCASE$(CurrentWord$) + " " + CHR$(34) + p$ + CHR$(34)
                $End If
            $Else
                Shell _Hide "sh " + "XGRAM_PAGODA5.sh" + " " + LCase$(CurrentWord$) + " " + Chr$(34) + p$ + Chr$(34)
            $End If
            UpdateNextToCCL_DONE (MostRightField): _Display
            While _MouseInput: Wend

            Locate 1, 1, 0, CursorS, CursorE
            For i = 1 To YdimROW
                Locate i, 1: Print Space$(XdimCOL);
            Next

            If _FileExists(PSPlike$ + p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt") Then
                reportNAME$ = p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt"
                pgd& = FreeFile
                Open PSPlike$ + p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt" For Input As #pgd&
                pgdlines = 0
                Do While Not EOF(pgd&)
                    pgdlines = pgdlines + 1
                    Line Input #pgd&, dummyl$
                Loop
                Close #pgd&
                ReDim xgrams$(1 To pgdlines)
                SCROLLABLEheight = (YdimROW - 2) - 4 + 1
                pgd& = FreeFile
                Open PSPlike$ + p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt" For Input As #pgd&
                Locate 1, 1
                Print "PAGODA size: "; AddCommas$(pgdlines); " lines or "; AddCommas$(LOF(pgd&)); " bytes";
                Locate 2, 1
                Print "PAGODA name: "; Left$(reportNAME$, XdimCOL - Len("PAGODA name: "));
                pgdlines = 0
                Do While Not EOF(pgd&)
                    pgdlines = pgdlines + 1
                    Line Input #pgd&, xgrams$(pgdlines)
                    For j = 1 To Len(xgrams$(pgdlines))
                        If pgdlines Mod 2 = 0 Then
                            If Mid$(xgrams$(pgdlines), j, 1) = " " Then Mid$(xgrams$(pgdlines), j, 1) = "."
                        End If
                    Next
                Loop
                Close #pgd&
                For i = 1 To MIN&(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                    Locate i + 3, 1: Print Left$(xgrams$(i), XdimCOL);
                Next

            End If
            Print
            Print
            Print "Press ESC... for vertical scroll use Up/Down, MouseLeftButton/MouseRightButton or Mouse Wheel.";
            _Display
            $If WINDOWS Then
                    Play "v20l20g"
            $End If
            LinesScroled = 0: LinesScroledMAX = pgdlines - SCROLLABLEheight
            Do While InKey$ <> Chr$(27)
                If pgdlines > SCROLLABLEheight Then
                    AsIfItIsINKEY% = _MouseInput '      Check the mouse status
                    buttondown1 = _MouseButton(1)
                    buttondown2 = _MouseButton(2)
                    buttondown3 = _MouseButton(3)
                    mwheel = _MouseWheel
                    If buttondown2 Or mwheel = 1 Or _KeyDown(DOWNkey&) Then ' as if Down
                        If LinesScroled < LinesScroledMAX Then
                            LinesScroled = LinesScroled + 1
                        End If
                        For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                            Locate i + 3, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
                        Next
                    End If
                    If buttondown1 Or mwheel = -1 Or _KeyDown(UPkey&) Then ' as if Up
                        If LinesScroled > 0 Then
                            LinesScroled = LinesScroled - 1
                        End If
                        For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                            Locate i + 3, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
                        Next
                    End If
                End If
                _Limit 500
                _Display
            Loop
            While _MouseInput: Wend
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If

    If IsENTERreleased_Flag Then ' Wrap the current/INVERSE line, and scroll it up/down as the PAGODA
        Wwidth% = XdimCOL
        UpdateCLL CurrentLine, Len(Dumbo$) + 1 + 1
        Locate cry, crx, 0, CursorS, CursorE 'hide the cursor
        _Display
        If Len(FileArrayFULL$(CurrentLine)) > XdimCOL Then
            UpdateNextToCCL_BUSY (MostRightField): _Display
            l$ = FileArrayFULL$(CurrentLine)
            ExpandTabsFULL l$
            ' [[[
            ' Firstly do the wrapping virtually (in order to avoid writing some wrapped chunks and encounter unwrappable chunk) - we need either a wrapped line (in its entirety) or none:
            AssumeLineIsWrappable = 1
            pgdlines = 0
            lX$ = l$
            Do While Len(lX$) > Wwidth%
                Glupak% = Wwidth%
                Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                    InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                    If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                    'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                    Glupak% = Glupak% - 1
                    If Glupak% = 0 Then
                        AssumeLineIsWrappable = 0
                        pgdlines = 0
                        GoTo B4TxpanarVIRTUAL2
                    End If
                Loop
                lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                pgdlines = pgdlines + 1
            Loop
            pgdlines = pgdlines + 1 ' don't forget the last chunk/remainder
            ReDim xgrams$(1 To pgdlines)

            B4TxpanarVIRTUAL2:
            pgdlines = 0
            If AssumeLineIsWrappable = 1 Then
                lX$ = l$
                Do While Len(lX$) > Wwidth%
                    Glupak% = Wwidth%
                    Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                        InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                        If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                        'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                        Glupak% = Glupak% - 1
                        If Glupak% = 0 Then
                            GoTo B4Txpanar2
                        End If
                    Loop
                    pgdlines = pgdlines + 1
                    xgrams$(pgdlines) = Left$(lX$, Glupak%) 'PRINT #3, LEFT$(lX$, Glupak%)
                    lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                Loop
                pgdlines = pgdlines + 1 ' don't forget the last chunk/remainder
                xgrams$(pgdlines) = lX$ 'PRINT #3, lX$
                B4Txpanar2:
            Else 'unwrappable
                $If WINDOWS Then
                        Play "v20l60aba"
                $End If
            End If

            ']]]
            UpdateNextToCCL_DONE (MostRightField): _Display
            While _MouseInput: Wend

            If pgdlines Then
                Locate 1, 1, 0, CursorS, CursorE
                For i = 1 To YdimROW
                    Locate i, 1: Print Space$(XdimCOL);
                Next

                SCROLLABLEheight = (YdimROW - 2) - 3 + 1

                Locate 1, 1, 0
                Print "Original Current/INVERSE line size: "; AddCommas$(Len(FileArrayFULL$(CurrentLine))); " bytes ";

                For i = 1 To MIN&(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                    Locate i + 2, 1: Print Left$(xgrams$(i), XdimCOL);
                Next

                Print
                Print
                Print "Release Enter (or press Esc)... for vertical scroll use Up/Down, MouseLeftButton/MouseRightButton or Mouse Wheel.";
                _Display

                $If WINDOWS Then
                        Play "v20l20g"
                $End If
                LinesScroled = 0: LinesScroledMAX = pgdlines - SCROLLABLEheight
                Do While InKey$ <> Chr$(27) And IsENTERreleased = 0
                    If pgdlines > SCROLLABLEheight Then
                        AsIfItIsINKEY% = _MouseInput '      Check the mouse status
                        buttondown1 = _MouseButton(1)
                        buttondown2 = _MouseButton(2)
                        buttondown3 = _MouseButton(3)
                        mwheel = _MouseWheel
                        If buttondown2 Or mwheel = 1 Or _KeyDown(DOWNkey&) Then ' as if Down
                            If LinesScroled < LinesScroledMAX Then
                                LinesScroled = LinesScroled + 1
                            End If
                            For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                                Locate i + 2, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
                            Next
                        End If
                        If buttondown1 Or mwheel = -1 Or _KeyDown(UPkey&) Then ' as if Up
                            If LinesScroled > 0 Then
                                LinesScroled = LinesScroled - 1
                            End If
                            For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                                Locate i + 2, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
                            Next
                        End If
                    End If
                    _Limit 50
                    _Display
                Loop
                While _MouseInput: Wend
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If 'IF pgdlines THEN
        End If
        _KeyClear 2 'in order to get rid of all eventual 'Enter' hits during above scrolling
    End If 'IF IsENTERreleased_Flag THEN

    'DO WHILE INKEY$ <> "": LOOP ' have to clear the keyboard buffer
    '_Limit 500 '_LIMIT 30 'commented because the wheel up/down was not working?!
    'Caution: Above line works fine with "mainstream" mouse like a cheap HP 3-button one, but when attaching "game" mouse as White Shark Lancelot, it became superlaggy and unresponsive, maybe due to REPORT RATE aka POLL RATE being high, had to set it to 125Hz in order to work as if "cheap".

    'k$ = InKey$
    'If k$ <> "" Then LastHit~&& = EpochTime~&&: Stepping = 10
    Select Case EpochTime~&& - LastHit~&&
        Case Is > 13 * 60: Stepping = 0 'the 13th minute is maximum idleness
        Case Is > 9 * 60: Stepping = 1
        Case Is > 8 * 60: Stepping = 2
        Case Is > 7 * 60: Stepping = 3
        Case Is > 6 * 60: Stepping = 4
        Case Is > 5 * 60: Stepping = 5
        Case Is > 4 * 60: Stepping = 6
        Case Is > 3 * 60: Stepping = 7
        Case Is > 2 * 60: Stepping = 8
        Case Is > 1 * 60: Stepping = 9
        Case Else
    End Select
    _Limit Int(FramesPerSecond * (Stepping * .1)) + 3 'to avoid 0

Loop 'mainloop ]

End

SetColorScheme:
'Colorscale .000..255:

'0   Black            0             0             0
'1   Dark Blue        0             0             168
'2   Dark Green       0             168           0
'3   Dark Cyan        0             168           168
'4   Dark Red         168           0             0
'5   Dark Magenta     168           0             168
'6   Dark Yellow      168           84            0
'7   Light Grey       168           168           168

'8+0 Dark Grey        84            84            84
'8+1 Blue             84            84            252
'8+2 Green            84            252           84
'8+3 Cyan             84            252           252
'8+4 Red              252           84            84
'8+5 Magenta          252           84            252
'8+6 Yellow           252           252           84
'8+7 White            252           252           252

'Colorscale 00..63:
'0   Black            0      0       0
'1   Dark Blue        0      0      42
'2   Dark Green       0     42       0
'3   Dark Cyan        0     42      42
'4   Dark Red        42      0       0
'5   Dark Magenta    42      0      42
'6   Dark Yellow     42     21       0
'7   Light Grey      42     42      42

'8+0 Dark Grey       21     21      21
'8+1 Blue            21     21      63
'8+2 Green           21     63      21
'8+3 Cyan            21     63      63
'8+4 Red             63     21      21
'8+5 Magenta         63     21      63
'8+6 Yellow          63     63      21
'8+7 White           63     63      63

'Colorscale
_PaletteColor 0, _RGB32(0, 0, 0)
_PaletteColor 1, _RGB32(0, 0, 168)
_PaletteColor 2, _RGB32(0, 168, 0)
_PaletteColor 3, _RGB32(0, 168, 168)
_PaletteColor 4, _RGB32(168, 0, 0)
_PaletteColor 5, _RGB32(168, 0, 168)
_PaletteColor 6, _RGB32(168, 84, 0)
_PaletteColor 7, _RGB32(168, 168, 168)

_PaletteColor 8, _RGB32(84, 84, 84)
_PaletteColor 9, _RGB32(84, 84, 252)
_PaletteColor 10, _RGB32(84, 252, 84)
_PaletteColor 11, _RGB32(84, 252, 252)
_PaletteColor 12, _RGB32(252, 84, 84)
_PaletteColor 13, _RGB32(252, 84, 252)
_PaletteColor 14, _RGB32(252, 252, 84)
_PaletteColor 15, _RGB32(252, 252, 252)

_PaletteColor 3, _RGB32(0, 168 - 10, 168 - 10) 'darker Cyan
_PaletteColor 8, _RGB32(84 - 22, 84 - 22, 84 - 22) 'make Grey darker

_PaletteColor 4, _RGB32(110, 2, 25) 'Carminish
_PaletteColor 4 + 8, _RGB32(110 + 44, 2 + 44, 25 + 44) 'make Carmin more lighter

_PaletteColor 1, _RGB32(168 - 20, 84 - 20, 0) 'make the Amber more darker
_PaletteColor 6 + 8, _RGB32(168 + 54, 84 + 54, 0) 'make the Amber more lighter

' Change the Purple to SteelBlue
_PaletteColor 5, _RGB32(33, 99, 122)
_PaletteColor 5 + 8, _RGB32(33 + 44, 99 + 44, 122 + 44)
' Change the Green to Cyanish
_PaletteColor 2, _RGB32(1, 80, 80)
_PaletteColor 2 + 8, _RGB32(1 + 44, 80 + 44, 80 + 44)

Return

UpdateColors:
For ii = 0 To 15 ' Choosing not to alter BLACK color ... maybe channels with 000 also...
    NewR% = Asc(Mid$(RGB3x16$, 3 * ii + 1, 1))
    NewG% = Asc(Mid$(RGB3x16$, 3 * ii + 2, 1))
    NewB% = Asc(Mid$(RGB3x16$, 3 * ii + 3, 1))
    If NewR% Then
        If NewR% + rChannel% + Brightness% <= 0 Then
            NewR% = 1
        ElseIf NewR% + rChannel% + Brightness% > 63 Then
            NewR% = 63
        Else
            NewR% = NewR% + rChannel% + Brightness%
        End If
    End If
    If NewG% Then
        If NewG% + gChannel% + Brightness% <= 0 Then
            NewG% = 1
        ElseIf NewG% + gChannel% + Brightness% > 63 Then
            NewG% = 63
        Else
            NewG% = NewG% + gChannel% + Brightness%
        End If
    End If
    If NewB% Then
        If NewB% + bChannel% + Brightness% <= 0 Then
            NewB% = 1
        ElseIf NewB% + bChannel% + Brightness% > 63 Then
            NewB% = 63
        Else
            NewB% = NewB% + bChannel% + Brightness%
        End If
    End If
    _PaletteColor ii, _RGB32(NewR% * 4, NewG% * 4, NewB% * 4)
Next

'SimulateBlinking& = Not SimulateBlinking&
'If SimulateBlinking& = 0 Then
Locate 38, 2: Color 0, 7: Print "Note1: Press 'r|g|b' or 'R|G|B' keys to decrease/increase the respective channel by one point, i|I for Brightness, Esc.";
Locate 39, 2: Color 0, 7: Print "Note2: In order to have your own color scheme, you can manually change the values of 'Masakari.RGB' (3x16 bytes long).";
Locate 40, 2: Color 0, 7: Print Using "Note3: WYSIWYG, 'Masakari.RGB' has been updated with rChannel%/gChannel%/bChannel%/Brightness% = ####/####/####/####"; rChannel%, gChannel%, bChannel%, Brightness%;
'Else
'Locate 38, 2: Color 15, 7: Print "Note1: Press 'r|g|b' or 'R|G|B' keys to respectively decrease/increase the respective channel by one point.";
'Locate 39, 2: Color 15, 7: Print "Note2: In order to have your own color scheme, you can manually change the values of 'Masakari.RGB' (3x16 bytes long).";
'End If
RGB3x16new$ = Space$(3 * 16)
For ii = 0 To 15
    Out &H3C7, ii 'set color attribute to read
    red = Inp(&H3C9) '* 4 'multiply by 4 to convert intensity to 0 to 255 RGB values
    grn = Inp(&H3C9) '* 4
    blu = Inp(&H3C9) '* 4
    Mid$(RGB3x16new$, 3 * ii + 1, 1) = Chr$(red)
    Mid$(RGB3x16new$, 3 * ii + 2, 1) = Chr$(grn)
    Mid$(RGB3x16new$, 3 * ii + 3, 1) = Chr$(blu)
Next
For i = 1 To 6
    Dummy$ = DrawBoxShadowDUMMY$(i, 2 + (i - 1) * 6, 2, 6 + (i - 1) * 6, 116, "Dummy window with background color" + Str$(i) + " = " + Hex2$(Asc(Mid$(RGB3x16new$, 3 * i + 1, 1))) + Hex2$(Asc(Mid$(RGB3x16new$, 3 * i + 2, 1))) + Hex2$(Asc(Mid$(RGB3x16new$, 3 * i + 3, 1))) + ", +8 = " + Hex2$(Asc(Mid$(RGB3x16new$, 3 * (i + 8) + 1, 1))) + Hex2$(Asc(Mid$(RGB3x16new$, 3 * (i + 8) + 2, 1))) + Hex2$(Asc(Mid$(RGB3x16new$, 3 * (i + 8) + 3, 1))))
Next
GoSub UpdateColorSchemeFile

Return

UpdateColorSchemeFile:
f00 = FreeFile
Open "Masakari.RGB" For Binary As #f00
RGB3x16new$ = Space$(3 * 16)
For ii = 0 To 15
    Out &H3C7, ii 'set color attribute to read
    red = Inp(&H3C9) '* 4 'multiply by 4 to convert intensity to 0 to 255 RGB values
    grn = Inp(&H3C9) '* 4
    blu = Inp(&H3C9) '* 4
    Mid$(RGB3x16new$, 3 * ii + 1, 1) = Chr$(red)
    Mid$(RGB3x16new$, 3 * ii + 2, 1) = Chr$(grn)
    Mid$(RGB3x16new$, 3 * ii + 3, 1) = Chr$(blu)
Next
Put #f00, , RGB3x16new$
Close #f00
Return

Sub ReturnCOMBO
    Shared LSHIFT_RSHIFT
    Shared LCTRL_RCTRL
    Shared LALT_RALT

    Shared LALT_HOME
    Shared LALT_END

    Shared LALT_INS
    Shared LALT_DEL

    Shared LALT_PGUP
    Shared LALT_PGDN

    Shared LALT_Left
    Shared LALT_Right
    Shared LALT_Up
    Shared LALT_Down

    Shared RALT_HOME
    Shared RALT_END

    Shared RALT_INS
    Shared RALT_DEL

    Shared RALT_PGUP
    Shared RALT_PGDN

    Shared RALT_Left
    Shared RALT_Right
    Shared RALT_Up
    Shared RALT_Down

    Shared LSHIFT_HOME
    Shared LSHIFT_END

    Shared LSHIFT_INS
    Shared LSHIFT_DEL

    Shared LSHIFT_PGUP
    Shared LSHIFT_PGDN

    Shared LSHIFT_Left
    Shared LSHIFT_Right
    Shared LSHIFT_Up
    Shared LSHIFT_Down

    Shared RSHIFT_HOME
    Shared RSHIFT_END

    Shared RSHIFT_INS
    Shared RSHIFT_DEL

    Shared RSHIFT_PGUP
    Shared RSHIFT_PGDN

    Shared RSHIFT_Left
    Shared RSHIFT_Right
    Shared RSHIFT_Up
    Shared RSHIFT_Down

    Shared LCTRL_HOME
    Shared LCTRL_END

    Shared LCTRL_INS
    Shared LCTRL_DEL

    Shared LCTRL_PGUP
    Shared LCTRL_PGDN

    Shared LCTRL_Left
    Shared LCTRL_Right
    Shared LCTRL_Up
    Shared LCTRL_Down

    Shared RCTRL_HOME
    Shared RCTRL_END

    Shared RCTRL_INS
    Shared RCTRL_DEL

    Shared RCTRL_PGUP
    Shared RCTRL_PGDN

    Shared RCTRL_Left
    Shared RCTRL_Right
    Shared RCTRL_Up
    Shared RCTRL_Down

    Shared LSHIFT_LCTRL_HOME
    Shared LSHIFT_LCTRL_END

    Shared LSHIFT_LCTRL_INS
    Shared LSHIFT_LCTRL_DEL

    Shared LSHIFT_LCTRL_PGUP
    Shared LSHIFT_LCTRL_PGDN

    Shared LSHIFT_LCTRL_Left
    Shared LSHIFT_LCTRL_Right
    Shared LSHIFT_LCTRL_Up
    Shared LSHIFT_LCTRL_Down

    Shared LSHIFT_BackSpace
    Shared LSHIFT_TAB
    Shared LSHIFT_SPACE
    Shared LSHIFT_ESC
    Shared LSHIFT_ENTER

    Shared RSHIFT_BackSpace
    Shared RSHIFT_TAB
    Shared RSHIFT_SPACE
    Shared RSHIFT_ESC
    Shared RSHIFT_ENTER

    Shared LCTRL_SPACE
    Shared LCTRL_ENTER

    Shared RCTRL_SPACE
    Shared RCTRL_ENTER

    If _KeyDown(LSHIFTkey&) And _KeyDown(RSHIFTkey&) Then LSHIFT_RSHIFT = 1 Else LSHIFT_RSHIFT = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(RCTRLkey&) Then LCTRL_RCTRL = 1 Else LCTRL_RCTRL = 0
    If _KeyDown(LALTkey&) And _KeyDown(RALTkey&) Then LALT_RALT = 1 Else LALT_RALT = 0

    'LALT:
    If _KeyDown(LALTkey&) And _KeyDown(HOMEkey&) Then LALT_HOME = 1 Else LALT_HOME = 0
    If _KeyDown(LALTkey&) And _KeyDown(ENDkey&) Then LALT_END = 1 Else LALT_END = 0

    If _KeyDown(LALTkey&) And _KeyDown(INSkey&) Then LALT_INS = 1 Else LALT_INS = 0
    If _KeyDown(LALTkey&) And _KeyDown(DELkey&) Then LALT_DEL = 1 Else LALT_DEL = 0

    If _KeyDown(LALTkey&) And _KeyDown(PGUPkey&) Then LALT_PGUP = 1 Else LALT_PGUP = 0
    If _KeyDown(LALTkey&) And _KeyDown(PGDNkey&) Then LALT_PGDN = 1 Else LALT_PGDN = 0

    If _KeyDown(LALTkey&) And _KeyDown(LEFTkey&) Then LALT_Left = 1 Else LALT_Left = 0
    If _KeyDown(LALTkey&) And _KeyDown(RIGHTkey&) Then LALT_Right = 1 Else LALT_Right = 0
    If _KeyDown(LALTkey&) And _KeyDown(UPkey&) Then LALT_Up = 1 Else LALT_Up = 0
    If _KeyDown(LALTkey&) And _KeyDown(DOWNkey&) Then LALT_Down = 1 Else LALT_Down = 0

    'RALT:
    If _KeyDown(RALTkey&) And _KeyDown(HOMEkey&) Then RALT_HOME = 1 Else RALT_HOME = 0
    If _KeyDown(RALTkey&) And _KeyDown(ENDkey&) Then RALT_END = 1 Else RALT_END = 0

    If _KeyDown(RALTkey&) And _KeyDown(INSkey&) Then RALT_INS = 1 Else RALT_INS = 0
    If _KeyDown(RALTkey&) And _KeyDown(DELkey&) Then RALT_DEL = 1 Else RALT_DEL = 0

    If _KeyDown(RALTkey&) And _KeyDown(PGUPkey&) Then RALT_PGUP = 1 Else RALT_PGUP = 0
    If _KeyDown(RALTkey&) And _KeyDown(PGDNkey&) Then RALT_PGDN = 1 Else RALT_PGDN = 0

    If _KeyDown(RALTkey&) And _KeyDown(LEFTkey&) Then Print RALT_Left = 1 Else RALT_Left = 0
    If _KeyDown(RALTkey&) And _KeyDown(RIGHTkey&) Then RALT_Right = 1 Else RALT_Right = 0
    If _KeyDown(RALTkey&) And _KeyDown(UPkey&) Then RALT_Up = 1 Else RALT_Up = 0
    If _KeyDown(RALTkey&) And _KeyDown(DOWNkey&) Then RALT_Down = 1 Else RALT_Down = 0
    'LSHIFT:
    If _KeyDown(LSHIFTkey&) And _KeyDown(HOMEkey&) Then LSHIFT_HOME = 1 Else LSHIFT_HOME = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(ENDkey&) Then LSHIFT_END = 1 Else LSHIFT_END = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(INSkey&) Then LSHIFT_INS = 1 Else LSHIFT_INS = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(DELkey&) Then LSHIFT_DEL = 1 Else LSHIFT_DEL = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(PGUPkey&) Then LSHIFT_PGUP = 1 Else LSHIFT_PGUP = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(PGDNkey&) Then LSHIFT_PGDN = 1 Else LSHIFT_PGDN = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LEFTkey&) Then LSHIFT_Left = 1 Else LSHIFT_Left = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(RIGHTkey&) Then LSHIFT_Right = 1 Else LSHIFT_Right = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(UPkey&) Then LSHIFT_Up = 1 Else LSHIFT_Up = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(DOWNkey&) Then LSHIFT_Down = 1 Else LSHIFT_Down = 0

    'RSHIFT:
    If _KeyDown(RSHIFTkey&) And _KeyDown(HOMEkey&) Then RSHIFT_HOME = 1 Else RSHIFT_HOME = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(ENDkey&) Then RSHIFT_END = 1 Else RSHIFT_END = 0

    If _KeyDown(RSHIFTkey&) And _KeyDown(INSkey&) Then RSHIFT_INS = 1 Else RSHIFT_INS = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(DELkey&) Then RSHIFT_DEL = 1 Else RSHIFT_DEL = 0

    If _KeyDown(RSHIFTkey&) And _KeyDown(PGUPkey&) Then RSHIFT_PGUP = 1 Else RSHIFT_PGUP = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(PGDNkey&) Then RSHIFT_PGDN = 1 Else RSHIFT_PGDN = 0

    If _KeyDown(RSHIFTkey&) And _KeyDown(LEFTkey&) Then RSHIFT_Left = 1 Else RSHIFT_Left = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(RIGHTkey&) Then RSHIFT_Right = 1 Else RSHIFT_Right = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(UPkey&) Then RSHIFT_Up = 1 Else RSHIFT_Up = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(DOWNkey&) Then RSHIFT_Down = 1 Else RSHIFT_Down = 0

    'LCTRL:
    If _KeyDown(LCTRLkey&) And _KeyDown(HOMEkey&) Then LCTRL_HOME = 1 Else LCTRL_HOME = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(ENDkey&) Then LCTRL_END = 1 Else LCTRL_END = 0

    If _KeyDown(LCTRLkey&) And _KeyDown(INSkey&) Then LCTRL_INS = 1 Else LCTRL_INS = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(DELkey&) Then LCTRL_DEL = 1 Else LCTRL_DEL = 0

    If _KeyDown(LCTRLkey&) And _KeyDown(PGUPkey&) Then LCTRL_PGUP = 1 Else LCTRL_PGUP = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(PGDNkey&) Then LCTRL_PGDN = 1 Else LCTRL_PGDN = 0

    If _KeyDown(LCTRLkey&) And _KeyDown(LEFTkey&) Then LCTRL_Left = 1 Else LCTRL_Left = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(RIGHTkey&) Then LCTRL_Right = 1 Else LCTRL_Right = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(UPkey&) Then LCTRL_Up = 1 Else LCTRL_Up = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(DOWNkey&) Then LCTRL_Down = 1 Else LCTRL_Down = 0

    'RCTRL:
    If _KeyDown(RCTRLkey&) And _KeyDown(HOMEkey&) Then RCTRL_HOME = 1 Else RCTRL_HOME = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(ENDkey&) Then RCTRL_END = 1 Else RCTRL_END = 0

    If _KeyDown(RCTRLkey&) And _KeyDown(INSkey&) Then RCTRL_INS = 1 Else RCTRL_INS = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(DELkey&) Then RCTRL_DEL = 1 Else RCTRL_DEL = 0

    If _KeyDown(RCTRLkey&) And _KeyDown(PGUPkey&) Then RCTRL_PGUP = 1 Else RCTRL_PGUP = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(PGDNkey&) Then RCTRL_PGDN = 1 Else RCTRL_PGDN = 0

    If _KeyDown(RCTRLkey&) And _KeyDown(LEFTkey&) Then RCTRL_Left = 1 Else RCTRL_Left = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(RIGHTkey&) Then RCTRL_Right = 1 Else RCTRL_Right = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(UPkey&) Then RCTRL_Up = 1 Else RCTRL_Up = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(DOWNkey&) Then RCTRL_Down = 1 Else RCTRL_Down = 0

    'LSHIFT+LCTRL: NOTICE: LSHIFT+LCTRL+Left triggers 3 variables on - 1] LSHIFT_LCTRL_Left 2] LSHIFT_Left 3] LCTRL_Left
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(HOMEkey&) Then LSHIFT_LCTRL_HOME = 1 Else LSHIFT_LCTRL_HOME = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(ENDkey&) Then LSHIFT_LCTRL_END = 1 Else LSHIFT_LCTRL_END = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(INSkey&) Then LSHIFT_LCTRL_INS = 1 Else LSHIFT_LCTRL_INS = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(DELkey&) Then LSHIFT_LCTRL_DEL = 1 Else LSHIFT_LCTRL_DEL = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(PGUPkey&) Then LSHIFT_LCTRL_PGUP = 1 Else LSHIFT_LCTRL_PGUP = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(PGDNkey&) Then LSHIFT_LCTRL_PGDN = 1 Else LSHIFT_LCTRL_PGDN = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(LEFTkey&) Then LSHIFT_LCTRL_Left = 1 Else LSHIFT_LCTRL_Left = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(RIGHTkey&) Then LSHIFT_LCTRL_Right = 1 Else LSHIFT_LCTRL_Right = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(UPkey&) Then LSHIFT_LCTRL_Up = 1 Else LSHIFT_LCTRL_Up = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(DOWNkey&) Then LSHIFT_LCTRL_Down = 1 Else LSHIFT_LCTRL_Down = 0

    'LSHIFT:
    If _KeyDown(LSHIFTkey&) And _KeyDown(BACKSPCkey&) Then LSHIFT_BackSpace = 1 Else LSHIFT_BackSpace = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(TABkey&) Then LSHIFT_TAB = 1 Else LSHIFT_TAB = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(SPACEkey&) Then LSHIFT_SPACE = 1 Else LSHIFT_SPACE = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(ESCkey&) Then LSHIFT_ESC = 1 Else LSHIFT_ESC = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(ENTERkey&) Then LSHIFT_ENTER = 1 Else LSHIFT_ENTER = 0
    'RSHIFT:
    If _KeyDown(RSHIFTkey&) And _KeyDown(BACKSPCkey&) Then RSHIFT_BackSpace = 1 Else RSHIFT_BackSpace = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(TABkey&) Then RSHIFT_TAB = 1 Else RSHIFT_TAB = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(SPACEkey&) Then RSHIFT_SPACE = 1 Else RSHIFT_SPACE = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(ESCkey&) Then RSHIFT_ESC = 1 Else RSHIFT_ESC = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(ENTERkey&) Then RSHIFT_ENTER = 1 Else RSHIFT_ENTER = 0

    'LCTRL:
    If _KeyDown(LCTRLkey&) And _KeyDown(SPACEkey&) Then LCTRL_SPACE = 1 Else LCTRL_SPACE = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(ENTERkey&) Then LCTRL_ENTER = 1 Else LCTRL_ENTER = 0
    'RCTRL:
    If _KeyDown(RCTRLkey&) And _KeyDown(SPACEkey&) Then RCTRL_SPACE = 1 Else RCTRL_SPACE = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(ENTERkey&) Then RCTRL_ENTER = 1 Else RCTRL_ENTER = 0

    '_KEYCLEAR
End Sub

Sub ExpandTabsFULL (l$)
    Shared XdimCOL
    If InStr(l$, Chr$(9)) Then
        TabV% = 8
        b$ = "": f& = 0
        PossibleRecalculation = Len(l$)
        'FOR i& = 1 TO MIN&(PossibleRecalculation, XdimCOL) 'LEN(l$) ' For some reason going all the length is too slow...?! As it is, the lateral scroll is crippled!
        For i& = 1 To PossibleRecalculation
            RemoveSpecial$ = Mid$(l$, i&, 1)
            If RemoveSpecial$ = Chr$(9) Then
                b$ = b$ + String$((f& \ TabV%) * TabV% + TabV% - f&, " ")
                '  |
                '  |
                ' \|/
                'TabV% - (f% - (f% \ TabV%) * TabV%) =
                'TabV% - (f% MOD TabV%)
                f& = (f& \ TabV%) * TabV% + TabV%
            Else
                b$ = b$ + RemoveSpecial$ 'MID$(l$, i&, 1)
                f& = f& + 1
            End If
        Next
        l$ = b$
    End If
End Sub

Sub ExpandTabs (l$)
    Shared XdimCOL
    If InStr(l$, Chr$(9)) Then
        TabV% = 8
        b$ = "": f& = 0
        PossibleRecalculation = Len(l$)
        For i& = 1 To MIN&(PossibleRecalculation, XdimCOL) 'LEN(l$) ' For some reason going all the length is too slow...?! As it is, the lateral scroll is crippled!
            RemoveSpecial$ = Mid$(l$, i&, 1)
            If RemoveSpecial$ = Chr$(9) Then
                b$ = b$ + String$((f& \ TabV%) * TabV% + TabV% - f&, " ")
                '  |
                '  |
                ' \|/
                'TabV% - (f% - (f% \ TabV%) * TabV%) =
                'TabV% - (f% MOD TabV%)
                f& = (f& \ TabV%) * TabV% + TabV%
            Else
                b$ = b$ + RemoveSpecial$ 'MID$(l$, i&, 1)
                f& = f& + 1
            End If
        Next
        l$ = b$
    End If
End Sub

Function MIN& (YdimROW, filecount)
    If YdimROW < filecount Then MIN& = YdimROW Else MIN& = filecount
End Function

Function AddCommas$ (numeral)
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    AddCommas$ = LTrim$(s$)
End Function

Function AddCommasPaddedNUM$ (numeral)
    Shared FieldLineNum
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = Right$("000,000,000,000", FieldLineNum)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedNUM$ = Padded$
End Function

Function AddCommasPaddedLEN$ (numeral)
    Shared FieldLineLen
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = Right$("000,000,000,000", FieldLineLen)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedLEN$ = Padded$
End Function

Sub UpdateCLL (l, posit)
    Shared YdimROW ', FileArray$()
    crx = Pos(0)
    cry = CsrLin
    Locate YdimROW + 1, posit: Color 9, 0
    'PRINT "; Line Number: " + AddCommasPaddedNUM$(l);
    Print "; Line: " + AddCommasPaddedNUM$(l);
    'PRINT "; Line Length: " + AddCommasPaddedLEN$(LEN(FileArrayFULL$(l))); 'fix with 'FULL' from jun-02
    Print "; Linesize: " + AddCommasPaddedLEN$(Len(FileArrayFULL$(l))); 'fix with 'FULL' from jun-02
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub UpdateNextToCCL_BUSY (posit)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0);
    Locate YdimROW + 1, posit: Color 9, 0: Print "; Status: BUSY";
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub UpdateNextToCCL_DONE (posit)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0); 'STRING$((XdimCOL - posit) - 1, " ");
    Locate YdimROW + 1, posit: Color 9, 0: Print "; Status: DONE";
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub UpdateNextToCCL_UNWRAPPABLEcount (posit)
    Shared XdimCOL
    Shared YdimROW
    Shared UnwrappableLines
    crx = Pos(0)
    cry = CsrLin
    Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0);
    Locate YdimROW + 1, posit: Color 9, 0: Print "; Unwrappable Lines: " + AddCommas$(UnwrappableLines);
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub UpdateCLine (lineToWrite, columnToWrite, FRGR, BACKGR, ln)
    Shared FileArrayWINDOW$()
    Shared XdimCOL
    Shared CurrentWord$
    crx = Pos(0)
    cry = CsrLin
    Color FRGR, BACKGR
    Locate lineToWrite, columnToWrite, 1, CursorS, CursorE
    Print FileArrayWINDOW$(ln);
    'get the word under the cursor [
    LeftM = crx: RightM = crx 'both can go within 1..XdimCOL
    CurrentChar$ = Mid$(FileArrayWINDOW$(ln), LeftM, 1)
    If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
        Do While LeftM > 1
            CurrentChar$ = Mid$(FileArrayWINDOW$(ln), LeftM - 1, 1)
            If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
                LeftM = LeftM - 1
            Else
                Exit Do
            End If
        Loop
        Do While RightM < XdimCOL
            CurrentChar$ = Mid$(FileArrayWINDOW$(ln), RightM + 1, 1)
            If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
                RightM = RightM + 1
            Else
                Exit Do
            End If
        Loop
    End If
    If RightM - LeftM > 0 Then CurrentWord$ = Mid$(FileArrayWINDOW$(ln), LeftM, RightM - LeftM + 1) Else CurrentWord$ = ""
    'get the word under the cursor ]
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub UpdateCLineHIGHLIGHTword (lineToWrite, columnToWrite, FRGR, BACKGR, ln)
    Shared FileArrayWINDOW$()
    Shared XdimCOL
    Shared CurrentWord$
    crx = Pos(0)
    cry = CsrLin
    Color FRGR, BACKGR
    Locate lineToWrite, columnToWrite, 1, CursorS, CursorE
    Print FileArrayWINDOW$(ln);
    'get the word under the cursor [
    LeftM = crx: RightM = crx 'both can go within 1..XdimCOL
    CurrentChar$ = Mid$(FileArrayWINDOW$(ln), LeftM, 1)
    If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
        Do While LeftM > 1
            CurrentChar$ = Mid$(FileArrayWINDOW$(ln), LeftM - 1, 1)
            If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
                LeftM = LeftM - 1
            Else
                Exit Do
            End If
        Loop
        Do While RightM < XdimCOL
            CurrentChar$ = Mid$(FileArrayWINDOW$(ln), RightM + 1, 1)
            If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
                RightM = RightM + 1
            Else
                Exit Do
            End If
        Loop
    End If
    If RightM - LeftM > 0 Then CurrentWord$ = Mid$(FileArrayWINDOW$(ln), LeftM, RightM - LeftM + 1) Else CurrentWord$ = ""
    If CurrentWord$ <> "" Then
        Color 7 + 8, BACKGR
        For qq = LeftM To RightM
            Locate cry, qq, 1, CursorS, CursorE
            Print Mid$(FileArrayWINDOW$(ln), qq, 1);
        Next
    End If
    'get the word under the cursor ]
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub UpdateWindowFrame (FRGR, BACKGR)
    Shared YdimROW, filecount, File_Frame_y, File_Frame_x, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    Color FRGR, BACKGR
    If YdimROW > filecount Then
        For i = 1 To YdimROW
            Locate i, 1: Print Space$(XdimCOL);
        Next
    End If
    For i = 1 To MIN&(YdimROW, filecount)
        DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        If Len(DumboReadOnceNotThrice$) >= XdimCOL Then
            FileArrayWINDOW$(i) = Mid$(DumboReadOnceNotThrice$, File_Frame_x, XdimCOL)
        Else
            FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + Space$(XdimCOL - Len(DumboReadOnceNotThrice$))
        End If
        'since r.8 the goal is to browse properly binary/.tar files
        'FOR j = 1 TO LEN(FileArrayWINDOW$(i))
        'since r.9 the goal is to browse properly German/Spanish/French/Italian files, SO COMMENTING OUT:
        'IF MID$(FileArrayWINDOW$(i), j, 1) < " " THEN MID$(FileArrayWINDOW$(i), j, 1) = CHR$(32)
        'NEXT
        Locate i, 1: Print FileArrayWINDOW$(i);
    Next
End Sub

Sub ReportTimeToLoad (posit)
    Shared YdimROW, XdimCOL
    Shared TimeA, TimeB
    crx = Pos(0)
    cry = CsrLin
    ElapsedTime% = TimeB - TimeA
    If ElapsedTime% < 0 Then ElapsedTime% = (86400 - TimeA) + TimeB
    Paddedstr$ = "; Loaded in " + LTrim$(Str$(ElapsedTime%)) + " seconds."
    '     P=6
    '[123456] (8-P)-1=2 ' 2021-Jul-26, ugh, the fix is without '-1' because P is not 5 but 6!
    Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0);
    Locate YdimROW + 1, posit: Color 4, 0: Print Paddedstr$;
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub ReportTimeToScroll (posit)
    Shared YdimROW, XdimCOL
    Shared TimeScrollA, TimeScrollB
    Shared LineScrollBenchmark
    Shared PageScrollBenchmark
    Shared filecount
    crx = Pos(0)
    cry = CsrLin
    ElapsedTime% = TimeScrollB - TimeScrollA
    If ElapsedTime% < 0 Then ElapsedTime% = (86400 - TimeScrollA) + TimeScrollB
    If ElapsedTime% = 0 Then ElapsedTime% = 1
    'Line-By-Line or Line granularity Scroll Rate; LPS stands for Lines-Per-Second
    'Page-By-Page or Page granularity Scroll Rate; PPS stands for Pages-Per-Second
    Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0);
    If XdimCOL = 213 Then
        If LineScrollBenchmark = 1 Then Locate YdimROW + 1, posit: Color 4, 0: Print "; DOWNed in"; ElapsedTime%; "seconds, or "; AddCommasPaddedLEN$(filecount / ElapsedTime%); " LPS";
        If PageScrollBenchmark = 1 Then Locate YdimROW + 1, posit: Color 4, 0: Print "; PGDNed in"; ElapsedTime%; "seconds, or "; AddCommasPaddedLEN$((filecount / YdimROW) / ElapsedTime%); " PPS";
    Else
        If LineScrollBenchmark = 1 Then Locate YdimROW + 1, posit: Color 4, 0: Print "; DOWNed in"; ElapsedTime%; "seconds.";
        If PageScrollBenchmark = 1 Then Locate YdimROW + 1, posit: Color 4, 0: Print "; PGDNed in"; ElapsedTime%; "seconds.";
    End If
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Function FileArrayFULL$ (i)
    Shared QWORD, LineLen13
    'SHARED TheWholeFile$
    _MemGet MhandleOFF, MhandleOFF.OFFSET + 8&& * (i - 1), QWORD
    _MemGet MhandleLEN, MhandleLEN.OFFSET + 8&& * (i - 1), LineLen13
    If ToLoadOrNotFlag Then
        'BufferForLine$ = MID$(TheWholeFile$, QWORD, LineLen13)
        BufferForLine$ = Space$(LineLen13)
        _MemGet Mwholefile, Mwholefile.OFFSET + (QWORD - 1), BufferForLine$
    Else
        BufferForLine$ = Space$(LineLen13)
        Seek #1, QWORD
        Get #1, , BufferForLine$
    End If
    'ExpandTabs (BufferForLine$)
    FileArrayFULL$ = BufferForLine$
End Function

Function FileArray$ (i)
    Shared QWORD, LineLen13
    'SHARED TheWholeFile$
    _MemGet MhandleOFF, MhandleOFF.OFFSET + 8&& * (i - 1), QWORD
    _MemGet MhandleLEN, MhandleLEN.OFFSET + 8&& * (i - 1), LineLen13
    If ToLoadOrNotFlag Then
        'BufferForLine$ = MID$(TheWholeFile$, QWORD, LineLen13)
        BufferForLine$ = Space$(LineLen13)
        _MemGet Mwholefile, Mwholefile.OFFSET + (QWORD - 1), BufferForLine$
    Else
        BufferForLine$ = Space$(LineLen13)
        Seek #1, QWORD
        Get #1, , BufferForLine$
    End If
    ExpandTabs (BufferForLine$)
    FileArray$ = BufferForLine$
End Function

Sub ShowIndigoWindow
    'COLOR 8, 0: LOCATE i, 1 + LEN(FileArrayWINDOW$(i)): PRINT CHR$(179);: COLOR FRGR, BACKGR
End Sub

'http://rosettacode.org/wiki/Levenshtein_distance#FutureBasic
'FutureBasic
'Based on Wikipedia algorithm. Suitable for Pascal strings.

'include "ConsoleWindow"

'local fn LevenshteinDistance( aStr as Str255, bStr as Str255 ) as long
'dim as long m, n, i, j, min, k, l
'dim as long distance( 255, 255 )

'm = len(aStr)
'n = len(bStr)

'for i = 0 to m
'   distance( i, 0 ) = i
'next

'for j = 0 to n
'   distance( 0, j ) = j
'next

'for j = 1 to n
'   for i = 1 to m
'      if mid$( aStr, i, 1 ) == mid$( bStr, j, 1 )
'         distance( i, j ) = distance( i-1, j-1 )
'      else
'         min = distance( i-1, j   ) + 1
'         k   = distance( i, j - 1 ) + 1
'         l   = distance( i-1, j-1 ) + 1
'         if k < min then min = k
'         if l < min then min = l
'         distance( i, j ) = min
'     end if
'   next
'next
'end fn = distance( m, n )

'dim as long i
'dim as Str255 testStr( 5, 2 )

'testStr( 0, 0 ) = "kitten"      : testStr( 0, 1 ) = "sitting"
'testStr( 1, 0 ) = "rosettacode" : testStr( 1, 1 ) = "raisethysword"
'testStr( 2, 0 ) = "Saturday"    : testStr( 2, 1 ) = "Sunday"
'testStr( 3, 0 ) = "FutureBasic" : testStr( 3, 1 ) = "FutureBasic"
'testStr( 4, 0 ) = "here's a bunch of words"
'testStr( 4, 1 ) = "to wring out this code"

'for i = 0 to 4
'   print "1st string = "; testStr( i, 0 )
'   print "2nd string = "; testStr( i, 1 )
'   print "Levenshtein distance ="; fn LevenshteinDistance( testStr( i, 0 ), testStr( i, 1 ) )
'   print
'next

'Output:

'1st string = kitten
'2nd string = sitting
'Levenshtein distance = 3

'1st string = rosettacode
'2nd string = raisethysword
'Levenshtein distance = 8

'1st string = Saturday
'2nd string = Sunday
'Levenshtein distance = 3

'1st string = FutureBasic
'2nd string = FutureBasic
'Levenshtein distance = 0

'1st string = here's a bunch of words
'2nd string = to wring out this code
'Levenshtein distance = 18

'In information theory and computer science, the Levenshtein distance is a metric for measuring the amount of difference between two sequences (i.e. an edit distance). The Levenshtein distance between two strings is defined as the minimum number of edits needed to transform one string into the other, with the allowable edit operations being insertion, deletion, or substitution of a single character.

Sub DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 4
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    If YdimROW = 40 Then shrunkP = 14 Else shrunkP = 0
    Locate TopLrow + 38 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 39 - shrunkP To TopLrow + 40 - shrunkP
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate TopLrow + 40 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    'PRINT " _  __                  _"
    'PRINT "| |/ / __ _  ____ __ _ | |__    __ _  _ __    __ _"
    'PRINT "| ' / / _` ||_  // _` || '_ \  / _` || '_ \  / _` |"
    'PRINT "| . \| (_| | / /| (_| || | | || (_| || | | || (_| |"
    'PRINT "|_|\_\\__,_|/___|\__,_||_| |_| \__,_||_| |_| \__,_|"
    Color 7, BckGRcolor
    Print " ____  __.                        .__"
    Locate , TopLcol + 2
    Print "|    |/ _|_____   _____________   |  |__  _____     ____  _____"
    Locate , TopLcol + 2
    Print "|      <  \__  \  \___   /\__  \  |  |  \ \__  \   /    \ \__  \"
    Locate , TopLcol + 2
    Print "|    |  \  / __ \_ /    /  / __ \_|   Y  \ / __ \_|   |  \ / __ \_"
    Locate , TopLcol + 2
    Print "|____|__ \(____  //_____ \(____  /|___|  /(____  /|___|  /(____  /"
    Locate , TopLcol + 2
    Print "        \/     \/       \/     \/      \/      \/      \/      \/"
    Locate , TopLcol + 2
    Print ""

    Locate , TopLcol + 2
    Print "A typhoon-class exact & wildcards & Levenshtein Distance (Wagner-Fischer) searcheress"
    Print ""
    Locate , TopLcol + 2
    Print "Note1: The dump (resultant hits) goes to Kazahana.txt file."
    Locate , TopLcol + 2
    Print "Note2: Nine SLOW wildcards are available:"
    Locate , TopLcol + 2
    Print "       wildcard '*' any character(s) or empty,"
    Locate , TopLcol + 2
    Print "       wildcard '.' any ALPHA character(s) or empty,"
    Locate , TopLcol + 2
    Print "       wildcard '`' any NON-ALPHA character(s) or empty,"
    Locate , TopLcol + 2
    Print "       wildcard '@'/'#' any character {or empty}/{and not empty},"
    Locate , TopLcol + 2
    Print "       wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},"
    Locate , TopLcol + 2
    Print "       wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty}."
    Locate , TopLcol + 2
    Print "Note3: Two FAST wildcards are available:"
    Locate , TopLcol + 2
    Print "       wildcard '&' any character(s) or empty,"
    Locate , TopLcol + 2
    Print "       wildcard '+' any character and not empty."
    Locate , TopLcol + 2
    Print "Note4: Don't mix SLOW and FAST, the SLOW overrides the FAST. Also, 1 byte exact pattern, not allowed."
    If shrunkP = 0 Then
        Locate , TopLcol + 2
        Print "Exact Case-Sensitive 16-threaded search for all lines up to 26208 chars long:"
        Locate , TopLcol + 2
        Print "Example1: Arnold"
        Locate , TopLcol + 2
        Print "Example2: "; Chr$(34); "metal fatigue"; Chr$(34)
        Locate , TopLcol + 2
        Print "Wildcard Case-Insensitive 16-threaded search for all lines up to 26208 chars long:"
        Locate , TopLcol + 2
        Print "Example3: "; Chr$(34); "out^^^^^^^^^^^^^ize*"; Chr$(34)
        Locate , TopLcol + 2
        Print "          Possible hits within a line starting with O|o: outhyperbolize, OUTSIZE, outsized"
        Locate , TopLcol + 2
        Print "NORMAL/EXHAUSTIVE Fuzzy Case-Insensitive 16-threaded search for all lines up to 156/26208 chars long:"
        Locate , TopLcol + 2
        Print "Example4: 3 psychedlicize"
        Locate , TopLcol + 2
        Print "          This line '1234psychedlicize' won't match."
        Locate , TopLcol + 2
        Print "Example5: 2e edelvais"
        Locate , TopLcol + 2
        Print "          Possible hits: edelweiss, edelweisses, psychedelicism"
        Locate , TopLcol + 2
        Print "Note5: Levenshtein search can be NORMAL, as in Example4, matching the whole line."
        Locate , TopLcol + 2
        Print "Note6: Levenshtein search can be EXHAUSTIVE, as in Example5, if LD is postfixed with 'e',"
        Locate , TopLcol + 2
        Print "       matching each position in the line."
        Locate , TopLcol + 2
        Print "Note7: The Needle/Pattern below is set by default as the Current_Word or the CLIPBOARD."
    End If
    Color 7, BckGRcolor
    HelpLine$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc"
    Locate TopLrow + 41 - shrunkP, TopLcol + 2: Print HelpLine$
    _Display
    AddToKazahana$ = InputLine$(TopLrow + 39 - shrunkP, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    StartSt$ = Date$ + " " + Time$
    Locate TopLrow + 41 - shrunkP, TopLcol + 2: Print String$(Len(HelpLine$), " ")
    Locate TopLrow + 41 - shrunkP, TopLcol + 2: Print "Start: "; StartSt$
    Locate 1, 1, 0, CursorS, CursorE
    _Display

    TimeK1# = Timer(.01)
    $If WINDOWS Then
            Print #13, Chr$(34) + PSPlike$ + "Kazahana.exe" + Chr$(34) + " " + AddToKazahana$ + " " + Chr$(34) + LoadedFile$ + Chr$(34) + " 30539"
    $End If
    $If WINDOWS Then
            'SHELL _DONTWAIT _HIDE CHR$(34) + PSPlike$ + "Kazahana_Hexadecad_GCC_472_SSE41_32bit.exe" + CHR$(34) + " " + AddToKazahana$ + " " + CHR$(34) + LoadedFile$ + CHR$(34) + " 1539" '9 is odd therefore no dump of pattern field, 9 is bigger than 4 therefore case insensitive wildcard search.
            Shell _Hide Chr$(34) + PSPlike$ + "Kazahana.exe" + Chr$(34) + " " + AddToKazahana$ + " " + Chr$(34) + LoadedFile$ + Chr$(34) + " 30539" '9 is odd therefore no dump of pattern field, 9 is bigger than 4 therefore case insensitive wildcard search.
    $Else
        Shell _Hide Chr$(34) + PSPlike$ + "kazahana" + Chr$(34) + " " + AddToKazahana$ + " " + Chr$(34) + LoadedFile$ + Chr$(34) + " 30539" '9 is odd therefore no dump of pattern field, 9 is bigger than 4 therefore case insensitive wildcard search.
    $End If
    TimeK2# = Timer(.01)
    SearchTime! = TimeK2# - TimeK1#
    If SearchTime! < 0 Then SearchTime! = (86400 - TimeK1#) + TimeK2#
    Locate TopLrow + 42 - shrunkP, TopLcol + 2: Print "Ready: "; Date$ + " " + Time$
    f = FreeFile
    Open "Kazahana.txt" For Binary As #f
    KazLen = LOF(f)
    Close #f
    SearchRate = FileSize / (SearchTime! + 0.0001)
    Locate TopLrow + 43 - shrunkP, TopLcol + 2: Print "Size of Kazahana.txt: "; AddCommas$(KazLen); " bytes"; "; Search-and-Dump Speed: "; AddCommas$(SearchRate); " bytes/s";
    Locate TopLrow + 44 - shrunkP, TopLcol + 2: Print "Press Esc...";
    _Display
    $If WINDOWS Then
            Play "v20l20g"
    $End If
    Do While InKey$ <> Chr$(27)
        _Limit 30
    Loop
    Locate 1, 1, 1, CursorS, CursorE

    'E:\_KAZE_Smxrt_Benchmarks\QB64_kit_v1.4_2.48 GB\qb64>Kazahana_Hexadecad_GCC_472_SSE41_32bit.exe
    'Kazahana, a typhoon-class exact & wildcards & Levenshtein Distance (Wagner-Fischer) searcher, r. 1-++fix+nowait_critical_nixFIX_Wolfram+fixITER+EX+CS_fix_DEFINE_Trolldom, copyleft Kaze 2019-May-21.
    'Usage: Kazahana [AtMostLevenshteinDistance][e] string textualfile MasterBufferSize
    'Note0: MasterBufferSize is in KB, consider 1024, 3072, 7168 or bigger (up to 2GB). Three additional flags were mapped on this value: all dump
    '       lines (except fuzzy's) will have/lack pattern-source info when the number is even/odd respectively, see Examples #5 and #6.
    '       When MasterBufferSize ends in 0, then No-Dump i.e. hits are only counted.
    'Note0a: Caution! Reported hits are not actual ones but all LINES containing a hit (or hits), e.g. for pattern 'Boom' a line as 'Boom-Boom!' yields one hit not two.
    'Note1: There are three regimes: exact, wildcards and fuzzy searches. First two kick in when 3 parameters are given, fuzzy when 4.
    'Note2: What decides whether exact or wildcards? Of course presence of at least one wildcard. To see exact search see Example #4.
    'Note3: Exact search hits with 'Railgun_Trolldom', not 'Railgun_Sekireigan_Wolfram'.
    'Note4a: Incoming string is automatically lowercased for fuzzy searches i.e. they are case insensitive.
    'Note4b: Incoming string is NOT automatically lowercased for wildcards searches when MasterBufferSize ends in 0..4 i.e. they are case sensitive.
    'Note4c: Incoming string is automatically lowercased for wildcards searches when MasterBufferSize ends in 5..9 i.e. they are case insensitive.
    'Note5: Incoming string could be up to 26208/156 chars for Exact&Wildcard&ExhaustiveFuzzy/Fuzzy respectively.
    'Note5a: Since 2013-Nov-21 Levenshtein search exits not when the incoming line is bigger than 156 chars, now it just skips longer lines.
    'Note5b: Since 2013-Dec-05 Levenshtein search can be EXHAUSTIVE if LD is postfixed with 'e'.
    'Note6: Incoming textualfile could be bigger than 4GB.
    'Note7: Each line should end with [CR]LF, that is Windows or/and UNIX style.
    'Note8: The dump goes to Kazahana.txt file.
    'Note9a: Nine SLOW wildcards are available:
    '        wildcard '*' any character(s) or empty,
    '        wildcard '.' any ALPHA character(s) or empty,
    '        wildcard '`' any NON-ALPHA character(s) or empty,
    '        wildcard '@'/'#' any character {or empty}/{and not empty},
    '        wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},
    '        wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty}.
    'Note9b: Two FAST wildcards are available:
    '        wildcard '&' any character(s) or empty,
    '        wildcard '+' any character and not empty.
    'Note9c: Don't mix SLOW and FAST, the SLOW overrides the FAST, i.e. presence of at least one of the 9 wildcards cancels FAST mode.
    'Example1: E:\>Kazahana 0 ramjet MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd 1536
    'Example2: E:\>Kazahana 3 psychedlicize MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd 1536
    'Example3: E:\>Kazahana "psyched^^^^^^ize^" MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd 1536
    'Example4: E:\>Kazahana "metal fatigue" enwiki-20121201-pages-articles.xml 7168
    'Example5: E:\>Kazahana "out^^^^^^^^^^^^^ize*" MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd 1536
    '          E:\>type Kazahana.txt
    '          [out^^^^^^^^^^^^^ize*] outhyperbolize /MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd/
    '          [out^^^^^^^^^^^^^ize*] outsize /MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd/
    '          [out^^^^^^^^^^^^^ize*] outsized /MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd/
    '          [out^^^^^^^^^^^^^ize*] outstrategize /MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd/
    '          [out^^^^^^^^^^^^^ize*] outtyrannize /MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd/
    'Example6: E:\>Kazahana "out^^^^^^^^^^^^^ize*" MASAKARI_General-Purpose_Grade_English_Wordlist_r3_316423_words.wrd 1537
    '          E:\>type Kazahana.txt
    '          outhyperbolize
    '          outsize
    '          outsized
    '          outstrategize
    '          outtyrannize
    'Example7: E:\>Kazahana 2e edelvais MASAKARI_General-Purpose_Grade_English_Wordlist.wrd 1024
    '          E:\>type Kazahana.txt
    '          bordelais
    '          bordelaise
    '          edelweiss
    '          edelweisses
    '          foredevised
    '          predellas
    '          psychedelicism
    'Info1: One second seems to have 1,000 clocks.

    'E:\_KAZE_Smxrt_Benchmarks\QB64_kit_v1.4_2.48 GB\qb64>
End Sub


Function DrawBoxShadowDUMMY$ (BckGRcolor, TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 14 'BckGRcolor * 6
    Locate TopLrow + 38 - 23 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 39 - 23 - shrunkP To TopLrow + 40 - 23 - shrunkP
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate TopLrow + 40 - 23 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    Color 7, BckGRcolor

    HelpLine$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc"
    Locate TopLrow + 41 - 23 - shrunkP, TopLcol + 3: Print HelpLine$
    Color 0, BckGRcolor
    Locate TopLrow + 41 - 23 - shrunkP, TopLcol + 2: Print "["
    Locate TopLrow + 41 - 23 - shrunkP, TopLcol + 3 + Len(HelpLine$): Print "]"
    Color BckGRcolor, 0: Locate TopLrow + 41 - 23 - shrunkP - 2, TopLcol + 2: Print "Background ";: Color BckGRcolor + 8, 0: Print "Background+8";: Color , BckGRcolor: Color 0: Print " COLOR #00 ";: Color 8: Print " COLOR #08 ";: Color 9: Print " COLOR #09 ";: Color 10: Print " COLOR #10 ";: Color 11: Print " COLOR #11 ";: Color 12: Print " COLOR #12 ";: Color 13: Print " COLOR #13 ";: Color 14: Print " COLOR #14 ";
    _Display
    DrawBoxShadowDUMMY$ = InKey$
    Locate 1, 1, 1, CursorS, CursorE

End Function

Function DrawBoxShadow3exact$ (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 6
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 14
    Locate TopLrow + 38 - 23 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 39 - 23 - shrunkP To TopLrow + 40 - 23 - shrunkP
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate TopLrow + 40 - 23 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    Color 7, BckGRcolor

    HelpLine$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc"
    Locate TopLrow + 41 - 23 - shrunkP, TopLcol + 2: Print HelpLine$
    _Display
    DrawBoxShadow3exact$ = InputLine$(TopLrow + 39 - 23 - shrunkP, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    Locate 1, 1, 1, CursorS, CursorE

End Function

Function DrawBoxShadow3exactRussian$ (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 5
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 14
    Locate TopLrow + 38 - 23 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 39 - 23 - shrunkP To TopLrow + 40 - 23 - shrunkP
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate TopLrow + 40 - 23 - shrunkP, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    Color 7, BckGRcolor

    HelpLine$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc"
    Locate TopLrow + 41 - 23 - shrunkP, TopLcol + 2: Print HelpLine$
    _Display
    DrawBoxShadow3exactRussian$ = InputLineRussian$(TopLrow + 39 - 23 - shrunkP, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    Locate 1, 1, 1, CursorS, CursorE

End Function

Function InputLine$ (Irow, Icol, LineLen)
    Static a$
    Shared CurrentWord$
    Locate Irow, Icol, 1, CursorS, CursorE
    MaxCol = Icol + LineLen - 1
    CurCol = Icol 'Icol..MaxCol
    'IF CurrentWord$ = "" THEN
    '    IF INSTR(_CLIPBOARD$, CHR$(10)) THEN '_CLIPBOARD$ could be multi-line, so get the first
    '        a2$ = LEFT$(_CLIPBOARD$, INSTR(_CLIPBOARD$, CHR$(10)) - 1)
    '        IF RIGHT$(a2$, 1) = CHR$(13) THEN a2$ = LEFT$(a2$, LEN(a2$) - 1)
    '        a$ = LEFT$(a2$, LineLen - 1) '""
    '    ELSE
    '        a$ = LEFT$(_CLIPBOARD$, LineLen - 1) '""
    '    END IF
    '    CurCol = Icol + LEN(a$)
    'ELSE
    '    a$ = CurrentWord$
    'END IF
    Do
        key$ = InKey$
        If key$ <> "" Then
            code% = Asc(key$):
            If code% Then ' ASC returns any value greater than 0
                Select Case Asc(key$)
                    Case 27:
                        a$ = "": CurCol = Icol
                    Case 13:
                        If a$ <> "" Then Exit Do
                    Case 8: 'Backspace
                        If CurCol <> Icol Then
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = Left$(a$, Len(a$) - 1)
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                a$ = Left$(a$, (CurCol - Icol) - 1) + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol - 1
                        End If
                    Case 32 To 127 - 1:
                        If Len(a$) < LineLen - 1 Then 'a$ = a$ + key$: CurCol = CurCol + 1 '-1 because cursor goes next to the field otherwise
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = a$ + key$
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                ' Insert at (CurCol - Icol) + 1:
                                a$ = Left$(a$, (CurCol - Icol)) + key$ + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol + 1
                        End If
                End Select
            Else
                Select Case Asc(key$, 2)
                    Case 75: If CurCol > Icol Then CurCol = CurCol - 1
                    Case 77: If CurCol < MaxCol And CurCol < Icol + Len(a$) Then CurCol = CurCol + 1
                    Case 71: CurCol = Icol 'Home
                    Case 79: CurCol = Icol + Len(a$) 'End
                    Case 83: 'Del
                        If a$ <> "" Then
                            a$ = Left$(a$, (CurCol - Icol)) + Right$(a$, Len(a$) - (CurCol - Icol) - 1)
                        End If
                    Case 82: 'Ins
                End Select
            End If
        End If
        Locate Irow, Icol, 1, CursorS, CursorE
        Print String$(LineLen, " ");
        Locate Irow, Icol, 1, CursorS, CursorE
        Print a$;
        Locate Irow, CurCol, 1, CursorS, CursorE
        _Display
        _Limit 30
    Loop
    'DO WHILE _KEYDOWN(13): LOCATE , , 0: _DISPLAY: LOOP
    _KeyClear
    InputLine$ = a$
End Function

Function InputLineRussian$ (Irow, Icol, LineLen)
    Static a$
    Shared CurrentWord$
    Locate Irow, Icol, 1, CursorS, CursorE
    MaxCol = Icol + LineLen - 1
    CurCol = Icol 'Icol..MaxCol
    'IF CurrentWord$ = "" THEN
    '    IF INSTR(_CLIPBOARD$, CHR$(10)) THEN '_CLIPBOARD$ could be multi-line, so get the first
    '        a2$ = LEFT$(_CLIPBOARD$, INSTR(_CLIPBOARD$, CHR$(10)) - 1)
    '        IF RIGHT$(a2$, 1) = CHR$(13) THEN a2$ = LEFT$(a2$, LEN(a2$) - 1)
    '        a$ = LEFT$(a2$, LineLen - 1) '""
    '    ELSE
    '        a$ = LEFT$(_CLIPBOARD$, LineLen - 1) '""
    '    END IF
    '    CurCol = Icol + LEN(a$)
    'ELSE
    '    a$ = CurrentWord$
    'END IF
    Do
        key$ = InKey$
        If key$ <> "" Then
            code% = Asc(key$):
            If code% Then ' ASC returns any value greater than 0
                Select Case Asc(key$)
                    Case 27:
                        a$ = "": CurCol = Icol
                    Case 13:
                        If a$ <> "" Then Exit Do
                    Case 8: 'Backspace
                        If CurCol <> Icol Then
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = Left$(a$, Len(a$) - 1)
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                a$ = Left$(a$, (CurCol - Icol) - 1) + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol - 1
                        End If
                    Case 32 To 127 - 1:
                        k$ = key$
                        If k$ = "~" Then k$ = Chr$(250)
                        If k$ = "`" Then k$ = Chr$(251)

                        If k$ = "+" Then k$ = Chr$(154)
                        If k$ = "=" Then k$ = Chr$(234)

                        If k$ = "Q" Then k$ = Chr$(159)
                        If k$ = "q" Then k$ = Chr$(239)

                        If k$ = "W" Then k$ = Chr$(152)
                        If k$ = "w" Then k$ = Chr$(232)

                        If k$ = "E" Then k$ = Chr$(133)
                        If k$ = "e" Then k$ = Chr$(165)

                        If k$ = "R" Then k$ = Chr$(144)
                        If k$ = "r" Then k$ = Chr$(224)

                        If k$ = "T" Then k$ = Chr$(146)
                        If k$ = "t" Then k$ = Chr$(226)

                        If k$ = "Y" Then k$ = Chr$(155)
                        If k$ = "y" Then k$ = Chr$(235)

                        If k$ = "U" Then k$ = Chr$(147)
                        If k$ = "u" Then k$ = Chr$(227)

                        If k$ = "I" Then k$ = Chr$(136)
                        If k$ = "i" Then k$ = Chr$(168)

                        If k$ = "O" Then k$ = Chr$(142)
                        If k$ = "o" Then k$ = Chr$(174)

                        If k$ = "P" Then k$ = Chr$(143)
                        If k$ = "p" Then k$ = Chr$(175)

                        If k$ = "{" Then k$ = Chr$(158)
                        If k$ = "[" Then k$ = Chr$(238)

                        If k$ = "}" Then k$ = Chr$(153)
                        If k$ = "]" Then k$ = Chr$(233)

                        If k$ = "|" Then k$ = Chr$(157)
                        If k$ = "\" Then k$ = Chr$(237)

                        If k$ = "A" Then k$ = Chr$(128)
                        If k$ = "a" Then k$ = Chr$(160)

                        If k$ = "S" Then k$ = Chr$(145)
                        If k$ = "s" Then k$ = Chr$(225)

                        If k$ = "D" Then k$ = Chr$(132)
                        If k$ = "d" Then k$ = Chr$(164)

                        If k$ = "F" Then k$ = Chr$(148)
                        If k$ = "f" Then k$ = Chr$(228)

                        If k$ = "G" Then k$ = Chr$(131)
                        If k$ = "g" Then k$ = Chr$(163)

                        If k$ = "H" Then k$ = Chr$(151)
                        If k$ = "h" Then k$ = Chr$(231)

                        If k$ = "J" Then k$ = Chr$(137)
                        If k$ = "j" Then k$ = Chr$(169)

                        If k$ = "K" Then k$ = Chr$(138)
                        If k$ = "k" Then k$ = Chr$(170)

                        If k$ = "L" Then k$ = Chr$(139)
                        If k$ = "l" Then k$ = Chr$(171)

                        If k$ = ":" Then k$ = Chr$(156)
                        If k$ = ";" Then k$ = Chr$(236)

                        If k$ = Chr$(34) Then k$ = Chr$(134)
                        If k$ = "'" Then k$ = Chr$(166)

                        If k$ = "Z" Then k$ = Chr$(135)
                        If k$ = "z" Then k$ = Chr$(167)

                        If k$ = "X" Then k$ = Chr$(149)
                        If k$ = "x" Then k$ = Chr$(229)

                        If k$ = "C" Then k$ = Chr$(150)
                        If k$ = "c" Then k$ = Chr$(230)

                        If k$ = "V" Then k$ = Chr$(130)
                        If k$ = "v" Then k$ = Chr$(162)

                        If k$ = "B" Then k$ = Chr$(129)
                        If k$ = "b" Then k$ = Chr$(161)

                        If k$ = "N" Then k$ = Chr$(141)
                        If k$ = "n" Then k$ = Chr$(173)

                        If k$ = "M" Then k$ = Chr$(140)
                        If k$ = "m" Then k$ = Chr$(172)

                        key$ = k$
                        If Len(a$) < LineLen - 1 Then 'a$ = a$ + key$: CurCol = CurCol + 1 '-1 because cursor goes next to the field otherwise
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = a$ + key$
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                ' Insert at (CurCol - Icol) + 1:
                                a$ = Left$(a$, (CurCol - Icol)) + key$ + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol + 1
                        End If
                End Select
            Else
                Select Case Asc(key$, 2)
                    Case 75: If CurCol > Icol Then CurCol = CurCol - 1
                    Case 77: If CurCol < MaxCol And CurCol < Icol + Len(a$) Then CurCol = CurCol + 1
                    Case 71: CurCol = Icol 'Home
                    Case 79: CurCol = Icol + Len(a$) 'End
                    Case 83: 'Del
                        If a$ <> "" Then
                            a$ = Left$(a$, (CurCol - Icol)) + Right$(a$, Len(a$) - (CurCol - Icol) - 1)
                        End If
                    Case 82: 'Ins
                End Select
            End If
        End If
        Locate Irow, Icol, 1, CursorS, CursorE
        Print String$(LineLen, " ");
        Locate Irow, Icol, 1, CursorS, CursorE
        Print a$;
        Locate Irow, CurCol, 1, CursorS, CursorE
        _Display
        _Limit 30
    Loop
    'DO WHILE _KEYDOWN(13): LOCATE , , 0: _DISPLAY: LOOP
    _KeyClear
    InputLineRussian$ = a$
End Function

Sub NextFrame (TopRow)
    Shared ASCIIFrame
    Shared PSPlike$
    Locate TopRow, 73
    ASCIIFrame = ASCIIFrame + 1
    If ASCIIFrame > 20 Then ASCIIFrame = 1 '1..20
    f = FreeFile
    fr$ = LTrim$(Str$(ASCIIFrame))
    If Len(fr$) = 1 Then fr$ = "0" + fr$
    If _FileExists(PSPlike$ + "glass" + fr$ + ".txt") Then
        Open PSPlike$ + "glass" + fr$ + ".txt" For Input As #f
        Do While Not EOF(f)
            Line Input #f, a$
            Locate , 73
            Print a$
        Loop
        Close #f
    End If
End Sub

Sub NextFramePEN (TopRow)
    Shared ASCIIFramePEN
    Shared PSPlike$
    Shared XdimCOL
    If XdimCOL = 213 Then HorizPos = 128 Else HorizPos = 70
    Locate TopRow, HorizPos
    ASCIIFramePEN = ASCIIFramePEN + 1
    If ASCIIFramePEN > 24 Then ASCIIFramePEN = 1 '1..20
    f = FreeFile
    fr$ = LTrim$(Str$(ASCIIFramePEN))
    If Len(fr$) = 1 Then fr$ = "0" + fr$
    If _FileExists(PSPlike$ + "pen" + fr$ + ".txt") Then
        Open PSPlike$ + "pen" + fr$ + ".txt" For Input As #f
        Do While Not EOF(f)
            Line Input #f, a$
            Locate , HorizPos
            Print Right$(a$, 80 - 23)
        Loop
        Close #f
    End If
End Sub

Sub ShowF1
    Shared Mrev$
    PostFix$ = ""
    'IF ToLoadOrNotFlag = 0 THEN PostFix$ = PostFix$ + "_External" ELSE PostFix$ = PostFix$ + "_Fast"
    If WrapFlag = 1 Then PostFix$ = PostFix$ + "_Wrapper" Else PostFix$ = PostFix$ + "_Vanilla"
    Print "Masakari, revision " + Mrev$ + PostFix$ + ", written in QB64 by Kaze, source code downloadable at https://www.qb64.org/forum"

    $If WINDOWS Then
            Print "Usage: Masakari [filename]|[/help][-ascii[_gesch]]"
    $Else
        Print "Usage: Masakari [filename]|[-h][-ascii[_gesch]]"
    $End If
    Print "Note: The 'filename' could be a filelist, i.e. a list of filenames (see Space and Double-Left-Click)."
    Print "Mouse:"
    Print "   Button 1 - sets the cursor and the inverse line to the chosen position; hold (without moving for 4 seconds) to quit"
    Print "   Button 2 - [when holded] Draws; Button 3 - Burst PgDn; Wheel Up/Dn - Up/Dn"
    Print "   Button 2 + Wheel Up/Dn - going to the top/bottom left position"
    Print "   Button 1 + Button 2 - creating PAGODA file for the Current_Word, the loaded file must be in Current Directory!"
    Print "   Button 2 + dragging (sideways) for at least 100 columns/cells (within 2 seconds) - same as Alt+X, Alt+Q"
    Print "   Button 2 + dragging (from top to bottom) for at least 5 lines/cells (within 2 seconds) - same as PgUp"
    Print "   Button 2 + dragging (from bottom to top) for at least 5 lines/cells (within 2 seconds) - same as PgDn"
    Print "   Button 1 + Button 1 (within 0.33 seconds) - Double-Left-Click - PgUp or loads the inverse line (if it is a valid file)"
    Print "   Button 2 + Button 2 (within 0.33 seconds) - Double-Right-Click - PgDn"
    Print "   LShift + Button 1/2 - Burst Up/Dn; LCtrl + Button 1/2 - Burst PgUp/PgDn"
    Print "   LAlt + Button 1/2 = LCtrl+Home - going to the top left position / LCtrl+End - going to the bottom left position"
    Print "Keyboard:"
    Print "   F1 - this help panel; Enter (released) - opens the current/INVERSE line, WRAPPED, into a new scroll window"
    Print "   Up/Dn/PgUp/PgDn; LALT+Up - colour tweaking; LALT+Down - set greyscale mode"
    Print "   LShift+1=! released - Sort by LENGTH of lines; LShift+2=@ released - Sort by OFFSET of lines"
    Print "   Ctrl+Home/End - going to the top/bottom left position; F11 - Oxford ED; F12 - Etymology OD; F10 - Schizandrafield"
    Print "   Alt+X or Alt+Q - quit to the system, without demanding keypress"
    Print "   Space - loads the highlighted line (if it is an actual filename)"
    Print "   Double_LALTkey - highlighting all unfamiliar words to masakari.wrd file/wordlist"
    Print "   LCtrl+F3 - Search Panel, Kazahana (with 16 threads) searches Externally the file, currently displayed"
    Print "   LAlt+F3 released - Non-Interactive search for Current_Word, from the line below the INVERSE one, downward"
    Print "   LShift+F3 released - Non-Interactive search for CLIPBOARD, from the line below the INVERSE one, downward"
    Print "   F2/F3 released - Search Panel, Interactive search for User_Input, from the line below the INVERSE one, downward"
    'Note: The [LShift+]F3 search modes are Exact and Case-Sensitive, non-whole word as well
    Print "Benchmarking:"
    Print "       LAlt+RAlt - Reporting (in the status line in red color) the time for load"
    Print "       LCtrl+RCtrl - Reporting (in the status line in red color) the time for PgDn-ing (page-by-page) the entire file"
    Print "       LShift+RShift - Reporting (in the status line in red color) the time for Down-ing (line-by-line) the entire file"
    Print "       Esc - Stops the auto-scrolling started with LCtrl+RCtrl or LShift+RShift"
    Print "Note1: During the LShift+RShift (or LCtrl+RCtrl) auto-scroll, you can still press/hold RCtrl (same as Double_LALTkey)."
    Print "Note2: During the auto-scroll, you can still press PgUp, PgDn, Ctrl+Home, Ctrl+End, Esc."
    Print "Note3: The 'Vanilla' sub-variant loads textual files without wrapping the lines."
    Print "Note4: The 'Wrapper' sub-variant makes the text file viewable without side/lateral scroll."
    Print "       If unwrappable lines exist then those lines are dumped to filename+"; Chr$(34); ".unwrappable"; Chr$(34); ","
    Print "       otherwise, the wrapped lines are dumped to filename+"; Chr$(34); ".wrapped"; Chr$(34); ", and auto-loaded."
    Print "       If wrapped file exists during start then it is used, not re-created."
End Sub

Function timeElapsedSince! (startTime!)
    If startTime! > Timer Then startTime! = startTime! - 86400
    timeElapsedSince! = Timer - startTime!
End Function

Function CROPorPADatRIGHT$ (victim$, linelen)
    If Len(victim$) > linelen Then
        CROPorPADatRIGHT$ = Left$(victim$, linelen)
    Else
        CROPorPADatRIGHT$ = victim$ + Space$(linelen - Len(victim$))
    End If
End Function

'CONST LSHIFTkey& = 100304
'DO
'    IF _KEYDOWN(LSHIFTkey&) = 0 AND IsF3released THEN PRINT "F3 released ";
'    _LIMIT 500
'LOOP
Function IsF3released
    IsF3released = 0
    MustBeLONGssigned& = _KeyHit
    If MustBeLONGssigned& Then
        If MustBeLONGssigned& < 0 Then 'negative value means key released
            MustBeLONGssigned& = -MustBeLONGssigned&
            If MustBeLONGssigned& \ 256 = 61 Then
                IsF3released = 1
            Else
            End If
        End If
    End If
End Function

Function IsENTERreleased
    IsENTERreleased = 0
    MustBeLONGssigned& = _KeyHit
    If MustBeLONGssigned& Then
        If MustBeLONGssigned& < 0 Then 'negative value means key released
            MustBeLONGssigned& = -MustBeLONGssigned&
            If MustBeLONGssigned& = 13 Then
                IsENTERreleased = 1
            Else
            End If
        End If
    End If
End Function

'' NASTY BEHAVIOR!? Still puzzled as to why the code below prematurely exits (for 'Enter') while working for F2 or F3?!
'k$ = INPUT$(1)
'DO 'WHILE _KEYDOWN(13) 'why the hell it is not working when 'while' is uncommented?!
'    'PRINT "" 'the dummy print doesn't fix the premature exit
'    PRINT _KEYDOWN(13) 'why the hell it is working ONLY for a while when 'print' is commented?! With it, it works.
'    IF _KEYDOWN(13) = 0 THEN EXIT DO
'LOCATE , , 0: _DISPLAY: LOOP
'PRINT k$
'END

'' kinda fix above mess
'k$ = INPUT$(1)
'DO 'inhere we are already with Enter pressed
'    xbug = _KEYHIT
'    'IF xbug < 0 THEN 'negative value means key released
'LOOP UNTIL xbug < 0

Sub UpdateNextToCCL_F3 (posit)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0);
    Locate YdimROW + 1, posit: Color 9 - (2), 0: Print "; Status: F2/F3 Searching...";
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub ShowASCIIart
    Print "___  ___                    _                 _                       _____     _____        "
    Print "|  \/  |                   | |               (_)                     |  _  |   / __  \       "
    Print "| .  . |  __ _  ___   __ _ | | __ __ _  _ __  _    _ __  ___ __   __  \ V /    `' / /'   _   "
    Print "| |\/| | / _` |/ __| / _` || |/ // _` || '__|| |  | '__|/ _ \\ \ / /  / _ \      / /   _| |_ "
    Print "| |  | || (_| |\__ \| (_| ||   <| (_| || |   | |  | |  |  __/ \ V /_ | |_| | _ ./ /___|_   _|"
    Print "\_|  |_/ \__,_||___/ \__,_||_|\_\\__,_||_|   |_|  |_|   \___|  \_/(_)\_____/(_)\_____/  |_|  "
    Print
End Sub

Sub dict01sub
    Shared CurrentWord$
    Const EntryHead = 35
    Const RecordLen = EntryHead + 8 + 8 + 2 '35+2+8+8
    Dim dict01_lfixed As String * EntryHead
    Dim dict01_lfixedCRLF As String * RecordLen
    dict01_TotalWrd& = 0

    dict01$ = "dict2txt_Online_Etymology_Dictionary1.1.txt"
    f01 = FreeFile
    Open dict01$ For Binary As #f01
    If LOF(f01) Then

        f02 = FreeFile
        Open dict01$ + ".ind" For Binary As #f02 'LEN = 35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX
        Do While Not EOF(f01)
            EntryStartAddr& = Seek(f01)
            Line Input #f01, l$
            EntryLen = Seek(f01)
            'IF INSTR(l$, CHR$(9)) > 35 THEN PRINT l$
            If InStr(l$, Chr$(9)) Then
                dict01_lfixed$ = Left$(l$, InStr(l$, Chr$(9)) - 1)
                dict01_lfixedCRLF$ = dict01_lfixed$ + PADzeros$(Hex$(EntryStartAddr&)) + PADzeros$(Hex$(EntryLen - EntryStartAddr&)) + Chr$(13) + Chr$(10)
                Put #f02, , dict01_lfixedCRLF$: dict01_TotalWrd& = dict01_TotalWrd& + 1
                'PRINT "EntryStartAddr/EntryLen ="; EntryStartAddr&; "/"; EntryLen - EntryStartAddr&
                '_DELAY .01
            End If
        Loop
        Close #f01, #f02
        Print "Total entries for '"; dict01$; "':"; dict01_TotalWrd&
        Print "CurrentWord$: "; CurrentWord$
        Shell _Hide "CMD /C sort " + dict01$ + ".ind" + " > " + "sorted_" + dict01$ + ".ind"
        f01 = FreeFile
        Open dict01$ For Binary As #f01
        f02 = FreeFile
        Open "sorted_" + dict01$ + ".ind" For Random Access Read As #f02 Len = RecordLen '35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX

        'testing 537 line:
        'alimentary                         00025E8D00000118
        'PhysicalLine& = 19001 '537

        ' BINARY SEARCH [
        UCurrentWord$ = LCase$(CurrentWord$)
        WRDpos& = 0
        LeftPoint& = 1
        RightPoint& = dict01_TotalWrd&
        Do
            If RightPoint& - LeftPoint& <= 1 Then 'Sxsedtcheta
                Get #f02, LeftPoint&, dict01_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Left$(dict01_lfixedCRLF$, EntryHead))) Then WRDpos& = LeftPoint&: Exit Do
                Get #f02, RightPoint&, dict01_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Left$(dict01_lfixedCRLF$, EntryHead))) Then WRDpos& = RightPoint&: Exit Do
                WRDpos& = LeftPoint& 'THIS IS BECAUSE I NEED NEAREST word not zero!
                Exit Do
            End If
            SplitPoint& = (LeftPoint& + RightPoint&) \ 2
            Get #f02, SplitPoint&, dict01_lfixedCRLF$
            If UCurrentWord$ < LCase$(RTrim$(Left$(dict01_lfixedCRLF$, EntryHead))) Then
                RightPoint& = SplitPoint&
            ElseIf UCurrentWord$ > LCase$(RTrim$(Left$(dict01_lfixedCRLF$, EntryHead))) Then
                LeftPoint& = SplitPoint&
            Else
                WRDpos& = SplitPoint&: Exit Do
            End If
        Loop
        If WRDpos& <> 0 Then
            Do While WRDpos& > 1
                WRDpos& = WRDpos& - 1
                Get #f02, WRDpos&, dict01_lfixedCRLF$
                If UCurrentWord$ <> LCase$(RTrim$(Left$(dict01_lfixedCRLF$, EntryHead))) Then
                    WRDpos& = WRDpos& + 1
                    Exit Do
                End If
            Loop
            'IF WRDpos& <= TotalWrd& - 16 THEN FL2wrd& = WRDpos& ELSE FL2wrd& = TotalWrd& - 16
        End If
        ' BINARY SEARCH ]

        $If WINDOWS Then
                Play "v20o2l40gaf"
        $End If

        PhysicalLine& = WRDpos&
        'GET #f02, (PhysicalLine& - 1) * (35 + 2 + 8 + 8) + 1, dict01_lfixedCRLF$ 'when OPENed for BINARY
        Get #f02, PhysicalLine&, dict01_lfixedCRLF$
        EntryAll$ = Space$(dePADzeros&(Mid$(dict01_lfixedCRLF$, (EntryHead + 1) + 8, 8)))
        Get #f01, dePADzeros&(Mid$(dict01_lfixedCRLF$, (EntryHead + 1), 8)), EntryAll$
        Print "EntryHead: "; Left$(EntryAll$, InStr(EntryAll$, Chr$(9)) - 1)
        EntryTail$ = "EntryTail: " + Right$(EntryAll$, Len(EntryAll$) - InStr(EntryAll$, Chr$(9)))
        Print EntryTail$
        'PRINT "[" + EntryAll$ + "]"
        Close #f01, #f02
        _Display
        Do
            key$ = InKey$
            _Limit 60
        Loop Until _KeyDown(27)
    Else
        $If WINDOWS Then
                Play "L16V32O3g-g-<<d+"
        $End If
        Close #f01
    End If 'If LOF(f01) Then
End Sub

' Dictionary_Specification_Language_(ABBYY_Software_House)_Oxford_English_Dictionary_2nd_Edition_Version_4_(En-En)_ANSI.dsl
' Dictionary_Specification_Language_(ABBYY_Software_House)_Webster's_Unabridged_3_(En-En)_UTF-8.dsl
' Machine-Learning_Urban_Dictionary_Definitions_Corpus_(1999_-_May-2016).words.json
Sub dict02sub
    Shared CurrentWord$
    Const dict02_EntryHead = 34
    Const dict02_RecordLen = dict02_EntryHead + 8 + 8 + 2 '34+2+8+8
    Dim dict02_lfixed As String * dict02_EntryHead
    Dim dict02_lfixedCRLF As String * dict02_RecordLen
    dict02_TotalWrd& = 0
    dict02_LongestEnryHead& = 0

    dict02$ = "Dictionary_Specification_Language_(ABBYY_Software_House)_Oxford_English_Dictionary_2nd_Edition_Version_4_(En-En)_ANSI.dsl"
    Rem Caution: One EntryHead could be multi-line!
    Rem 'cellist
    Rem cellist

    If _FileExists(PSPlike$ + "sorted_" + dict02$ + ".ind") = 0 Then 'check for existance [[[
        f01 = FreeFile
        Open dict02$ For Binary As #f01
        If LOF(f01) Then

            f02 = FreeFile
            Open dict02$ + ".ind" For Binary As #f02 'LEN = 35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX
            OldOff& = 1
            Do While Not EOF(f01)
                NewOff& = Seek(f01)
                Line Input #f01, l$
                'IF LEN(l$) > dict02_LongestEnryHead& THEN dict02_LongestEnryHead& = LEN(l$)
                If Left$(l$, 1) = Chr$(9) Then
                Else
                    If OldOff& <> NewOff& Then
                        EntryStartAddr& = OldOff&
                        EntryLen = NewOff& - OldOff&
                        OldOff& = NewOff&
                        dict02_lfixed$ = lprev$
                        dict02_lfixedCRLF$ = dict02_lfixed$ + PADzeros$(Hex$(EntryStartAddr&)) + PADzeros$(Hex$(EntryLen)) + Chr$(13) + Chr$(10)
                        Put #f02, , dict02_lfixedCRLF$: dict02_TotalWrd& = dict02_TotalWrd& + 1
                    End If
                    lprev$ = l$
                End If
            Loop
            'The last entry has no END [
            NewOff& = Seek(f01) ' PRINT NewOff& gives LOF(f01)+1
            EntryStartAddr& = OldOff&
            EntryLen = NewOff& - OldOff&
            OldOff& = NewOff&
            dict02_lfixed$ = lprev$
            dict02_lfixedCRLF$ = dict02_lfixed$ + PADzeros$(Hex$(EntryStartAddr&)) + PADzeros$(Hex$(EntryLen)) + Chr$(13) + Chr$(10)
            Put #f02, , dict02_lfixedCRLF$: dict02_TotalWrd& = dict02_TotalWrd& + 1

            'The last entry has no END ]

            Close #f01, #f02
            'PRINT dict02_LongestEnryHead& ' 34 for OED
            'PRINT "Total entries for '"; dict02$; "':"; dict02_TotalWrd&

            'PRINT "CurrentWord$: "; CurrentWord$
            Shell _Hide "CMD /C sort " + Chr$(34) + dict02$ + ".ind" + Chr$(34) + " > " + Chr$(34) + "sorted_" + dict02$ + ".ind" + Chr$(34)

        Else
            $If WINDOWS Then
                    Play "L16V32O3g-g-<<d+"
            $End If
            Close #f01
        End If 'If LOF(f01) Then
    Else
        dict02_TotalWrd& = 277315
    End If 'check for existance ]]]
    If _FileExists(PSPlike$ + "sorted_" + dict02$ + ".ind") <> 0 Then 'check for existance [[[
        f01 = FreeFile
        Open dict02$ For Binary As #f01
        f02 = FreeFile
        Open "sorted_" + dict02$ + ".ind" For Random Access Read As #f02 Len = dict02_RecordLen '35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX

        'testing 537 line:
        'alimentary                         00025E8D00000118
        'PhysicalLine& = 19001 '537

        ' BINARY SEARCH [
        UCurrentWord$ = LCase$(CurrentWord$)
        WRDpos& = 0
        LeftPoint& = 1
        RightPoint& = dict02_TotalWrd&
        Do
            If RightPoint& - LeftPoint& <= 1 Then 'Sxsedtcheta
                Get #f02, LeftPoint&, dict02_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Left$(dict02_lfixedCRLF$, dict02_EntryHead))) Then WRDpos& = LeftPoint&: Exit Do
                Get #f02, RightPoint&, dict02_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Left$(dict02_lfixedCRLF$, dict02_EntryHead))) Then WRDpos& = RightPoint&: Exit Do
                WRDpos& = LeftPoint& 'THIS IS BECAUSE I NEED NEAREST word not zero!
                Exit Do
            End If
            SplitPoint& = (LeftPoint& + RightPoint&) \ 2
            Get #f02, SplitPoint&, dict02_lfixedCRLF$
            If UCurrentWord$ < LCase$(RTrim$(Left$(dict02_lfixedCRLF$, dict02_EntryHead))) Then
                RightPoint& = SplitPoint&
            ElseIf UCurrentWord$ > LCase$(RTrim$(Left$(dict02_lfixedCRLF$, dict02_EntryHead))) Then
                LeftPoint& = SplitPoint&
            Else
                WRDpos& = SplitPoint&: Exit Do
            End If
        Loop
        If WRDpos& <> 0 Then
            Do While WRDpos& > 1
                WRDpos& = WRDpos& - 1
                Get #f02, WRDpos&, dict02_lfixedCRLF$
                If UCurrentWord$ <> LCase$(RTrim$(Left$(dict02_lfixedCRLF$, dict02_EntryHead))) Then
                    WRDpos& = WRDpos& + 1
                    Exit Do
                End If
            Loop
            'IF WRDpos& <= TotalWrd& - 16 THEN FL2wrd& = WRDpos& ELSE FL2wrd& = TotalWrd& - 16
        End If
        ' BINARY SEARCH ]

        $If WINDOWS Then
                Play "v20o2l20geb"
        $End If
        PhysicalLine& = WRDpos&
        'PhysicalLine& = 277315 '277315 total; WARNING! 61358 is 'dictionary' - cannot be found because words as 'dicarch' confuse the binary search!
        'GET #f02, (PhysicalLine& - 1) * (35 + 2 + 8 + 8) + 1, dict02_lfixedCRLF$ 'when OPENed for BINARY
        Get #f02, PhysicalLine&, dict02_lfixedCRLF$


        ' Scrolling into 3D djamtche [
        'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
        If Len(dict02$) > 70 Then Reduced$ = "..." + Right$(dict02$, 70) Else Reduced$ = dict02$
        Call DrawBoxShadowOED(3 + 3, 3, 35, 125, Reduced$, 2)
        BckGRcolor = 2 '6
        s$ = LTrim$(Str$(PhysicalLine&))
        If Len(s$) > 3 Then
            If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
            s$ = ""
            For i = 1 To Len(x$) Step 3
                s$ = s$ + Mid$(x$, i, 3) + ","
            Next
            s$ = Left$(s$, Len(s$) - 1)
        End If
        s$ = LTrim$(s$)
        Padded$ = "0,000,000,000"
        Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
        Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
        Locate , , 0

        DjamPoolLength = 125 - 3 + 1 - 4
        DjamPoolHeight = 35 - (3 + 3) + 1 - 4
        CurrentPos& = PhysicalLine& ' Notice that CurrentPos& = 1..(dict02_TotalWrd& - DjamPoolHeight + 1)
        ' inhere it could be between 1.. due to BINARY search
        If CurrentPos& > (dict02_TotalWrd& - DjamPoolHeight + 1) Then CurrentPos& = (dict02_TotalWrd& - DjamPoolHeight + 1)
        PoolLinePos = 1
        Do
            key$ = InKey$
            'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
            If key$ <> "" Then
                code% = Asc(key$):
                If code% Then ' ASC returns any value greater than 0
                    Select Case Asc(key$)
                        Case 13:
                            Call DrawBoxShadowOEDin(3 + 3, 3, 35, 125, Reduced$)
                            BckGRcolor = 2
                            Locate , , 0
                            Get #f02, CurrentPos& + (PoolLinePos - 1), dict02_lfixedCRLF$
                            EntryAll$ = Space$(dePADzeros&(Mid$(dict02_lfixedCRLF$, (dict02_EntryHead + 1) + 8, 8)))
                            Get #f01, dePADzeros&(Mid$(dict02_lfixedCRLF$, (dict02_EntryHead + 1), 8)), EntryAll$
                            f03 = FreeFile
                            Open "Entry" For Output As #f03
                            Close #f03
                            Open "Entry.untabbed_wrapped" For Output As #f03
                            Close #f03
                            Open "Entry" For Binary As #f03
                            EntryHead$ = "EntryHead: " + Left$(EntryAll$, InStr(EntryAll$, Chr$(13)) - 1) + Chr$(13) + Chr$(10)
                            Put #f03, , EntryHead$
                            EntryTail$ = "EntryTail: " + Right$(EntryAll$, Len(EntryAll$) - InStr(EntryAll$, Chr$(9)))
                            Put #f03, , EntryTail$
                            Close #f03
                            'Creating the wrapped temporary file [
                            Open "Entry" For Binary As #f03
                            f04 = FreeFile
                            Open "Entry.untabbed_wrapped" For Output As #f04

                            Wwidth% = DjamPoolLength
                            WrappedLines = 0
                            Do While Not EOF(f03)
                                Line Input #f03, l$
                                ExpandTabsFULL l$
                                ' Firstly do the wrapping virtually (in order to avoid writing some wrapped chunks and encounter unwrappable chunk) - we need either a wrapped line (in its entirety) or none:
                                AssumeLineIsWrappable = 1
                                lX$ = l$
                                Do While Len(lX$) > Wwidth%
                                    Glupak% = Wwidth%
                                    Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                                        InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                                        If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                                        'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                                        Glupak% = Glupak% - 1
                                        If Glupak% = 0 Then
                                            AssumeLineIsWrappable = 0
                                            GoTo B4TxpanarVIRTUAL3
                                        End If
                                    Loop
                                    lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                                Loop
                                B4TxpanarVIRTUAL3:
                                If AssumeLineIsWrappable = 1 Then
                                    lX$ = l$
                                    Do While Len(lX$) > Wwidth%
                                        Glupak% = Wwidth%
                                        Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                                            InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                                            If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                                            'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                                            Glupak% = Glupak% - 1
                                            If Glupak% = 0 Then
                                                Beep
                                                GoTo B4Txpanar3
                                            End If
                                        Loop
                                        Print #f04, Left$(lX$, Glupak%): WrappedLines = WrappedLines + 1
                                        'lX$ = STRING$(1, " ") + LTRIM$(MID$(lX$, Glupak% + 1, LEN(lX$) - (Glupak%)))
                                        lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                                    Loop
                                    Print #f04, lX$: WrappedLines = WrappedLines + 1
                                    B4Txpanar3:
                                Else
                                    Beep
                                End If
                            Loop
                            Close #f03, #f04
                            'Creating the wrapped temporary file ]

                            ReDim Djamtche$(1 To WrappedLines)
                            Open "Entry.untabbed_wrapped" For Input As #f04
                            jj = 1
                            Do While Not EOF(f04)
                                Line Input #f04, Djamtche$(jj): jj = jj + 1
                            Loop
                            Close #f04

                            For i = 1 To DjamPoolHeight
                                Locate 3 + 3 + 2 + (i - 1), 3 + 2
                                Print String$(DjamPoolLength, " ");
                            Next

                            CurrentPos2& = 1 ' Notice that CurrentPos2& = 1.. (WrappedLines - DjamPoolHeight + 1)
                            If WrappedLines < DjamPoolHeight Then CurrentPos2max& = 1 Else CurrentPos2max& = (WrappedLines - DjamPoolHeight + 1)
                            If CurrentPos2& > CurrentPos2max& Then CurrentPos2& = CurrentPos2max&
                            PoolLinePos2 = 1
                            Do
                                key$ = InKey$
                                'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
                                If key$ <> "" Then
                                    code% = Asc(key$):
                                    If code% Then ' ASC returns any value greater than 0
                                    Else
                                        Select Case Asc(key$, 2)
                                            Case 72:
                                                If PoolLinePos2 > 1 Then
                                                    PoolLinePos2 = PoolLinePos2 - 1
                                                Else
                                                    If CurrentPos2& > 1 Then CurrentPos2& = CurrentPos2& - 1
                                                End If
                                            Case 80:
                                                If PoolLinePos2 < MIN&(DjamPoolHeight, WrappedLines) Then
                                                    PoolLinePos2 = PoolLinePos2 + 1
                                                Else
                                                    If CurrentPos2& < CurrentPos2max& Then CurrentPos2& = CurrentPos2& + 1
                                                End If
                                            Case 75: 'Left
                                            Case 77: 'Right
                                            Case 71: 'Home
                                                PoolLinePos2 = 1
                                                CurrentPos2& = 1
                                            Case 79: 'End
                                                PoolLinePos2 = MIN&(DjamPoolHeight, WrappedLines)
                                                CurrentPos2& = CurrentPos2max&
                                            Case 73: 'PgUp
                                                If CurrentPos2& - DjamPoolHeight >= 1 Then CurrentPos2& = CurrentPos2& - DjamPoolHeight
                                            Case 81: 'PgDn
                                                If CurrentPos2& + DjamPoolHeight <= CurrentPos2max& Then CurrentPos2& = CurrentPos2& + DjamPoolHeight
                                            Case 61: 'F3
                                            Case 13: 'Enter

                                        End Select
                                    End If
                                End If

                                _Limit 60
                                GoSub Txpo2a
                            Loop Until _KeyDown(8)
                            Call DrawBoxShadowOED(3 + 3, 3, 35, 125, Reduced$, 2)
                            BckGRcolor = 2 '6
                            Locate , , 0
                        Case 32:
                        Case 65 To 97: 'PRINT key$;
                        Case Asc("a") To Asc("z"): 'PRINT key$;
                            'CASE 27: COLOR 7, 0: SYSTEM 'END
                    End Select
                Else
                    Select Case Asc(key$, 2)
                        Case 72:
                            If PoolLinePos > 1 Then
                                PoolLinePos = PoolLinePos - 1
                            Else
                                If CurrentPos& > 1 Then CurrentPos& = CurrentPos& - 1
                            End If
                        Case 80:
                            If PoolLinePos < DjamPoolHeight Then
                                PoolLinePos = PoolLinePos + 1
                            Else
                                If CurrentPos& < (dict02_TotalWrd& - DjamPoolHeight + 1) Then CurrentPos& = CurrentPos& + 1
                            End If
                        Case 75: 'Left
                        Case 77: 'Right
                        Case 71: 'Home
                            PoolLinePos = 1
                            CurrentPos& = 1
                        Case 79: 'End
                            PoolLinePos = DjamPoolHeight
                            CurrentPos& = (dict02_TotalWrd& - DjamPoolHeight + 1)
                        Case 73: 'PgUp
                            If CurrentPos& - DjamPoolHeight >= 1 Then CurrentPos& = CurrentPos& - DjamPoolHeight
                        Case 81: 'PgDn
                            If CurrentPos& + DjamPoolHeight <= (dict02_TotalWrd& - DjamPoolHeight + 1) Then CurrentPos& = CurrentPos& + DjamPoolHeight
                        Case 61: 'F3
                        Case 13: 'Enter

                    End Select
                End If
            End If

            _Limit 60
            If _KeyDown(13) Then ' Enter

            End If
            If _KeyDown(18176) Then ' Home

            End If
            If _KeyDown(20224) Then ' End

            End If
            If _KeyDown(15616) Then ' F3

            End If
            If _KeyDown(18688) Then ' PgUp

            End If
            If _KeyDown(20736) Then ' PgDn

            End If

            GoSub Txpo2
        Loop Until _KeyDown(27)
        ' Scrolling into 3D djamtche ]
        Close #f01, #f02
    End If 'check for existance ]]]
    '_KEYCLEAR 2
    Do While InKey$ <> "": Loop
    While _MouseInput: Wend
    Exit Sub

    Txpo2:
    For i = 1 To MIN&(DjamPoolHeight, dict02_TotalWrd&) ' with dictionaries all are bigger than ~40 lines
        Get #f02, CurrentPos& + (i - 1), dict02_lfixedCRLF$
        EntryAll$ = Space$(dePADzeros&(Mid$(dict02_lfixedCRLF$, (dict02_EntryHead + 1) + 8, 8)))
        Get #f01, dePADzeros&(Mid$(dict02_lfixedCRLF$, (dict02_EntryHead + 1), 8)), EntryAll$
        PADDED_EntryAll$ = Left$(EntryAll$, InStr(EntryAll$, Chr$(13)) - 1) + String$(DjamPoolLength - Len(Left$(EntryAll$, InStr(EntryAll$, Chr$(13)) - 1)), " ")
        Locate 3 + 3 + 2 + (i - 1), 3 + 2
        If i = PoolLinePos Then Color BckGRcolor, 0 Else Color 0, BckGRcolor
        Print PADDED_EntryAll$;
    Next
    s$ = LTrim$(Str$(CurrentPos& + PoolLinePos - 1))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = "0,000,000,000"
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
    _Display 'in order to not having frozen screen
    Return

    Txpo2a:
    For i = 1 To MIN&(DjamPoolHeight, WrappedLines) ' with dictionaries all are bigger than ~40 lines
        PADDED_EntryAll$ = Djamtche$(CurrentPos2& + (i - 1)) + String$(DjamPoolLength - Len(Djamtche$(CurrentPos2& + (i - 1))), " ")
        Locate 3 + 3 + 2 + (i - 1), 3 + 2
        If i = PoolLinePos2 Then Color BckGRcolor, 0 Else Color 0, BckGRcolor
        Print PADDED_EntryAll$;
    Next
    s$ = LTrim$(Str$(CurrentPos2& + PoolLinePos2 - 1))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = "0,000,000,000"
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
    _Display 'in order to not having frozen screen
    Return

End Sub

Sub dict03sub
    Shared CurrentWord$
    Const dict03_RecordLen = 47 '4+10+31 +2 for CRLF
    Dim dict03_lfixedCRLF As String * dict03_RecordLen
    Dim dict03_lfixedCRLFhighlight As String * dict03_RecordLen
    _Define A-Z As _INTEGER64  ' TO-DO: Grr, this very file can be 2+B lines, all & should be removed and be defined all as 8bytes
    dict03_TotalWrd = 0

    dict03$ = "Schizandrafield_Corpus_revision_D_(45-corpora_-unique-words).sorted"

    If _FileExists(PSPlike$ + dict03$ + ".ind") = 0 Then 'check for existance [[[
        f01 = FreeFile
        Open dict03$ For Binary As #f01
        If LOF(f01) Then

            f02 = FreeFile
            Open dict03$ + ".ind" For Binary As #f02 'LEN = 35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX
            Do While Not EOF(f01)
                Line Input #f01, l$
                dict03_lfixedCRLF$ = l$ + String$(45 - Len(l$), " ") + Chr$(13) + Chr$(10)
                Put #f02, , dict03_lfixedCRLF$: dict03_TotalWrd = dict03_TotalWrd + 1
            Loop
            Close #f01, #f02
            'SHELL _HIDE "CMD /C sort " + CHR$(34) + dict03$ + ".ind" + CHR$(34) + " > " + CHR$(34) + "sorted_" + dict03$ + ".ind" + CHR$(34)

        Else
            $If WINDOWS Then
                    Play "L16V32O3g-g-<<d+"
            $End If
            Close #f01
        End If 'If LOF(f01) Then
    Else
        dict03_TotalWrd = 1005624651
    End If 'check for existance ]]]
    If _FileExists(PSPlike$ + dict03$ + ".ind") <> 0 Then 'check for existance [[[
        f02 = FreeFile
        Open PSPlike$ + dict03$ + ".ind" For Random Access Read As #f02 Len = dict03_RecordLen '35 + 2 + 8 + 8 '+2 for CRLF and DWORD+DWORD as padded HEX

        'testing 537 line:
        'alimentary                         00025E8D00000118
        'PhysicalLine = 19001 '537

        ' BINARY SEARCH [
        UCurrentWord$ = LCase$(CurrentWord$)
        WRDpos = 0
        LeftPoint = 1
        RightPoint = dict03_TotalWrd
        Do
            If RightPoint - LeftPoint <= 1 Then 'Sxsedtcheta
                Get #f02, LeftPoint, dict03_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then WRDpos = LeftPoint: Exit Do
                Get #f02, RightPoint, dict03_lfixedCRLF$
                If UCurrentWord$ = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then WRDpos = RightPoint: Exit Do
                WRDpos = LeftPoint 'THIS IS BECAUSE I NEED NEAREST word not zero!
                Exit Do
            End If
            SplitPoint = (LeftPoint + RightPoint) \ 2
            Get #f02, SplitPoint, dict03_lfixedCRLF$
            If UCurrentWord$ < LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then
                RightPoint = SplitPoint
            ElseIf UCurrentWord$ > LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then
                LeftPoint = SplitPoint
            Else
                WRDpos = SplitPoint: Exit Do
            End If
        Loop
        If WRDpos <> 0 Then
            Do While WRDpos > 1
                WRDpos = WRDpos - 1
                Get #f02, WRDpos, dict03_lfixedCRLF$
                If UCurrentWord$ <> LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then
                    WRDpos = WRDpos + 1
                    Exit Do
                End If
            Loop
            'IF WRDpos <= TotalWrd& - 16 THEN FL2wrd& = WRDpos ELSE FL2wrd& = TotalWrd& - 16
        End If
        ' BINARY SEARCH ]

        $If WINDOWS Then
                Play "v20o2l20geb"
        $End If
        PhysicalLine = WRDpos
        'PhysicalLine = 277315 '277315 total; WARNING! 61358 is 'dictionary' - cannot be found because words as 'dicarch' confuse the binary search!
        'GET #f02, (PhysicalLine - 1) * (35 + 2 + 8 + 8) + 1, dict03_lfixedCRLF$ 'when OPENed for BINARY
        Get #f02, PhysicalLine, dict03_lfixedCRLF$

        'PRINT "EntryHead: "; LEFT$(EntryAll$, INSTR(EntryAll$, CHR$(13)) - 1)
        'EntryTail$ = "EntryTail: " + RIGHT$(EntryAll$, LEN(EntryAll$) - INSTR(EntryAll$, CHR$(9)))
        'PRINT EntryTail$
        'PRINT "[" + EntryAll$ + "]"

        ' Scrolling into 3D djamtche [
        'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
        If Len(dict03$) > 70 Then Reduced$ = "..." + Right$(dict03$, 70) Else Reduced$ = dict03$
        Call DrawBoxShadowOED(3 + 3, 3, 35, 125, Reduced$, 6)
        BckGRcolor = 6
        s$ = LTrim$(Str$(PhysicalLine))
        If Len(s$) > 3 Then
            If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
            s$ = ""
            For i = 1 To Len(x$) Step 3
                s$ = s$ + Mid$(x$, i, 3) + ","
            Next
            s$ = Left$(s$, Len(s$) - 1)
        End If
        s$ = LTrim$(s$)
        Padded$ = "0,000,000,000"
        Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
        Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
        Locate , , 0: _Display

        DjamPoolLength = 125 - 3 + 1 - 4
        DjamPoolHeight = 35 - (3 + 3) + 1 - 4
        CurrentPos = PhysicalLine ' Notice that CurrentPos = 1..(dict03_TotalWrd - DjamPoolHeight + 1)
        If CurrentPos > (dict03_TotalWrd - DjamPoolHeight + 1) Then CurrentPos = (dict03_TotalWrd - DjamPoolHeight + 1)
        PoolLinePos = 1
        Do
            key$ = InKey$
            'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
            If key$ <> "" Then
                code% = Asc(key$):
                If code% Then ' ASC returns any value greater than 0
                    Select Case Asc(key$)
                        Case 32:
                        Case 65 To 97: 'PRINT key$;
                        Case Asc("a") To Asc("z"): 'PRINT key$;
                            'CASE 27: COLOR 7, 0: SYSTEM 'END
                    End Select
                Else
                    Select Case Asc(key$, 2)
                        Case 72:
                            If PoolLinePos > 1 Then
                                PoolLinePos = PoolLinePos - 1
                            Else
                                If CurrentPos > 1 Then CurrentPos = CurrentPos - 1
                            End If
                        Case 80:
                            If PoolLinePos < DjamPoolHeight Then
                                PoolLinePos = PoolLinePos + 1
                            Else
                                If CurrentPos < (dict03_TotalWrd - DjamPoolHeight + 1) Then CurrentPos = CurrentPos + 1
                            End If
                        Case 75: 'Left
                        Case 77: 'Right
                        Case 71: 'Home
                            PoolLinePos = 1
                            CurrentPos = 1
                        Case 79: 'End
                            PoolLinePos = DjamPoolHeight
                            CurrentPos = (dict03_TotalWrd - DjamPoolHeight + 1)
                        Case 73: 'PgUp
                            If CurrentPos - DjamPoolHeight >= 1 Then CurrentPos = CurrentPos - DjamPoolHeight
                        Case 81: 'PgDn
                            If CurrentPos + DjamPoolHeight <= (dict03_TotalWrd - DjamPoolHeight + 1) Then CurrentPos = CurrentPos + DjamPoolHeight
                        Case 61: 'F3
                        Case 13: 'Enter
                    End Select
                End If
            End If

            _Limit 60
            If _KeyDown(13) Then ' Enter

            End If
            If _KeyDown(18176) Then ' Home

            End If
            If _KeyDown(20224) Then ' End

            End If
            If _KeyDown(15616) Then ' F3

            End If
            If _KeyDown(18688) Then ' PgUp

            End If
            If _KeyDown(20736) Then ' PgDn

            End If

            GoSub Txpo3
        Loop Until _KeyDown(27)
        ' Scrolling into 3D djamtche ]
        Close #f02
    End If 'check for existance ]]]
    '_KEYCLEAR 2
    Do While InKey$ <> "": Loop
    While _MouseInput: Wend
    Exit Sub

    Txpo3:
    If CurrentPos > (dict03_TotalWrd - DjamPoolHeight + 1) Then ' because dict03_TotalWrd - (dict03_TotalWrd - DjamPoolHeight + 1) + 1 isDjamPoolHeight
        PoolLinePos = CurrentPos - (dict03_TotalWrd - DjamPoolHeight + 1)
    End If
    Get #f02, CurrentPos + (PoolLinePos - 1), dict03_lfixedCRLFhighlight$ 'we need this in order to highlight (lowering the strain on the eye) all such words
    For i = 1 To MIN&(DjamPoolHeight, dict03_TotalWrd) ' with dictionaries all are bigger than ~40 lines
        Get #f02, CurrentPos + (i - 1), dict03_lfixedCRLF$
        Locate 3 + 3 + 2 + (i - 1), 3 + 2
        If i = PoolLinePos Then
            Color BckGRcolor, 0
        Else
            If UCurrentWord$ = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then Color 7, BckGRcolor Else Color 0, BckGRcolor
            If LCase$(RTrim$(Mid$(dict03_lfixedCRLFhighlight$, 15, 31))) = LCase$(RTrim$(Mid$(dict03_lfixedCRLF$, 15, 31))) Then Color 15, BckGRcolor
        End If
        'PRINT LEFT$(dict03_lfixedCRLF$, INSTR(dict03_lfixedCRLF$, CHR$(13)) - 1) + STRING$(DjamPoolLength - LEN(LEFT$(dict03_lfixedCRLF$, INSTR(dict03_lfixedCRLF$, CHR$(13)) - 1)), " ");
        For j = 1 To 45
            If Left$(Schizandra$(j), 3) = Left$(dict03_lfixedCRLF$, 3) Then
                addon$ = RTrim$(Right$(Schizandra$(j), Len(Schizandra$(j)) - 4))
                PaddingLEN = DjamPoolLength - Len(Left$(dict03_lfixedCRLF$, InStr(dict03_lfixedCRLF$, Chr$(13)) - 1))
                If Len(addon$) <= PaddingLEN Then
                    addon$ = addon$ + String$(PaddingLEN - Len(addon$), " ")
                Else
                    addon$ = Left$(addon$, PaddingLEN)
                End If
                Print Left$(dict03_lfixedCRLF$, InStr(dict03_lfixedCRLF$, Chr$(13)) - 1) + addon$;
            End If
        Next
    Next
    s$ = LTrim$(Str$(CurrentPos + PoolLinePos - 1))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = "0,000,000,000"
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
    _Display 'in order to not having frozen screen
    Return
End Sub

Function PADzeros$ (hexstr$)
    PADzeros$ = String$(8 - Len(hexstr$), "0") + hexstr$
End Function
Function dePADzeros& (hexstr$)
    dePADzeros& = Val("&H" + hexstr$)
End Function

Sub DrawBoxShadowOED (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$, BckGRcolor)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ Dictionary: ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 0
    Locate TopLrow + 1, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To BottomRrow - 1
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow - 1, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    Color 7, BckGRcolor

    HelpLine$ = "Up,Dn,PgUp,PgDn,Home,End,Enter,Esc,F3"
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 2: Print "[ Keys: ";: Color 7, BckGRcolor: Print HelpLine$;: Color 0, BckGRcolor: Print " ]";
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 2 + 49: Print "[ Jump: ";: Color 7, BckGRcolor: Print "ForwardToFirstLineMatchingThisText";: Color 0, BckGRcolor: Print " ]";
    _Display
    'Match$ = InputLine$(TopLrow + 39 - 23 - shrunkP, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    Locate 1, 1, 1, CursorS, CursorE
End Sub

Sub DrawBoxShadowOEDin (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, filecount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 2
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, filecount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    Locate TopLrow, TopLcol
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: Locate TopLrow, TopLcol + 2: Print "[ Dictionary: ";: Color 15, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: Locate i, TopLcol: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow, TopLcol
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 0
    Locate TopLrow + 1, TopLcol + 1
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To BottomRrow - 1
        Color 0, BckGRcolor: Locate i, TopLcol + 1: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    Locate BottomRrow - 1, TopLcol + 1
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    Locate TopLrow + 2, TopLcol + 2
    Color 7, BckGRcolor

    HelpLine2$ = "Up,Dn,PgUp,PgDn,Home,End,Backspace,F3"
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 2: Print "[ Keys: ";: Color 7, BckGRcolor: Print HelpLine2$;: Color 0, BckGRcolor: Print " ]";
    Color 0, BckGRcolor: Locate BottomRrow, TopLcol + 2 + 49: Print "[ Jump: ";: Color 7, BckGRcolor: Print "ForwardToFirstLineMatchingThisText";: Color 0, BckGRcolor: Print " ]";
    _Display
    'Match$ = InputLine$(TopLrow + 39 - 23 - shrunkP, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    Locate 1, 1, 1, CursorS, CursorE
End Sub


''mouse mumbo-jumbo [

'SCREEN _NEWIMAGE(600, 900, 256)
'_SCREENMOVE 32, 32

'ShutDownDuration# = 4 ' 4 seconds
'DclickTime# = 0.33 ' 1/3 of a second, usually it is 0.27s, so 0.33 suits even the slow clickers
'DIM Button1LOG_firstDetection#(4)
'DIM Button1LOG_ForHowLongHolded#(4)
'PrevClick1# = 0
'PRINT "You may exit with Esc or by holding left mouse button for 4 seconds..."
'DO WHILE INKEY$ <> CHR$(27)

'    AsIfItIsINKEY% = _MOUSEINPUT '      Check the mouse status
'    IF AsIfItIsINKEY% THEN
'        buttondown1 = _MOUSEBUTTON(1)
'        buttondown2 = _MOUSEBUTTON(2)
'        buttondown3 = _MOUSEBUTTON(3)
'        mwheel = _MOUSEWHEEL
'    END IF

'    IF (buttondown1 AND PrevClick1# = 0) THEN 'first detection of the click
'        PrevClick1# = TIMER(0.001)
'    END IF

'    IF (buttondown1 AND PrevClick1# <> 0) THEN 'already clicked
'        '        PrevClick1# = TIMER(0.001)
'        ForHowLongWasPressed1# = TIMER(0.001) - PrevClick1#
'    END IF

'    IF buttondown1 = 0 AND PrevClick1# <> 0 THEN 'write to the log
'        PRINT
'        FOR MumboJumbo = 1 TO 4
'            PRINT "OLD"; Button1LOG_firstDetection#(MumboJumbo), Button1LOG_ForHowLongHolded#(MumboJumbo)
'        NEXT

'        FOR MumboJumbo = 1 TO 3
'            Button1LOG_firstDetection#(MumboJumbo) = Button1LOG_firstDetection#(MumboJumbo + 1)
'            Button1LOG_ForHowLongHolded#(MumboJumbo) = Button1LOG_ForHowLongHolded#(MumboJumbo + 1)
'        NEXT
'        Button1LOG_firstDetection#(4) = PrevClick1#
'        Button1LOG_ForHowLongHolded#(4) = ForHowLongWasPressed1#
'        PrevClick1# = 0

'        FOR MumboJumbo = 1 TO 4
'            PRINT "NEW"; Button1LOG_firstDetection#(MumboJumbo), Button1LOG_ForHowLongHolded#(MumboJumbo)
'        NEXT

'    END IF

'    IF Button1LOG_firstDetection#(3) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3) < DclickTime#) THEN Double_LeftClick = 1 ELSE Double_LeftClick = 0
'    IF Double_LeftClick = 1 THEN PRINT "Double_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

'    IF Button1LOG_firstDetection#(2) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(2) < DclickTime# * 2) THEN Triple_LeftClick = 1 ELSE Triple_LeftClick = 0
'    IF Triple_LeftClick = 1 THEN PRINT "Triple_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(2)) * 1000); "ms."

'    IF Button1LOG_firstDetection#(1) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(1) < DclickTime# * 3) THEN Quadruple_LeftClick = 1 ELSE Quadruple_LeftClick = 0
'    IF Quadruple_LeftClick = 1 THEN PRINT "Quadruple_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(1)) * 1000); "ms."

'    IF (ForHowLongWasPressed1# > ShutDownDuration#) THEN
'        ShutDown_LeftClick = 1: IF ShutDown_LeftClick = 1 THEN PRINT "ShutDown_LeftClick detected.": END
'    END IF

'    _LIMIT 500
'    _DISPLAY
'LOOP

''Note1: From above experiments I see Double-Click fits usually in DclickTime# s window.
''Note2: Double-Click is detected when the difference between two initial clicks is below DclickTime# s i.e. Button1LOG_firstDetection#(4)-Button1LOG_firstDetection#(3) < DclickTime#
'' ForHowLongWasPressed1# = B1 - A1 i.e. duration of holding down:
'' where
'' A1=first detection of the click   B1=released A2=first detection of the click   B2=released
'' [                                ][          ][                                ][          ]

''mouse mumbo-jumbo ]

' The need for more ergonomic (that is, easily accessible) shortcuts (strictly keyboardish) got me thinking...
' Holy hell, why no one introduced the analogues/counterparts of "double-clicks" - the first that comes to mind: the "double-hits".
' Both, being just taps.
' Currently, in Masakari there are:
' - shortcuts, purely keyboardish;
' - shortcuts, mix of keys and mouse buttons;
' - shortcuts, purely mouseish, just mouse stuff - buttons and wheel.
' From revision 8.1+ onward, following double-hits were implemented:
' Double LShift; Double LCtrl; Double LAlt; Double RAlt.
' The thing is that "legacy" shortcuts as Ctrl+F3 (even the F3) force the user to "locate" their position and to overreach - meaning hovering pass the SPACEBAR area - which is most easy to hit since the wrists/palms have support, and are simply closer.
' To me, the traditional key sequences are to be replaced/enriched with more convenient, more close to the first row of the keyboard, ones.
' Currently, my main keyboard is a nasty one (laptopish, with low profile, non-tactile, half-sized F-keys, and tightly packed), when e.g. a LCtrl+F3 search is needed, spotting this halved F3 is a drag, therefore the double-hit of e.g. LCtrl saves the situation - just double-tap it - the timings between the two pressings are handled by the same logic as the mouse double/triple/quadruple-clicks.
' The following stand-alone etude is the same as the previously shared mouse_mumbo-jumbo.bas, except:
' buttondown1 = _MOUSEBUTTON(1)
' should be replaced with
' KeyTap_buttondown1 = _KEYDOWN(LSHIFTkey&)

''keyboard mumbo-jumbo [

'CONST RSHIFTkey& = 100303
'CONST LSHIFTkey& = 100304
'CONST RCTRLkey& = 100305
'CONST LCTRLkey& = 100306
'CONST RALTkey& = 100307
'CONST LALTkey& = 100308

'CONST BACKSPCkey& = 8
'CONST TABkey& = 9
'CONST SPACEkey& = 32
'CONST ESCkey& = 27
'CONST ENTERkey& = 13

'CONST HOMEkey& = 18176
'CONST ENDkey& = 20224

'CONST INSkey& = 20992
'CONST DELkey& = 21248

'CONST PGUPkey& = 18688
'CONST PGDNkey& = 20736

'CONST LEFTkey& = 19200
'CONST RIGHTkey& = 19712
'CONST UPkey& = 18432
'CONST DOWNkey& = 20480

'SCREEN _NEWIMAGE(600, 900, 256)
'_SCREENMOVE 32, 32

'ShutDownDuration# = 4 ' 4 seconds
'DclickTime# = 0.33 ' 1/3 of a second, usually it is 0.27s, so 0.33 suits even the slow clickers
'DIM Button1LOG_firstDetection#(4)
'DIM Button1LOG_ForHowLongHolded#(4)
'PrevClick1# = 0
'PRINT "You may exit with Esc or by holding left Shift key for 4 seconds..."
'DO 'WHILE INKEY$ <> CHR$(27)

'    'AsIfItIsINKEY% = _MOUSEINPUT '      Check the mouse status
'    IF AsIfItIsINKEY% THEN
'        'buttondown1 = _MOUSEBUTTON(1)
'        'buttondown2 = _MOUSEBUTTON(2)
'        'buttondown3 = _MOUSEBUTTON(3)
'        'mwheel = _MOUSEWHEEL
'    END IF

'    buttondown1 = _KEYDOWN(LSHIFTkey&)
'    buttondown2 = _KEYDOWN(LCTRLkey&)
'    buttondown3 = _KEYDOWN(LALTkey&)

'    IF (buttondown1 AND PrevClick1# = 0) THEN 'first detection of the click
'        PrevClick1# = TIMER(0.001)
'    END IF

'    IF (buttondown1 AND PrevClick1# <> 0) THEN 'already clicked
'        '        PrevClick1# = TIMER(0.001)
'        ForHowLongWasPressed1# = TIMER(0.001) - PrevClick1#
'    END IF

'    IF buttondown1 = 0 AND PrevClick1# <> 0 THEN 'write to the log
'        PRINT
'        FOR MumboJumbo = 1 TO 4
'            PRINT "OLD"; Button1LOG_firstDetection#(MumboJumbo), Button1LOG_ForHowLongHolded#(MumboJumbo)
'        NEXT

'        FOR MumboJumbo = 1 TO 3
'            Button1LOG_firstDetection#(MumboJumbo) = Button1LOG_firstDetection#(MumboJumbo + 1)
'            Button1LOG_ForHowLongHolded#(MumboJumbo) = Button1LOG_ForHowLongHolded#(MumboJumbo + 1)
'        NEXT
'        Button1LOG_firstDetection#(4) = PrevClick1#
'        Button1LOG_ForHowLongHolded#(4) = ForHowLongWasPressed1#
'        PrevClick1# = 0

'        FOR MumboJumbo = 1 TO 4
'            PRINT "NEW"; Button1LOG_firstDetection#(MumboJumbo), Button1LOG_ForHowLongHolded#(MumboJumbo)
'        NEXT

'    END IF

'    IF Button1LOG_firstDetection#(3) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3) < DclickTime#) THEN Double_LeftClick = 1 ELSE Double_LeftClick = 0
'    IF Double_LeftClick = 1 THEN PRINT "Double_LeftShift detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

'    IF Button1LOG_firstDetection#(2) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(2) < DclickTime# * 2) THEN Triple_LeftClick = 1 ELSE Triple_LeftClick = 0
'    IF Triple_LeftClick = 1 THEN PRINT "Triple_LeftShift detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(2)) * 1000); "ms."

'    IF Button1LOG_firstDetection#(1) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(1) < DclickTime# * 3) THEN Quadruple_LeftClick = 1 ELSE Quadruple_LeftClick = 0
'    IF Quadruple_LeftClick = 1 THEN PRINT "Quadruple_LeftShift detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(1)) * 1000); "ms."

'    IF (ForHowLongWasPressed1# > ShutDownDuration#) THEN
'        ShutDown_LeftClick = 1: IF ShutDown_LeftClick = 1 THEN PRINT "ShutDown_LeftShift detected.": END
'    END IF

'    _LIMIT 500
'    _DISPLAY
'LOOP

''Note1: From above experiments I see Double-Click fits usually in DclickTime# s window.
''Note2: Double-Click is detected when the difference between two initial clicks is below DclickTime# s i.e. Button1LOG_firstDetection#(4)-Button1LOG_firstDetection#(3) < DclickTime#
'' ForHowLongWasPressed1# = B1 - A1 i.e. duration of holding down:
'' where
'' A1=first detection of the click   B1=released A2=first detection of the click   B2=released
'' [                                ][          ][                                ][          ]

''keyboard mumbo-jumbo ]

Function Hex2$ (SOMEkey)
    If Len(Hex$(SOMEkey)) = 1 Then Hex2$ = "0" + Hex$(SOMEkey) Else Hex2$ = Hex$(SOMEkey)
End Function

Function EpochTime~&&
    DATEstamp$ = Date$: TIMEstamp$ = Time$
    Do While DATEstamp$ <> Date$ 'redo
        DATEstamp$ = Date$: TIMEstamp$ = Time$
    Loop
    m = Val(Left$(DATEstamp$, 2))
    d~&& = Val(Mid$(DATEstamp$, 4, 2))
    y~&& = Val(Right$(DATEstamp$, 4)) - 1970
    For i = 1 To m
        Select Case i 'Add the number of days for each previous month passed
            Case 1: d~&& = d~&& 'January doestn't have any carry over days.
            Case 2, 4, 6, 8, 9, 11: d~&& = d~&& + 31
            Case 3: d~&& = d~&& + 28
            Case 5, 7, 10, 12: d~&& = d~&& + 30
        End Select
    Next
    d~&& = d~&& + y~&& * 365
    For i = 2 To y Step 4
        If m > 2 Then d~&& = d~&& + 1 'add an extra day for leap year every 4 years, starting in 1970
    Next
    d~&& = d~&& - 1 'for year 2000
    EpochTime~&& = d~&& * 24 * 60 * 60 + Val(Left$(TIMEstamp$, 2)) * 3600 + Val(Mid$(TIMEstamp$, 4, 2)) * 60 + Val(Right$(TIMEstamp$, 2))
End Function

Sub ReportSortingLength (posit)
    Shared YdimROW, XdimCOL
    Shared TimeA, TimeB
    crx = Pos(0)
    cry = CsrLin
    '     P=6
    '[123456] (8-P)-1=2 ' 2021-Jul-26, ugh, the fix is without '-1' because P is not 5 but 6!
    Locate YdimROW + 1, posit: Color 9, 0: Print Space$((XdimCOL - posit) - 0);
    Locate YdimROW + 1, posit: Color 9, 0: Print "; Sorting ... by Length";
    Locate cry, crx, 1, CursorS, CursorE
End Sub

Sub ReportSortingOffset (posit)
    Shared YdimROW, XdimCOL
    Shared TimeA, TimeB
    crx = Pos(0)
    cry = CsrLin
    '     P=6
    '[123456] (8-P)-1=2 ' 2021-Jul-26, ugh, the fix is without '-1' because P is not 5 but 6!
    Locate YdimROW + 1, posit: Color 9, 0: Print Space$((XdimCOL - posit) - 0);
    Locate YdimROW + 1, posit: Color 9, 0: Print "; Sorting ... by Offset";
    Locate cry, crx, 1, CursorS, CursorE
End Sub

' Written by Sanmayce, 2021-Oct-29
' The indexes are signed, but the elements are unsigned.
_Define A-Z As _INTEGER64
Sub Quicksort_QB64 (QWORDS~&&())
    Left = LBound(QWORDS~&&)
    Right = UBound(QWORDS~&&)
    LeftMargin = Left
    ReDim Stack&&(Left To Right)
    StackPtr = 0
    StackPtr = StackPtr + 1
    Stack&&(StackPtr + LeftMargin) = Left
    StackPtr = StackPtr + 1
    Stack&&(StackPtr + LeftMargin) = Right
    Do 'Until StackPtr = 0
        Right = Stack&&(StackPtr + LeftMargin)
        StackPtr = StackPtr - 1
        Left = Stack&&(StackPtr + LeftMargin)
        StackPtr = StackPtr - 1
        Do 'Until Left >= Right
            Pivot~&& = QWORDS~&&((Left + Right) \ 2)
            Indx = Left
            Jndx = Right
            Do
                Do While (QWORDS~&&(Indx) < Pivot~&&)
                    Indx = Indx + 1
                Loop
                Do While (QWORDS~&&(Jndx) > Pivot~&&)
                    Jndx = Jndx - 1
                Loop
                If Indx <= Jndx Then
                    If Indx < Jndx Then Swap QWORDS~&&(Indx), QWORDS~&&(Jndx)
                    Indx = Indx + 1
                    Jndx = Jndx - 1
                End If
            Loop While Indx <= Jndx
            If Indx < Right Then
                StackPtr = StackPtr + 1
                Stack&&(StackPtr + LeftMargin) = Indx
                StackPtr = StackPtr + 1
                Stack&&(StackPtr + LeftMargin) = Right
            End If
            Right = Jndx
        Loop Until Left >= Right
    Loop Until StackPtr = 0
End Sub

' This works only under Windows [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[

''Declare CustomType Library
''    Sub memcpy (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
''    Function memcmp% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
''End Declare
''Dim Benchm As _MEM
''Elements = 10
''Granularity = 17
''Benchm = _MemNew(Elements * Granularity)
''For i = 9 To 0 Step -1
''    Pattern$ = String$(16, Chr$(Asc("0") + i)) + Chr$(0)
''    Print Pattern$
''    _MemPut Benchm, Benchm.OFFSET + Granularity * (9 - i), Pattern$
''Next
''Print: Print "Sorting...": Print
''Quicksort_QB64_Granularity Benchm, Elements, Granularity
''For i = 0 To 9
''    _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
''    Print Pattern$
''Next
''End

'' Written by Sanmayce, 2021-Dec-12
'' The indexes are signed, but the elements are unsigned.
'_Define A-Z As _INTEGER64
'Sub Quicksort_QB64_Granularity (MemBlock As _MEM, NumberOfElements As _Integer64, Granularity As Integer)
'    Left = 1 - 1
'    Right = NumberOfElements - 1
'    ReDim Stack&&(Left To Right)
'    SwapBuffer$ = Space$(Granularity)
'    Pivot$ = Space$(Granularity)
'    StackPtr = 0
'    StackPtr = StackPtr + 1
'    Stack&&(StackPtr) = Left
'    StackPtr = StackPtr + 1
'    Stack&&(StackPtr) = Right
'    Do 'Until StackPtr = 0
'        Right = Stack&&(StackPtr)
'        StackPtr = StackPtr - 1
'        Left = Stack&&(StackPtr)
'        StackPtr = StackPtr - 1
'        Do 'Until Left >= Right
'            'Pivot~&& = QWORDS~&&((Left + Right) \ 2)
'            memcpy _Offset(Pivot$), MemBlock.OFFSET + Granularity * ((Left + Right) \ 2), Granularity
'            Indx = Left
'            Jndx = Right
'            Do
'                'Do While (QWORDS~&&(Indx) < Pivot~&&)
'                Do While (memcmp%(MemBlock.OFFSET + Granularity * Indx, _Offset(Pivot$), Granularity) = -1)
'                    Indx = Indx + 1
'                Loop
'                'Do While (QWORDS~&&(Jndx) > Pivot~&&)
'                Do While (memcmp%(MemBlock.OFFSET + Granularity * Jndx, _Offset(Pivot$), Granularity) = 1)
'                    Jndx = Jndx - 1
'                Loop
'                If Indx <= Jndx Then
'                    If Indx < Jndx Then
'                        'Swap QWORDS~&&(Indx), QWORDS~&&(Jndx)
'                        memcpy _Offset(SwapBuffer$), MemBlock.OFFSET + Granularity * Jndx, Granularity
'                        memcpy MemBlock.OFFSET + Granularity * Jndx, MemBlock.OFFSET + Granularity * Indx, Granularity
'                        memcpy MemBlock.OFFSET + Granularity * Indx, _Offset(SwapBuffer$), Granularity
'                    End If
'                    Indx = Indx + 1
'                    Jndx = Jndx - 1
'                End If
'            Loop While Indx <= Jndx
'            If Indx < Right Then
'                StackPtr = StackPtr + 1
'                Stack&&(StackPtr) = Indx
'                StackPtr = StackPtr + 1
'                Stack&&(StackPtr) = Right
'            End If
'            Right = Jndx
'        Loop Until Left >= Right
'    Loop Until StackPtr = 0
'End Sub

' This works only under Windows ]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

'Declare CustomType Library "memKAZE"
'    Sub memcpyKAZE (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
'    Function memcmpKAZE% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
'End Declare
'Dim Benchm As _MEM
'Elements = 10
'Granularity = 17
'Benchm = _MemNew(Elements * Granularity)
'For i = 9 To 0 Step -1
'    Pattern$ = String$(16, Chr$(Asc("0") + i)) + Chr$(0)
'    Print Pattern$
'    _MemPut Benchm, Benchm.OFFSET + Granularity * (9 - i), Pattern$
'Next
'Print: Print "Sorting...": Print
'Quicksort_QB64_Granularity Benchm, Elements, Granularity
'For i = 0 To 9
'    _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
'    Print Pattern$
'Next
'End

' Written by Sanmayce, 2021-Dec-12
' The indexes are signed, but the elements are unsigned.
_Define A-Z As _INTEGER64
Sub Quicksort_QB64_Granularity (MemBlock As _MEM, NumberOfElements As _Integer64, Granularity As Integer)
    Left = 1 - 1
    Right = NumberOfElements - 1
    ReDim Stack&&(Left To Right)
    SwapBuffer$ = Space$(Granularity)
    Pivot$ = Space$(Granularity)
    StackPtr = 0
    StackPtr = StackPtr + 1
    Stack&&(StackPtr) = Left
    StackPtr = StackPtr + 1
    Stack&&(StackPtr) = Right
    Do 'Until StackPtr = 0
        Right = Stack&&(StackPtr)
        StackPtr = StackPtr - 1
        Left = Stack&&(StackPtr)
        StackPtr = StackPtr - 1
        Do 'Until Left >= Right
            'Pivot~&& = QWORDS~&&((Left + Right) \ 2)
            memcpyKAZE _Offset(Pivot$), MemBlock.OFFSET + Granularity * ((Left + Right) \ 2), Granularity
            Indx = Left
            Jndx = Right
            Do
                'Do While (QWORDS~&&(Indx) < Pivot~&&)
                BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Indx, _Offset(Pivot$), Granularity)
                Do While (BuggyWithLinuxNotOneOrMinusOne% < 0) '= -1)
                    Indx = Indx + 1
                    BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Indx, _Offset(Pivot$), Granularity)
                Loop
                'Do While (QWORDS~&&(Jndx) > Pivot~&&)
                BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Jndx, _Offset(Pivot$), Granularity)
                Do While (BuggyWithLinuxNotOneOrMinusOne% > 0) '= 1)
                    Jndx = Jndx - 1
                    BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Jndx, _Offset(Pivot$), Granularity)
                Loop
                If Indx <= Jndx Then
                    If Indx < Jndx Then
                        'Swap QWORDS~&&(Indx), QWORDS~&&(Jndx)
                        memcpyKAZE _Offset(SwapBuffer$), MemBlock.OFFSET + Granularity * Jndx, Granularity
                        memcpyKAZE MemBlock.OFFSET + Granularity * Jndx, MemBlock.OFFSET + Granularity * Indx, Granularity
                        memcpyKAZE MemBlock.OFFSET + Granularity * Indx, _Offset(SwapBuffer$), Granularity
                    End If
                    Indx = Indx + 1
                    Jndx = Jndx - 1
                End If
            Loop While Indx <= Jndx
            If Indx < Right Then
                StackPtr = StackPtr + 1
                Stack&&(StackPtr) = Indx
                StackPtr = StackPtr + 1
                Stack&&(StackPtr) = Right
            End If
            Right = Jndx
        Loop Until Left >= Right
    Loop Until StackPtr = 0
End Sub

